#!C:/usr/perl/bin/perl.exe

### uK4 - ログイン制限の指定
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
exit if !$loginip;
$cgi = "allowip.cgi";
@array = qw(myIP);
&auth();
$dfile = "$userdir/$xmailcfg/allowip.tab";

## 初期表示
if (@ARGV){
	if (open(FILE,"$dfile")){
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				$myIP .= $_;
			}
		close(FILE);
		$myIP =~ s/^\s+//;
		$myIP =~ s/\s+$//;
	}
	my $msg = "現在ログイン制限を実行しています。" if $myIP;
	
	&html($msg);
}

## フォーム入力を処理
&parse_form(@array);
&html("このアカウントでは更新/追加できません！<br>",1) if $k4fixed;
foreach(@array){
	&zenhan($_) if $$_ =~ /[^$zstr]/;
	#$$_ =~ s/ //g;
}
$myIP =~ s/^\s+//;
$myIP =~ s/\s+$//;

## データがある場合
if ($myIP){
	my $data;
	foreach my $line (split(/[\n\r]+/,$myIP)){
		my $comment;
		$comment = $& if $line =~ s/\s*#.*//;
		my $str = "$line は正しくありません。";
		if ($line =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/){
			foreach my $i ($1,$2,$3,$4){
				&html($str) if &check_my_ip($i);
			}
		} elsif ($line =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)$/){
			foreach my $i ($1,$2,$3,$4){
				&html($str) if &check_my_ip($i);
			}
			&html($str) if ($5 =~ /\D/ || $5 >32);
		} elsif ($line =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)-+(\d+)\.(\d+)\.(\d+)\.(\d+)/){
			foreach my $i ($1,$2,$3,$4,$5,$6,$7,$8){
				&html($str) if &check_my_ip($i);
			}
		} else {
			next;
		}
		$data .= "$line$comment\n";
	}
	
	my $data1 = $data;
	Encode::_utf8_off($data1);
	Encode::from_to($data1,$charset,$charsetE);
	if ($data && open(FILE,">$dfile")){
			print FILE $data1;
		close(FILE);
		$myIP = $data;
		$msg = "設定を保存しました。ログイン制限を実行します。";
	} else {
		unlink("$dfile");
		$myIP = '';
		$msg = "有効データがありません。ログイン制限は行いません。";
	}
}

## データがない場合
else {
	unlink("$dfile");
	$myIP = '';
	$msg = "設定を保存しました。ログイン制限は行いません。";
}

## 完了
&html($msg);

### -----------------------------
sub html {
	my ($emsg) = @_;
	$emsg = "$alert $fs5R $emsg " if $emsg;
	$emsg .= "$caution" if $cautiion;
	$emsg .= $fe;
	if ($Expired && !$_[1]){&expire($_[0]);}
	
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "$cbody";
	
	my $title = 'ログイン制限';
	$K4 = <<"EOF";
$nocache
$table1
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=6 cellspacing=0 class='doc13' border=0 width=130>
		<tr><td $bgcolor1>登録 IP アドレスからのみこのアカウントにログインできるようにします。<br>
		セキュリティを高めたい場合に利用してください。</td></tr>
		</table></td></tr>
	</table></td>
	<td width=4></td>
	<td>
		<table cellpadding=1 cellspacing=4 class='doc13' border=0>
		<tr valign='top'><td>
		<img src='$idir/security.gif' width=30 height=30 title='$title' border=0></td>
		<td $bgcolor4 width=12>$null</td>
		<td nowrap>
		<form method='post' action='$cgi'>
		<input type='hidden' name='Allow' value="$Allow">
		$fs7<b>$title</b>$fe 
		$hr
		$emsg<br>
EOF
	
	$K4 =~ s/[\r\n]+$\s*//g;
	
	$K42 = <<"EOF";
		<textarea name='myIP' class='doc15' cols=50 rows=7 wrap='off'>$myIP</textarea><br>
		<input type='submit' value='保存・更新'> 
		</form>
		$fs<ul>
		<li>1行に1つの指定を書いてください。<br>
		指定の末尾にはシャープ文字(#)に続けてコメントを書くことができます。</li>
		<li>IP アドレスは以下のように指定してください。<br>
		　192.168.1.10 　　　　　# 個別指定<br>
		　10.1.0.0/24　　　　　　# マスク指定<br>
		　10.1.1.1-10.1.1.100　　# 範囲指定</li>
		<li>新しい設定は新しいログインに対して有効になります。</li>
		</ul>$fe</td></tr>
		</table></td></tr>
</table>
</form>
EOF
	
	&print_utf($K4);
	&print_utf($K42,'',1);
	&print_footer();
	&exit();
}

## IPアドレスを簡易チェック
sub check_my_ip {
	my ($ip) = @_;
	if ($ip =~ /\D/ || $ip > 255){return(1);}
}
