#!C:/usr/perl/bin/perl.exe

### uK4 - パスワードの変更
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use Digest::MD5 'md5_hex';
use MIME::Base64;
use Net::SMTP;
use utf8;
require "./config.cgi";
@array = qw(myword pass1 pass2 to);
&auth();

## 初期表示
if (@ARGV){
	$myword = &get_myword() if $auth2nd;	# 現在の秘密の言葉を得る
	&html();
}

## パスワード変更
&parse_form(@array);
&html("このアカウントでは更新できません！",1) if $k4fixed;
my ($msg,$msg2,$myword2);

# 現在の秘密の言葉を得ておく
$myword2 = &get_myword() if $auth2nd;

# エラーチェック
&html("適切な入力が必要です！",1) if ((($myword eq $myword2) || (!$myword && !$myword2)) && !$pass1 && !$pass2);
if ($pass1 || $pass2){
	foreach(@array){
		&html("空白やタブを含むパスワードは許可されません！",1) if $$_ =~ /[ \t]/;
		&zenhan($_) if $$_ =~ /[^$zstr]/;
	}
	&html("パスワードが一致しません！",1) if ($pass1 ne $pass2);
	&html("パスワードに不正な文字が含まれています！",1) if $pass1 =~ /["|<>]/;
	&html("パスワードの長さを $passmin 字以上にしてください！",1) if length($pass1) < $passmin;
	&html("パスワードに記号文字を入れる必要があります！",1) if ($passch1 && $pass1 !~ /[^0-9a-z]/i);
	my $c = $& if $pass1 =~ /^./;
	($c) = &mod_str($c);
	&html("同一文字が連続するパスワードは許可されません！",1) if ($passch2 && $pass1 =~ /^$c+$/);
	&html("通知先アドレスが変です！",1) if ($to && $to !~ /^$emreg$/i);
	
	## 旧パスワードと比較
	my $file = "$mailroot/mailusers.tab";
	if (-s $file){
		my $pass2 = &enc_str($pass1);
		my ($domain2,$user2) = &mod_str($domain1,$user1);
		
		my @tmp;
		open(FILE,$file);
			@tmp = <FILE>;
		close(FILE);
		&html("現在のものと同じパスワードです！",1) if (grep(/^"*$domain2"*\t"*$user2"*\t"*$pass2"*\t/,@tmp));
	}
	
	## 更新
	&ctrlcmd("\"userpasswd\"	\"$domain1\"	\"$user1\"	\"$pass1\"");
	&log('s',$domain1,$user1,'*','run','パスワードの変更',$0);
	
	$goon = 1;
	$msg = 'パスワードを更新しました。';
	if ($k4xExtSystemMSG1){
		$k4xExtSystemMSG1 =~ s/\\n/<br>/g;
		$msg .= $k4xExtSystemMSG1;
	}
}

## 秘密の言葉を更新(EUCで保存)
if ($auth2nd){
	my $file = "$userdir/$xmailcfg/myword.tab";
	$myword =~ s/^\s+//;
	$myword =~ s/\s+$//;
	my $myword3 = $myword;
	Encode::_utf8_off($myword3);		# use::utf8があるとEncode::from_toが使えない
	Encode::from_to($myword3,$charset,$charsetE);	# コード変換
	if ($myword && open(FILE,">$file")){
			print FILE $myword3;
		close(FILE);
		$msg2 = '秘密の言葉を更新しました。';
	} else {
		unlink($file);
		$msg2 = '秘密の言葉を解除しました。';
	}
}

## 更新通知
if ($to){
	$from = "$user1\@$domain1";
	$message = "アドレス $user1\@$domain1 のパスワードを\n$pass1 に更新しました。\n";
	$message .= "$msg2\n" if ($auth2nd && $msg2);
	$message .= "-------\n$year/$month/$mday $hour:$min\n";
	$subject = "パスワード更新通知";
	@To = ($to);
	&startmail;
	$msg .= "$to に通知しました。";
}

&html("$msg$msg2");

## -------------------------------------
sub html {
	my ($emsg) = @_;
	&htmlconv('myword');
	&expire($_[0]) if ($Expired && !$_[1]);
	if ($emsg){$emsg = "$alert $fs5R $emsg $fe";}
	else {$emsg = "<font class='doc13' color='black'>$passmin 文字以上で指定してください。</font>";}
	my $msg1 = '<br><br>パスワードには記号文字を含む必要があります。' if $passch1;
	my $msg2 = '<br><br>同一文字が連続するパスワードは許可されません。' if $passch2;
	my $msg3 = '<br><br>"秘密の言葉" は任意の内容にすることができます。日本語もOKです。秘密の言葉を設定すると、2要素でのログイン認証となりセキュリティを高めることができます。' if $auth2nd;
	
	print "Content-Type: text/html; charset=$charset\n\n";
	print "$cbody";
	
	my $title = 'パスワードの更新';
	my $title1 = 'パスワードを入力してください';
	my $title2 = 'パスワードをもう一度入力してください';
	$K4 = <<"EOF";
<form method='post' action='changepass.cgi' $nosubmit onSubmit="if(!confirm('更新してもよろしいですか？')){return false;}">
$table1
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=6 cellspacing=0 class='doc13' border=0 width=130>
		<tr><td $bgcolor1>
		新しいパスワードを 2 度入力して更新してください。$msg2 $msg1<br>
		<br>
		すべての英字・数字と$fs2<b> \" | \&lt; \&gt; </b>$fe
		を除くすべての記号文字が使えます。$msg3</td></tr>
		</table></td></tr>
	</table></td>
<td width=8 nowrap></td>
<td width='100%'>
	<table cellpadding=1 cellspacing=4 class='doc13' border=0>
	<tr valign='top'><td><img src='$idir/key.gif' width=26 height=40 title='$title' border=0></td>
	<td $bgcolor4 width=12>$null</td>
	<td>$fs7<b>$title</b>$fe
	$hr
	$emsg<br>
	<br>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title1'> 
	<input type='password' name='pass1' size=30 maxlength=128 $nosubmit><br>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title2'> 
	<input type='password' name='pass2' size=30 maxlength=128 $nosubmit><br>
	<br>
	更新パスワードを以下のアドレスに通知する。<br>
	<input name='to' size=50 maxlength=256 value="$to" $nosubmit><br>
	<br>
EOF
	
	# 秘密の言葉
	if ($auth2nd){
		$K4 .= "$fs7<b>秘密の言葉</b>$fe$hr";
		$K4 .= "<input name='myword' size=50 maxlength=256 value=\"$myword\" $nosubmit><br><br>";
	}
	$K4 .= "	<input type='submit' value=' 更新する '></td></tr>";
	$K4 .= "	</table></td></tr>";
	
	my $str = &get_my_shortcut($domain1,$user1);
	if ($allowautologin && $str){
		$K4 .= <<"EOF";
<tr><td colspan=3><hr size=1>
<img src='$idir/arrow_red.gif' width=31 height=13 title='自動ログイン用ショートカット'>
&nbsp;<b>自動ログイン用ショートカット</b> - 以下のショートカットで本システムに自動ログインできます。<br>
<font color='#a00000'>$str</font></td></tr>
EOF
	}
	
	$K4 .= "</table></form>";
	
	&print_utf($K4);
	&print_footer();
	require "./$k4changepassscript" if ($goon && -f "./$k4changepassscript");
	&exit();
}

## 秘密の言葉を得る
sub get_myword {
	my $myword;
	open(FILE,"$userdir/$xmailcfg/myword.tab") || return();
		$myword = <FILE>;
	close(FILE);
	$myword = &dec_utf($myword,$charsetE);
	chomp($myword);
	$myword;
}
