## システム環境
admin = 							# コントロールコマンド用アカウント名(暗号化)
pass =	 							# コントロールコマンド用パスワード(暗号化)
xmailcfgdir = C:/pub/xmailcfg		# XMailCFGインストールフォルダ(空白可)
xmaildir = C:/usr/xmail				# XMail本体(XMail.exe)ファイル存在フォルダ
mailroot = C:/usr/xmail/mailroot	# MailRootフォルダ
passmin = 4							# パスワードの最小文字数
robot = robot@xmail.dojo.jp			# リストプロセッサのアドレス
ctrlprt = 6017						# XMailのCTRLサービスポート
tz = 9								# タイムゾーンの指定（時間）

## 基本設定
postmaster = postmaster@xmail.dojo.jp	# ポストマスターのアドレス
outurl = 							# デフォルトのログアウト先URL
outtarget = 						# ログアウト時のターゲット(0:_parent,1:_top)
url = http://www.keishicho.metro.tokyo.jp/	# 不正アクセス時のリダイレクト先URL
dfdomain = 							# デフォルトドメインの指定
sndomain = 							# シングルドメインの指定
topmenu = 0							# トップページ 0:標準 1:メールボックス 2:ドメイン管理
search = 0							# 検索エンジン 2:Google, 1:Yahoo!, 0:非表示
usecal = 0							# カレンダーを表示する場合は1
logging = 0							# ログインの成否、ログアウトの記録を残す場合は1
framesize = 125						# メニューフレームのピクセル数
maxmemo = 0							# メモ最大数
allowallow = 0						# 受信制限(受信許可)の指定を許可する場合は1
maxallow = 100						# 受信制限(受信許可)アドレスの登録最大数
allowdeny = 0						# 受信拒否の指定を許可する場合は1
maxdeny = 100						# 受信拒否(受信許可)アドレスの登録最大数
allowantispam = 0					# アンチ・スパムを許可する場合は1
allowspamfolder = 0					# 迷惑メールフォルダ機能を許可する場合は1
allownotify = 0						# お知らせメールを許可する場合は1
autoreply = 0						# 自動応答を許可する場合は1
popsync = 0							# 自動受信を許可する場合は1
allowusertab = 0					# 個人情報の更新を許可する場合は1
fservice = 0						# 他ユーザ情報の参照を許可する場合は1
contactpage1 = 0					# パスワード通知要求ページを表示しない場合は1
contactpage2 = 0					# 管理者コンタクトページを表示しない場合は1
relogin = 0							# 他アカウントでのログインのためのリンクを表示する場合は1
schedule = 0						# 予定表機能を利用する場合は1
viewlog = 0							# アクセスログを表示する場合は1

## セキュリティ関連
allowautologin = 0					# login.cgi?login+xxxxx+yyyyy形式での自動ログインを許可する場合は1
auth2nd = 0							# 2要素認証(秘密の言葉機能を追加)を許可する場合は1
slogin = 0							# 同じアカウントで二重ログインを許す場合は1
slogin2 = 0							# 二重ログイン禁止時の強制ログインを許す場合は1
clogin = 5							# ログイン画面におけるログイン試行の制限回数
loginip = 							# ログインを許可するIPの指定をユーザに許可する場合は1
bantime = 180						# 制限回数失敗後の再ログイン試行禁止時間(秒)
ttl = 1800							# ログイン有効時間（秒数）
allowip = 							# ログインを許可するIPアドレスの羅列(システム全体)
denyip = 							# ログインを拒否するIPアドレスの羅列(システム全体)
denyurl = 							# ログイン不許可時のリダイレクト先URL
strict = 1							# cookie認証でIPアドレスのチェック、0:行わない 1:24ビット、2:32ビット
passch1 = 0							# パスワードで記号文字を含める必要があれば1
passch2 = 0							# パスワードで同じ文字の連続を許可しない場合は1

## ウイルススキャン
scanner = 							# ウイルススキャンプログラムへのフルパス(F-ProtまたはNODを推奨)
clamdb = C:/Documents and Settings/All Users/.clamwin/db		# ClamWinを使う場合の追加変数
scannerSig = C:/ProgramData/FRISK Software/F-PROT Antivirus for Windows/antivir.def		# F-Prot for Windowsを使う場合の追加変数

### メールボックスの管理関連
allowmail = 0						# メールボックスの管理を許可する場合は1
smtpsvr = localhost					# 接続先XMailドメイン/IP
smtpprt = 25						# 接続先XMailのSMTPサービスポート
smtphelo = localhost				# 接続先XMail接続時のSMTP HELOドメイン名
allowmad = 0						# 複数のTo:,Cc:,Bcc:を許可する場合は1
allowfrom = 0						# From:アドレスの任意指定を許可する場合は1
allowsearch = 0						# メッセージの検索を許可する場合は1
mailer = 0							# メーラ(X-Mailer:)の表示
forcemsgfooter = 0					# 送信メッセージにフッタを強制付加する場合は1
xmailer = 1							# 送信MSGへのX-Mailer:ヘッダの挿入
showheader = 0						# メッセージヘッダを表示するときは1
anchor = 0							# URLへのアンカータグの埋め込み
allowhtml = 0						# HTMLメールの表示・印刷を許可する場合は1
allowdistribute = 0					# 振り分けの指定を許可する場合は1
shortening = 0						# 複数To:/Cc:の場合に先頭アドレスのみ表示するときは1
item = 10							# 1ページに表示するメッセージ数
maxmsgfile = 200					# 表示メッセージの最大数
allowrest = 0						# maxmsgfileを超えるMSGの管理を許可する場合は1
adlimit = 100						# アドレス帳登録数制限
msgslimit = 10000					# 送信メッセージの最大バイト数
msgvlimit = 10000					# 表示メッセージの最大バイト数
siglimit = 3						# 作成できる署名の最大数
sigrowmax = 5						# 署名の最大行数
allowattach = 0						# 添付ファイルを許可する場合は1
attachmax = 1						# 添付ファイルの最大数
attachsize = 100					# 1個の添付ファイルの最大サイズ(KB)
allowdown = 0						# 添付ファイルの閲覧/保存を許可する場合は1
attachtag = bat chm cmd com doc docx docm dot exe inf lnk mdb pif ppt pptx pptm scr shs vb vbe vbs vbx xls xlsx xlsm	# 警告する拡張子
folderlimit = 10					# 作成できるフォルダの最大数
linespace = 1.0						# メッセージ表示における行間
viewimage = 0						# 添付ファイルが画像(GIF,JPEG,PNG)である場合に(本文外に)縮小表示する場合は1
inline = 0							# 添付ファイルが画像である場合に本文内に表示する場合は1

### ファイルの管理関連
fsallow = 0							# ファイルの管理を許可する場合は1
fsroot = 							# ファイルを保存するフォルダのルート
fsspace = 10000						# 1アカウントあたり最大ディスク使用量(KB)
fssize = 1000						# アップロード可能な最大ファイルサイズ(KB)
fslevel = 0							# 許可する最大フォルダ階層(0でフォルダ作成を許可しない)
fsfolders = 10						# 1階層内に作成を許可するフォルダ数
fsfiles = 100						# 1フォルダ内に作成を許可するファイル数
fsitem = 100						# 1ページに表示するファイル数(フォルダを含む)
fstag = bat cmd com exe				# アップロードを拒否するファイル拡張子
fssearch = 0						# ファイルの検索を許可するなら1
fsattach = 0						# メッセージからの添付ファイル取り出しを許可するなら1

### 掲示板の管理関連
bbsallow = 0						# 掲示板機能を有効にする場合は1
bbsroot = 							# 掲示板データ保存ルートフォルダ
bbsmaxarticle = 300					# 1掲示板最大記事数
bbxmaxcomment = 100					# 1記事内最大コメント数
bbsmaxarticlesize = 10				# 記事・コメントの最大サイズ(KB)
bbsmaxitem = 100					# ページあたり表示記事数
bbsallowsamehandle = 1				# ハンドル名の重複を許可しないなら0
bbsallowsearch = 0					# 検索を許可するなら1
bbsallowsort = 0					# ソート表示を許可するなら1
bbsallowupload = 0					# ファイルアップロードを許可するなら1
bbsmaxupload = 100					# アップロードファイルの最大サイズ(KB)
bbsuploadtag = bat cmd com exe lnk	# アップロードを禁止するファイル拡張子
bbsupdateindex = 1					# 検索対象インデックスの随時更新を許可しないなら0

### 個人用メーリングリスト運営ルール関連
plmaxmember = 100					# 個人用ML登録時の最大メンバー数(デフォルト)
plrname = info postmaster support webmaster sysadmin	# ユーザが開設できないリストの名前
plmsgsize = 0						# 個人用MLでMSGサイズ制限設定を許可する場合は1
plstag = 0							# 個人用MLでSubject:タグの設定を許可する場合は1
plffrom = 0							# 個人用MLでFrom:アドレス固定の設定を許可する場合は1
plattach = 0						# 個人用MLで添付ファイル削除の設定を許可する場合は1
plmsgid = 0							# 個人用MLでMessage-Id:タグ付加の設定を許可する場合は1
plheader = 0						# 個人用MLでヘッダ/フッタの設定を許可する場合は1
pldeny = 0							# 個人用MLで受信拒否の設定を許可する場合は1
plsubscribe = 0						# 個人用MLで空メッセージ投稿による登録/削除の設定を許可する場合は1
plrobot = 0							# 個人用MLでリストプロセッサの設定を許可する場合は1
plnotice = 0						# 個人用MLでリスト開設/削除をpostmasterに通知する場合は1

### ビッグファイル送受機能関連
allowbigfile = 0					# ビッグファイル送付機能を有効にする場合は1
bigfileauthstr = 8					# ダウンロード時に認証が必要な場合に認証文字列の最小の長さ
bigfilemax = 1						# アップロードできるビッグファイルの個数制限
bigfilesize =						# アップロードできるビッグファイルのサイズ制限(キロバイト)
bigfiletag =						# アップロードを拒否するファイル拡張子
bigfileroot =						# ビッグファイルを保存するローカルパス(ドライブ文字も必要)
bigfileurl =						# ビッグファイルを公開するウェブサイトのアドレス(URL)
bigfileheader =						# 公開ページのHTMLヘッダファイル名(bigfilerootに存在する必要)
bigfilefooter =						# 公開ページのHTMLフッタファイル名
allowbigfile2 = 0					# ビッグファイル受領機能を有効にする場合は1
bigfilemax2 = 1						# アップロードできるビッグファイルの個数制限
bigfilesize2 = 100000				# アップロードできるビッグファイルのサイズ制限(キロバイト)
bigfileroot2 =						# ビッグファイルを保存するローカルパス(ドライブ文字も必要)
bigfileurl2 =						# ビッグファイルを受領するウェブサイトのアドレス(URL)
bigfileheader2 =					# 公開ページのHTMLヘッダファイル名(bigfileroot2に存在する必要)
bigfilefooter2 =					# 公開ページのHTMLフッタファイル名
