;### uK4 - 初期表示共通
## カレンダ表示(domain_home, help, mailbox_start)
use utf8;
sub calendar {
	my $usecalM = 3;
	require './calendar.cgi';
	print "<table cellpadding=1 cellspacing=0 border=0><tr><td bgcolor='#ffb0b0'>";
	print "<table cellpadding=4 cellspacing=0 border=0><tr><td $bgcolor1>";
	for (0 .. --$usecalM){&printCalendar($_);}
	print "</table></table>";
}

## 掲示板一覧を得る
sub getbbs {
	my $index = "$bbsroot/index.txt";
	my $regexp = 'B\d{3}';
	my @reg = qw(ID Title Start End Span Articles Comments ArticleSize Item 
		Delete Search Sort Upload Size Notify NotifyTag Inline Url Created Updated 
		Memo OwnersName OwnersPhone OwnersEmail);
	my @list;
	
	## 有効インデックスがあれば
	if (-f $index && (stat($index))[9] + $ttl > time()){
		open(MyFILE,$index);
			while (<MyFILE>){
				$_ = &dec_utf($_,$charsetE);
				next if (/^\s*$/ || /^#/);
				push(@list,$_);
			}
		close(MyFILE);
		return @list;
	}
	
	## インデックス作成
	unlink($index);
	foreach my $id (&getdirs($bbsroot,$regexp)){
		my %p = &getenv("$bbsroot/$id/profile.txt",'=');
		my $line;
		foreach my $i (@reg){$line .= $p{$i} . "\t";}
		
		# 投稿記事数を得る
		my $count = 0;
		my @tmp;
		if (open(FILE,"$bbsroot/$id/count.txt")){
				@tmp = <FILE>;
			close(FILE);
			($count) = @tmp;
			chomp($count);
		}
		
		# 状態を得る
		my $stat;
		if (-f "$bbsroot/deleted/$id"){$stat = 'deleted';}
		elsif (-f "$bbsroot/suspended/$id"){$stat = 'suspended';}
		
		# アカウント数を得る
		my $accounts;
		foreach (glob("$bbsroot/$id/accounts/*")){
			$accounts++ if -f;
		}
		
		$line .= "$accounts\t\t\t\t\t\t\t$stat\t$count\n";
		Encode::_utf8_off($line);
	}
	
	if (@list){
		open(MyFILE,">$index");
			flock(MyFILE,2);
			# 全掲示板のインデックス($ttl秒間有効)
			# 0BBSID 1BBS表示名 2開始日 3終了日 4記事表示期間 5最大記事数 6最大コメント数
			# 7記事サイズ 8ページ行数 9削除許可 10検索許可 11ソート法 12アップロード許可
			# 13アップサイズ 14投稿通知 15通知MSGのSubjectタグ 16画像インライン表示 
			# 17URLリンク表示 18作成日 19更新日 20メモ 21連絡責任名 22連絡責任者電話 
			# 23連絡責任者E-mail 24閲読アカウント数 25 26 27 28 29 30
			# 31状態 32投稿記事数
			print MyFILE @list;
		close(MyFILE);
	}
	
	@list;	
}

## MSGフォルダのリストを得る(mailbox_start,menu1)
sub getboxlist {
	local($a,$b);
	my (@folder,@i,@o);
	
	foreach (&getfolders()){
		my ($name,$exp) = split(/\t+/,$_);
		if ($name =~ /^i/i){push(@i,$_);}
		elsif ($name =~ /^o/i){push(@o,$_);}
	}
	@i = &sorting(1,0,0,@i);
	@o = &sorting(1,0,0,@o);
	push(@folder,@i);
	push(@folder,@o);
	foreach(qw(templatebox draftbox outbox inbox)){unshift(@folder,"$$_\t$box{$$_}");}
	push(@folder,"$trashbox\t$box{$trashbox}");
	push(@folder,"$spambox\t$box{$spambox}");
	
	foreach($draftbox,$trashbox,'temp'){if (!-e "$userdir/$_"){mkdir("$userdir/$_",0755);}}
	@folder;
}

## 追加メニューを得る(help, menu1)
sub getextmenu {
	my ($type) = @_;	# help.cgiから実行でtype=1
	my $tab = 'K4.menu.tab';
	my @reg;
	
	# 個人用メニューがあれば得る
	if (open(FILE,"$userdir/$xmailcfg/$tab")){
			@reg = <FILE>;
		close(FILE);
	}
	
	# グループ用メニューがあれば得る
	foreach my $group (split(/_+/,$extstr3)){
		$group =~ s/^[A-Z]//i;
		my @tmp;
		open(FILE,"$groot/$group/$tab") || next;
			@tmp = <FILE>;
		close(FILE);
		push(@reg,@tmp);
	}
	
	# ドメイン用メニューがあれば得る
	my @tmp;
	if (open(FILE,"$mailroot/domains/$domain1/$tab")){
			@tmp = <FILE>;
		close(FILE);
		push(@reg,@tmp);
	}
	
	# 重複を削除
	my %count;
	@reg = grep(!$count{$_}++, @reg);
	
	# メニューデータを作成
	my $menu;
	@reg = &sorting(1,0,0,@reg);
	foreach(@reg){
		$_ = &dec_utf($_,$charsetE);
		chomp;
		my ($idx,$name,$url,$op) = split(/\t/,$_);
		next if (!$name || !$url);
		if ($op){$op = "target='_blank'";}
		else {$op = "target='main'";}
		$name =~ s/</&lt;/g;
		$name =~ s/>/&gt;/g;
		$name =~ s/"/&quot;/g;
		if ($type){$menu .= "<a href=\"$url\" $op>$arrowR $name</a><br>";}
		else {$menu .= "$box<td width='100%'><a href=\"$url\" $op>$name</a></td></tr>";}
	}
	if ($menu && $type){
		my $str = $fs7G.'追加メニュー'.$fe;
		$menu = <<"EOF";
<tr><td $bgcolor4><img src='$idir/null.gif' width=2 height=1></td>
<td>$str<br>
$menu</td></tr>
<tr><td height=8></td></tr>
EOF
	} elsif ($menu){
		$menu = "<tr><td height=1></td></tr><tr $bgcolor1><td colspan=2 height=4>$null</td></tr>$menu";
		$menu .= "<tr $bgcolor1><td colspan=2 height=1>$null</td></tr>";
	}
	
	$menu;
}

## グループIDとグループ名との連想配列を得る
sub getgroupname {
	my %name;
	
	my @dir;
	opendir(DIR,$groot);
		@dir = readdir(DIR);
	closedir(DIR);
	
	foreach my $dir (@dir){
		next if !-f "$groot/$dir/profile.tab";
		my %i = &getenv("$groot/$dir/profile.tab",'=');
		$name{$dir} = $i{'Name'};
	}
	
	%name;
}

## ログイン時メッセージを得る(domain_home, help, mailbox_start)
sub info_check {
	my $tab = 'K4.info.tab';
	my ($info);
	
	# 個人用通知メッセージ
	$info = &info_check2("$mailroot/domains/$domain1/$user1/$xmailcfg/information.tab");
	
	# グループ用通知メッセージ
	foreach my $group (split(/_+/,$extstr3)){
		$group =~ s/^[A-Z]//;
		$info .= &info_check2("$groot/$group/$tab");
	}
	
	# ドメイン用通知メッセージ
	$info .= &info_check2("$mailroot/domains/$domain1/$tab");
	
	# 全ユーザ用通知メッセージ
	$info .= &info_check2("$mailroot/domains/$tab");
	
	$info = "$table0<tr><td $bgcolor4 height=1>$null$info</table><br>" if $info;
	$info;
}

## 通知メッセージの読み込み(&info_checkから)
sub info_check2 {
	my ($file) = @_;
	my ($data,$message,$title);
	my $count = 1;
	
	open(FILE,$file) || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			s/</&lt;/g;
			s/>/&gt;/g;
			s/"/&quot;/g;
			if ($count == 1 && /^\[Title\] *(.*)/i){$title = $1;}
			else {$message .= "$_\n";}
			$count++;
		}
	close(FILE);
	
	$message =~ s/^[ \n]+//;
	$message =~ s/\s+$//;
	$message =~ s/ /&nbsp;/g;
	$title =~ s/^\s+//;
	$title =~ s/\s+$//;
	$title =~ s/ /&nbsp;/;
	
	return() if (!$message && !$title);
	$message =~ s/\n/<br>/g;
	$title = "$fs7G$title$fe<br>" if $title;
	
	$data = <<"EOF";
<tr><td height=4></td></tr>
<tr><td>$title$message</td><td width=6></td></tr>
<tr><td height=4></td></tr>
<tr><td $bgcolor4 height=1>$null</td></tr>
EOF
	
	$data;
}

## ロギング
sub log1 {
	my $wday = ('日','月','火','水','木','金','土')[$wday];
	my $file1 = "$mailroot/logs/K4/$u\@$d...$etime2...$ENV{'REMOTE_ADDR'}.login";
	my $file2 = "$userdir/$xmailcfg/.login";
	Encode::_utf8_off($wday);
	Encode::from_to($wday,$charset,$charsetE);
	mkdir("$mailroot/logs/K4",0755);
	
	# XMailCFGからログイン者一覧を得るための記録
	open(FILE,">$file1") && close(FILE);
	
	# XMailCFGからログイン記録を参照するための記録
	open(FILE,">>$file2");
		flock(FILE,2);
		print FILE "$year-$month-$mday($wday) $hour:$min\t$d\t$u\t$ENV{'REMOTE_ADDR'}/$ENV{'HTTP_USER_AGENT'}\n";
	close(FILE);
	
	if (-s "$file2" < 1024**2){return();}
	my @tmp;
	open(FILE,"$file2");
		@tmp = <FILE>;
	close(FILE);
	open(FILE,">$file2");
		print FILE splice(@tmp,-1000,1000);
	close(FILE);
}

## ログイン実行
sub login {
	# Cookie作成
	foreach(qw(domain user loginid crypt etime ip extstr extstr1 extstr2 extstr3 extstr4 extstr5 r1 r2 r3 r4 r5 r6 r7 r8 r9)){
		$$_ =~ tr/abcdefg0123456789hijkl|mnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/gxoAdBjCqDEw\/FpGeHnIhJuKaLyMiNvOkPcQzRtSmTfUrVlWsXYZ0123456789b/;}
	$ck = "$k4cookiestr1=$extstr:$domain:$user:$loginid:$crypt:$etime:$ip:$extstr1:$extstr2:$extstr3:$extstr4:$extstr5:";
	$sck = "<meta http-equiv='Set-Cookie' content='$ck'>";
	$argment = "$r4$r1+$r5$r2+$r6$r3+$r7$r4+$r8$r9";
	
	print <<"EOF";
Content-type: text/html; charset=$charset
Set-Cookie: $ck
CacheControl: no-cache
Pragma: no-cache
Expires: -1

<html>
<head>
$forward
$nocache
$sck
<meta http-equiv="Refresh" content="0;url=$login2?$argment">
</head>
</html>
EOF
	
	&refresh_index('all') if !$slogin;
	&log('s',$d,$u,'*','login','ログイン成功',"",$crypt0);
	&log1();
	require "./$k4loginscript" if -f "./$k4loginscript";
	mkdir("$bigfileroot",0755) if $allowbigfile;
	mkdir("$bigfileroot2",0755) if $allowbigfile2;
	&deltrash();
	exit;
}

## 未読MSG数チェック(domain_home, help, mailbox_spam, mailbox_start)
sub mail_check {
	my ($count,$desc);
	my @folders = grep(/^i\d+\t/, &getfolders());
	unshift(@folders,"$inbox\t受信トレイ");
	push(@folders,"spam\t迷惑メール");
	
	foreach my $line (@folders){
		my $count2;
		my @tmp;
		my ($folder,$desc2) = split(/\t+/,$line);
		while (glob("$userdir/$folder/*.*")){
			next if ((stat($_))[9] < time() - $ttlday*24*60*60);
			my $name = $& if /[^\/]+$/;
			if (!-f "$userdir/temp/$name"){$count++; $count2++;}
		}
		my $cgi = 'mailbox_msg_list.cgi';
		$cgi = 'mailbox_spam.cgi' if $folder eq 'spam';
		$desc .= "<a href='$cgi?0+1+0+$folder+9'>$arrowR $desc2: <b>$count2</b></a><br>" if $count2;
	}
	$desc =~ s/(<br>)*$//g;
	
	($count,$desc);
}

1;
