#!C:/usr/perl/bin/perl.exe

### uK4 - ドメインの管理-共用アドレス帳の管理
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./domain_common.cgi";
($abook,$cgi,$max) = ('k4.book.tab',"domain_addresslist.cgi",'100');
@array = qw(tdomain address);

## 初期表示
if (@ARGV){
	&domainadmin();	# 管理権限チェック
	$tdomain = $key4;
	&html();
}

## フォーム入力を処理
&parse_form(@array);
&domainadmin();
&html("このアカウントでは更新できません！",1) if $k4fixed;

$address =~ s/^\s+//;
$address =~ s/\s+$//;
$address =~ s/\s*\n\s+/\n/g;
$address =~ s/ *#+ */\t/g;
undef $tmp;
if ($address =~ /[^\s]/){
	@tmp = split(/\n/,$address);
	&html("$max 件以上の登録は許可されていません。",1) if $#tmp + 1 >= $max;
	foreach(sort(@tmp)){
		s/^<(.+)>$/$1/;
		s/^<(.+)>\t(.*)/$1\t$2/;
		my ($em,$desc) = split(/\t+/,$_);
		my $em2 = $em;
		$em2 =~ s/\(.+?\)//g;
		&html("$em の半角カッコが正しいペアではありません。",1) if $em2 =~ /[()]/;
		$em2 = $em;
		$em2 =~ s/\[.+?\]//g;
		&html("$em の半角ブラケットが正しいペアではありません。",1) if $em2 =~ /[\[\]]/;
		s/^[<\(]+($emreg1)[>\)]+\s*$/$1/;
		$tmp .= "$_\n";
	}
}
if ($tmp){
	Encode::_utf8_off($tmp);
	Encode::from_to($tmp,$charset,$charsetE);
	if (open(FILE,">$mailroot/domains/$tdomain/$abook")){
			flock(FILE,2);
			print FILE "$tmp";
		close(FILE);
		$msg = "共用アドレス帳を保存しました。";
	}
	else {&html("共用アドレス帳の保存に失敗しました。",1);}
}
else {
	unlink("$mailroot/domains/$tdomain/$abook");
	$msg = "共用アドレス帳を削除しました。";
}

&html($msg);

## ページを表示 -------------------------
sub html {
	if (@_){
		if ($Expired && !$_[1]){&expire($_[0]);}
		$notice = "$alert $fs5R $_[0] $fe";
	} else {
		$notice = "「メールボックスの管理」における新規メッセージの送信でこのドメインのメンバーが共有する<br>";
		$notice .= "メールアドレスのリストを登録します。";
	}
	&check_domaininfo($tdomain);
	&check_address($tdomain);		# 現在の共用アドレス帳を得る
	&header('address');
	&htmlconv('addressbook');
	
	my $title = '共用アドレス帳の管理';
	$K4 = <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc13' border=0>
<tr><td>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title'> 
$fs7G<b>$title</b>$fe <span class='doc15'>(現在の登録数: $total 件)</span>
$hr
$notice</td></tr>
<tr><td height=6></td></tr>
<tr><td $bgcolor2>
<form method='post' action='$cgi'>
<input type='hidden' name='tdomain' value='$tdomain'>
<textarea name='address' cols=70 rows=12>$addressbook</textarea></td></tr>
<tr><td><input type='submit' value='アドレス帳を更新する'></td></tr>
<tr><td class='doc13'><ul>
<li>1 行につき 1 件の登録です。</li>
<li>1 件の入力は 「<font $colorR>メールアドレス (1個以上の # 区切り文字) その説明 (改行)</font>」 です。</li>
<li>説明には日本語が使えます。使用文字に制限はありません。</li>
<li>最大登録数は $max 件です。</li>
<li>以下は登録サンプルです。<br>
<table cellpadding=4 cellspacing=0 class='doc13' border=1>
<tr><td>
taro\@xmail.dojo.jp &nbsp; ## &nbsp; 友人Ａ<br>
太郎 &lt;taro\@xmail.dojo.jp&gt; &nbsp; ## &nbsp; 友人Ａ<br>
taro\@xmail.dojo.jp (太郎) &nbsp; ## &nbsp; 友人Ａ<br>
</td></tr>
</table></li>
</ul></td></tr>
</table>
</form>
EOF
	
	&print_utf($K4,'',1);
	&print_footer();
	&exit();
}

# ========================================
sub check_address {
	my ($desc,$email,@address,@tmp);
	my ($domain) = @_;
	$total = 0;
	if (open(FILE,"$mailroot/domains/$domain/$abook")){
			while(<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				if (/^($emreg1 *\([^\)]+\))\t*(.*)/i || /^([^<]+<$emreg1>)\t*(.*)/i || 
					/^[<\(]*($emreg1)[>\)]*[ \t]*(.*)/i){
					($email,$desc) = ($1,$2);
				} else {next;}
				if ($total >= $max){last;}
				$total++;
				push(@address,"$email ## $desc");
			}
		close(FILE);
	}
	foreach(sort(@address)){$addressbook .= "$_\n";}
}
