#!C:/usr/perl/bin/perl.exe

### uK4 - ドメインの管理-ユーザの管理-プロパティの編集
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use File::Find;
use utf8;
require "./config.cgi";
require "./domain_common.cgi";
($cgi,$help) = ("domain_user_edit.cgi","$helper?u");
@array = qw(
	tdomain tuser PopEnable ReceiveEnable pass1 pass2 k4login k4allowallow k4allowdeny k4allowantispam 
	k4allowmail k4allownotify k4allowdistribute k4allowbigfile k4allowbigfile2 k4allowusertab k4autoreply
	k4forward k4fservice k4menu k4mklist k4mlist k4password k4popsync RealName CompanyName Telephone 
	Address HomePage MaxMBSize MaxMessageSize SmtpPerms DisableEmitAuthUser memo menuid
);

## 初期表示
if (@ARGV){
	&domainadmin();	# 管理権限チェック
	($tdomain,$tuser,$menuid) = ($key4,$key5,'property');
	&check_domaininfo($tdomain);
	&getenv("$mailroot/domains/$tdomain/$tuser/user.tab",'',1);
	if (!$MaxMBSize){$MaxMBSize = $maxmbsize;}
	&getenv("$mailroot/domains/$tdomain/$tuser/$xmailcfg/config.tab",'=',1);
	&check_memo($tdomain,$tuser);	# メモを読む
	&html();
}

## フォーム入力を処理
&parse_form(@array);
&domainadmin();
&check_domaininfo($tdomain);
&html("このアカウントからは更新できません！") if $k4fixed;
if ($k4password){$k4password = '';} else {$k4password = 1;}
if ($k4forward){$k4forward = '';} else {$k4forward = 1;}
if ($pass1 || $pass2){
	&html("パスワードが一致しません！") if $pass1 ne $pass2;
	&html("パスワードに不正文字があります！") if $pass1 =~ /["\|<>]/;
	&html("パスワードの長さは $passmin 字以上です！") if length($pass1) < $passmin;
	
	&ctrlcmd("\"userpasswd\"	\"$tdomain\"	\"$tuser\"	\"$pass1\"");
	&log('s',$domain1,$user1,'*','run',"$tuser\@$tdomain のパスワードを変更",$0);
	$extmsg = '<br>●パスワードを更新しました。';
}
&html("メーリングリスト開設許可数は数値を指定してください！") if $k4mklist =~ /\D/;
&html("メーリングリスト開設許可数は $maxlist までです！") if ($k4mklist && $k4mklist > $maxlist);
$k4mlist =~ s/[\n\r\s]+/ /g;

&saveenv('user',$tdomain,$tuser,'RealName','CompanyName','Telephone','Address','HomePage','PopEnable','ReceiveEnable');
&saveenv('k4',$tdomain,$tuser,'k4login','k4allowallow','k4allowdeny','k4allowantispam','k4allowmail','k4allownotify',
	'k4allowusertab','k4allowdistribute','k4autoreply','k4forward','k4fservice','k4menu','k4mklist',
	'k4mlist','k4password','k4popsync');
&savememo($tdomain,$tuser);		# 管理用メモを保存

$extmsg .= '<br>●アカウントは停止されています。' if (!$PopEnable && !$ReceiveEnable);
$extmsg = "$fe$extmsg" if $extmsg;
&html('',"プロパティを更新しました。$extmsg");

## HTMLを表示 ---------------------------------------------
sub html {
	my ($emsg) = @_;
	$emsg = "$alert $fs5R $emsg$fe" if $emsg;
	&expire($_[1]) if ($Expired && !$_[0]);
	&check_domaininfo($tdomain);		# ユーザリストを得る
	&env2();			# K4アクセス権設定HTMLを取得
	&check_mailbox('mboxsize',"$mailroot/domains/$tdomain/$tuser");	# メールボックスの使用状況を調査
	&check_aliases($tdomain,$tuser);	# エイリアス情報を取得
	&htmlconv(qw(RealName CompanyName HomePage Address Telephone memo));
	$enable1 = 'checked' if $ReceiveEnable;
	$enable2 = 'checked' if $PopEnable;
	
	&selectmenu_u();
	&header('user');
	
	my $title = 'ユーザの管理';
	$K4 = <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc131' border=0>
<tr><td colspan=3>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title'> 
$fs7G<b>$title</b>$fe <span class='doc15'>$usertotal1</span> &nbsp;
<a href='$duser?$tdomain'>アカウントの追加 $arrowR</a>
$hr
$fs5R $_[1]$fe</td></tr>
<tr valign='top'><td>$selectmenu</td><td width=1></td><td>

<table cellpadding=0 cellspacing=1 class='doc131' border=0>
<tr><td colspan=2>$buttonP $fs7<b>$tuser\@$tdomain</b>$fe <span class='doc15'>のプロパティ</span><br>
$emsg</td></tr>
<tr><td height=4>
<form method='post' action='$cgi'>
<input type='hidden' name='tdomain' value='$tdomain'>
<input type='hidden' name='tuser' value='$tuser'>
<input type='hidden' name='menuid' value='$menuid'></td></tr>
<tr><td colspan=2>
	<table cellpadding=4 cellspacing=0 border=0 width='100%'>
	<tr><td $bgcolor0>
		$table1
		<tr><td nowrap>&nbsp;<a href="JavaScript:opn_win('$help+diskspace'$wsize)">ディスク使用量:</a>&nbsp;</td>
		<td><b>$mboxsize</b> KB</td></tr>
		<tr><td nowrap>&nbsp;<a href="JavaScript:opn_win('$help+alias'$wsize)">エイリアス情報:</a>&nbsp;</td>
		<td>$aliases</td></tr>
		</table></td></tr>
	</table></td></tr>
<tr><td height=10></td></tr>
<tr><td colspan=2>
	<table class='doc131'>
	<tr><td><a href="JavaScript:opn_win('$help+password'$wsize)">パスワード再発行:</a></td>
	<td><input type='password' name='pass1' size=25 maxlength=50 $nosubmit></td></tr>
	<tr><td align='right'><a href="JavaScript:opn_win('$help+password1'$wsize)">パスワード確認:</a></td>
	<td><input type='password' name='pass2' size=25 maxlength=50 $nosubmit></td></tr>
	</table></td></tr>
<tr><td class='doc15' colspan=2>$hr
■<a href="JavaScript:opn_win('$help+system'$wsize)">システムへのアクセス権</a></td></tr>
<tr><td colspan=2>
<dd><input type='checkbox' $enable2 name='PopEnable' value='1'> 
<a href="JavaScript:opn_win('$help+popservice'$wsize)">POP サービスの利用を許可</a></dd>
<dd><input type='checkbox' $enable1 name='ReceiveEnable' value='1'> 
<a href="JavaScript:opn_win('$help+smtpservice'$wsize)">SMTP サービスの利用を許可</a></dd>
<tr><td height=4></td></tr>
EOF
	&print_utf($K4);
	&printuserstat();
	$K4 = <<"EOF";
<tr><td height=4></td></tr>
<tr><td colspan=2>$hr
<input type='submit' value='プロパティを更新'></td></tr>
</table></td></tr>
</table>
<div align='right'>$arrowU</div>
</form>
EOF
	&print_utf($K4);
	&print_footer();
	&exit();
}

# ========================================
sub check_aliases {
	local(@aliases);
	local($alias) = 0;
	local($domain,$user) = @_;
	($domain,$user) = &mod_str($domain,$user);
	if (open(FILE,"$mailroot/aliases.tab")){
			while(<FILE>){
				chomp;
				s/"//g;
				if (/^([^\t]+)\t+([^\t]+)\t+$user\@$domain$/i){
					push(@aliases,"<option> $2\@$1</option>");
					$alias++;
				}
				elsif (/^$domain\t+([^\t]+)\t+$user$/i){
					push(@aliases,"<option> $1\@$tdomain</option>");
					$alias++;
				}
				else {}
			}
		close(FILE);
#		@aliases = sort(@aliases);
		foreach(@aliases){$aliases .= $_;}
	}
	if ($aliases){$aliases = "<select>$aliases</select> ($alias\件)";}
	else {$aliases = '(なし)';}
}

sub check_mailbox {
	local($count,$size,@dirlist);
	local($dir) = $_[1];
	
	opendir(DIR,$dir);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach (@dirlist){
		next if (/^\./ || /^(logs|temp\d*|$xmailcfg)/i);
		find(sub {$size += -s if -f}, "$dir/$_");
	}
	if ($size){$size = int(($size+1023) / 1024);}
	else {$size = 0;}
	1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	${$_[0]} = $size;
}
