;### uK4 - 個人用メーリングリスト管理共通
use utf8;
$denycgi = 'list_deny.cgi';		# 受信拒否用
$mailcgi = 'list_smail.cgi';	# MSG送信用
$membercgi = 'list_member.cgi';	# メンバー管理用
$robotcgi = 'list_robot.cgi';	# 自動登録用
$startcgi = 'list_home.cgi';	# トップページ用
$viewcgi = 'list_view.cgi';		# 個別リスト情報表示用
$wsize = ",320,200";			# ヘルプウインドウサイズ
$help = "helper.cgi?l2";
@k4arraym = qw(Attachment Deny ForceFrom Footer GoodbyeMessage Header ListAdmin Log MaxUser MessageID 
	MessageSize Owner ReplyTo Robot RobotConfirm RobotHelp RobotInfo RobotTTL Subscribe Tag WelcomeMessage);
@xmailarraym = qw(RealName CompanyName ClosedML ListSender ReceiveEnable UseReplyTo);
$na = $nofilter if -f "$tempdir/$nf";
&auth();

## 環境のチェック
sub env0 {
	my ($p1,$p2) = @_;
	my ($domain,$list,$name,$value,@tmp1,@tmp2);
	
	# 該当ドメインの全アカウントと管理情報を得る
	if ($p1 && $p1 !~ /\@/){
		($domain) = &mod_str($p1);
		if (open(MyFILE4,"$mailroot/$domainadmintab")){
				while(<MyFILE4>){
					chomp;
					s/"//g;
					next if (/^#/ || /^\s*$/ || !/\t/);
					@tmp1 = split(/\t/,$_);
					@K4D = @tmp1 if (!@K4D && $tmp1[0] =~ /^$domain$/i);
				}
			close(MyFILE4);
		}
		open(MyFILE4,"$mailroot/mailusers.tab");
			while(<MyFILE4>){
				chomp;
				push(@K4A,$1) if /^"*$domain"*\t"*([^"]+)/i;
			}
		close(MyFILE4);
		open(MyFILE4,"$mailroot/aliases.tab");
			while(<MyFILE4>){
				chomp;
				push(@K4A,$1) if /^"*$domain"*\t"*([^"]+)/i;
			}
		close(MyFILE4);
	}
	else {
	# 該当個人用リストの管理情報を得る
		$list = $p1;
		($name,$domain) = split(/\@/,$list);
		($list) = &mod_str($list);
		open(MyFILE4,"$mailroot/$listadmintab") || return();
			while(<MyFILE4>){
				chomp;
				s/"//g;
				next if (/^$/ || /^\s*$/ || !/\t/);
				@tmp1 = split(/\t/,$_);
				@K4L = @tmp1 if (!@K4L && $tmp1[0] =~ /^$list$/i);
			}
		close(MyFILE4);
	}
}

## メニューを表示
sub do_header1 {
	my ($title,$op,$msg) = @_;
	my ($m0,$m1,$m2,$m3,$m4,$m5,$op1);
	$m0 = "| <a href='$startcgi?___'>トップ</a> ";
	$m1 = "| <a href='$viewcgi?$ml'>環境設定</a> ";
	$m2 = "| <a href='$membercgi?$ml'>メンバー</a> ";
	$m3 = "| <a href='$denycgi?$ml'>受信拒否</a> " if $Ldeny && $pldeny;
	$m4 = "| <a href='$robotcgi?$ml'>自動処理</a> " if $Lrobot && $plrobot;
	$m5 = "| <a href='$mailcgi?$ml'>管理者投稿</a> ";
	
	if ($op eq 'view'){$op = "$m0$m2$m3$m4$m5 |"; $op1 = '環境設定';}
	elsif ($op eq 'deny'){$op = "$m0$m1$m2$m4$m5 |"; $op1 = '受信拒否';}
	elsif ($op eq 'member'){$op = "$m0$m1$m3$m4$m5 |"; $op1 = 'メンバーの管理';}
	elsif ($op eq 'robot'){$op = "$m0$m1$m2$m3$m5 |"; $op1 = '自動処理';}
	elsif ($op eq 'sendmail'){$op = "$m0$m1$m2$m3$m4 |"; $op1 = '管理者投稿';}
	else {$op = '';}
	$msg = "$alert $msg" if $msg;
	
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "<html><head>$charcss</head>";
	
	my $K4 = <<"EOF";
<body $bodyp class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4 $cbody0>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><a href='$startcgi?___'>
<img src='$idir/letter.gif' width=34 height=24 title='$title' border=0></a></td>
<td nowrap>&nbsp;$fs7G<b>$title</b>$fe&nbsp;&nbsp;</td>
<td align="right" width='100%'>$op&nbsp;</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=3 height=1>$null</td></tr>
<tr><td height=12></td></tr>
</table>
EOF
	if ($op1){
		my $title = "$ml の管理";
		$K4 .= <<"EOF";
<table cellpadding=2 cellspacing=0 class='doc131' border=0 width='100%'>
<tr><td><img src='$idir/arrow_blue.gif' width=32 height=13 title='$title'> 
$fs7 $op1 $fe$fs5R&nbsp; $msg$fe</td></tr>
</table>
EOF
	}
	&print_utf($K4);
}

## メーリングリスト現況を得る
sub getLinfo {
	my ($ml) = @_;
	my ($list,$domain) = split(/\@/,$ml);
	my $base = "$mailroot/domains/$domain/$list";
	mkdir("$base",0755);
	mkdir("$base/$xmailcfg",0755);
	@Lmembers = ();
	
	# K4/XMail環境を得る
	foreach("$base/user.tab","$base/$xmailcfg/config.tab"){
		my ($op,%i);
		if (-f){
			$op = '=' if /config\.tab/;
			%i = &getenv($_,$op);
			while(my ($key,$value) = each %i){$l{$key} = $value;}
		}
	}
	
	# メンバーリストを得る
	if (open(MyFILE4,"$base/mlusers.tab")){
			while (<MyFILE4>){
				chomp;
				next if (/^\s*$/ || /[^\w".\-\@\t]/ || !/@/);
				s/^\s+//;
				s/\s+$//;
				push(@Lmembers,$_);
			}
		close(MyFILE4);
	}
	@Lmembers = sort(@Lmembers);
}

## 現況を表示
sub printstat {
	my ($ml) = @_;
	my ($K4,$members,$tmp);
	
	&getLinfo($ml);
	$members = @Lmembers;
	1 while $members =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	$tmp = $Lmember;
	if ($tmp){
		1 while $tmp =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		$tmp = "(最大登録数: $tmp)";
	} else {$tmp = "(登録数無制限)";}
	
	$K4 = "<table cellpadding=2 cellspacing=0 border=0 width='100%'><tr><td $bgcolor3>$table1";
	$K4 .= "<tr><td><li>リストアドレス:</td><td>$Lname</td></tr>";
	$K4 .= "<tr><td nowrap><li>現在のメンバー数:　&nbsp;</td><td>$members $tmp</td></tr>";
	if ($Lrobot && $plrobot){
		if ($l{'Robot'}){$tmp = "実行中";} else {$tmp = "停止中";}
		$K4 .= "<tr><td><li>自動登録:</td><td>$tmp</td></tr>";
	}
	if ($l{'ClosedML'}){$tmp = "メンバーのみ投稿可能";} else {$tmp = "だれでも投稿可能";}
	$K4 .= "<tr><td><li>投稿権:</td><td>$tmp</td></tr>";
	if ($l{'ReceiveEnable'}){$tmp = "運用中";} else {$tmp = "停止中";}
	$K4 .= "<tr><td><li>状態:</td><td>$tmp</td></tr>";
	$K4 .= "</table></td></tr></table>";
	&print_utf($K4);
}

1;
