#!C:/usr/perl/bin/perl.exe

### uK4 - セットアップ済みビッグファイル送付サイトの管理($bigfileroot内)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";
$cgi = 'mailbox_bigfile.cgi';
$cgi2 = 'mailbox_bigfile2.cgi';
$confirm = "onClick=\"if(!confirm('このダウンロードサイトを削除してもよろしいですか？')){return false;}\"";
$index = "$tempdir/$loginid/.my_bigfile_site.txt";
$fileIcon = "<img src='$idir/file.gif' height=13 width=15 title='ファイル' border=0>";

## 初期表示
if (@ARGV){
	($field,$method,$page,$op1,$op2,$op3) = @ARGV;
	my $msg;
	
	# 登録済みサイトを削除する
	if ($op1 eq 'delete' && length($op2) == 32){
		rmtree(["$bigfileroot/$op2"],0,0);
		rmtree(["../temp/bigfile/$op2"],0,0);
		unlink($index);
		$msg = "1個の登録済みサイトを削除しました。";
	}
	# 指定ファイルをダウンロード
	elsif ($op1 eq 'download' && $op2 && length($op3) == 32){
		my %p = &getenv("$bigfileroot/$op3/profile.txt",'=','',1,$charset);
		($FileExt,$FileID,$FileName) = ($p{'File'.$op2.'Ext'},$p{'File'.$op2.'ID'},$p{'File'.$op2.'Name'});
		$FileName .= ".$FileExt" if ($FileName !~ /\.\w+$/ && $FileExt);
		my $stat = &download("$bigfileroot/$op3/$FileID",$FileName);
		exit;
	}
	# 最新情報に更新
	elsif ($op1 eq 'refresh'){
		unlink($index);
		$msg = "最新情報を取得しました。";
	}
	
	&html($msg);
}
exit;

### ---------------------------------------------------------------
sub html {
	&expire() if $Expired;
	my ($error) = @_;
	$error = "$alert $fs5R$error$fe" if $error;
	$arg = join('+',$field,$method,$page);
	
	# ビッグファイル受領サイトが存在するか
	my ($bCount) = &get_bigfile2("$user1\@$domain1") if $allowbigfile2;
	my $cLink = "<a href='$cgi2?0+0+0'>受領サイトの管理へ$arrowR</a>&nbsp;" if $bCount;
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	$K4 = <<"EOF";
<html><head>
$charcss
<title>ビッグファイルの管理</title>
</head>
<body $bodyp class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><img src='$idir/letter.gif' width=34 height=24 title='ビッグファイルを管理します'></td>
<td nowrap>&nbsp;$fs7G<b>ビッグファイルの管理</b>$fe$fs5G - ビッグファイル送付&nbsp;$fe</td><td width='100%'>$error</td>
<td nowrap>$cLink</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=4 height=1>$null</td></tr>
<tr><td height=4></td></tr>
<tr><td colspan=4 height=28 valign='top'>ビッグファイル送付機能を利用して準備したウェブサイトを管理します。
不要サイトは削除してください。 <a href='$cgi?$arg+refresh'>最新情報に更新$arrowR</a></td></tr>
</table>
EOF
	&print_utf($K4);
	
	# サイトの一覧を得る
	my ($count,@sites) = &get_my_site();
	
	# ソート(デフォルトは作成日)
	@sites = &sorting(1,0,0,@sites);
	
	# ページ分割
	###
	
	# 一覧を表示
	my ($count,$data,$fs3,$fs4,$fe4) = (0,'',"<font color='#800000'>","<font color='#006000'>","</font>");
	foreach my $site (@sites){
		chomp($site);
		# 0ID 1作成日 2開始/終了 3認証 4有効時間 5送付先 6送付元 7ファイルリスト 8オープン数 9ログイン数 10ダウンロード数
		$site =~ s/</&lt;/g;
		$site =~ s/>/&gt;/g;
		$site =~ s/"/&quot;/g;
		$site =~ s/\|+/<br>/g;
		my ($id,$created,$period,$auth,$expire,$to,$from,$files,$open,$login,$download) = split(/\t/,$site);
		my $authstr = "ログイン:$login<br>" if $auth =~ /認証必要/;
		my $bgc = "bgcolor='white'";
		$bgc = $bgcolor3 if $count%2 == 1;
		$created =~ s/\s+/<br>/;
		1 while $files =~ s/_icon(\d+)_/<a href='$cgi?$arg+download+$1+$id'>$fileIcon/;
		$files =~ s/_icon_/<\/a>/g;
		
		$data .= "<tr $bgc valign='top'><td>$fs3$created$fe4</td><td nowrap>$fs4$period$fe4</td><td>$fs3$auth$fe4</td>";
		$data .= "<td nowrap>$fs4"."オ"."-"."プン:$open<br>$authstr"."ダウンロ"."-"."ド:$download$fe4</td>";
		$data .= "<td>$fs3$to<br>$from$fe4</td><td>$files</td>";
		$data .= "<td align='center' nowrap><a href='$cgi?$arg+delete+$id' $confirm>&laquo;削除&raquo;</a><br>";
		$data .= "<a href='download.cgi?$id' target='_blank'>&laquo;URL&raquo;</a></td></tr>";
		$count++;
	}
	
	$K4 = "<table border=0 cellpadding=1 cellspacing=1 class='doc131' width='100%'>";
	$K4 .= "<tr bgcolor='#ffe0e0'><td>作成日</td><td nowrap>公開期間</td><td>認証</td><td>履歴</td>";
	$K4 .= "<td nowrap>送付先/送付元</td><td nowrap>送付ファイル</td>";
	$K4 .= "<td align='center' nowrap></td></tr>";
	print "<tr><td height=4></td></tr>";
	if ($data){$K4 .= $data;}
	else {$K4 .= "<tr><td align='center' colspan=7 height=60>送付用ビッグファイルは未登録です。</td></tr>";}
	$K4 .= "<tr><td bgcolor='#c0c0c0' colspan=7 height=1></td></tr>";
	$K4 .= "</table>";
	
	&print_utf($K4);
	&print_footer();
	exit;
}

## 作成したサイトの一覧を得る
sub get_my_site {
	my ($count,@sites) = (0);
	$bigfilemax = 1 if !$bigfilemax;
	$bigfileroot =~ s/\\/\//g;
	
	# 有効インデックスがある
	if ((stat($index))[9] >= time() - $ttlmidx && open(FILE,$index)){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				push(@sites,$_);
			}
		close(FILE);
		$count = @sites;
		return($count,@sites);
	} else {
		unlink($index);
	}
	
	# インデックスを作成
	foreach my $dir (&getdirs($bigfileroot,"\\w{32}")){
		my %p = &getenv("$bigfileroot/$dir/profile.txt",'=','',1,$charset);
		my ($auth,$download,$files,$login,$open,$period) = ('',0,'',0,0);
		
		# 作成者のチェック
		my ($owner) = &mod_str("$user1\@$domain1");
		next if $p{Owner} !~ /^$owner$/i;
		
		# 開始/終了
		if ($p{Start} || $p{End}){
			if ($p{Start} =~ /(\d{4})(\d{2})(\d{2})/){
				$period = '開始'.":$1/$2/$3|";
				if ($p{End} =~ /(\d{4})(\d{2})(\d{2})/){
					$period .= '終了'.":$1/$2/$3";
				}
			}
		} else {
			$period = '無期限';
		}
		# 認証
		if ($p{Auth}){
			$auth = '認証必要、';
			$auth .= 'パスフレ-ズ:'.$p{PassPhrase};
			$auth .= '(大小文字区別)' if $p{Sensitive};
			$auth .= "、";
			$auth .= "$p{ExpireTime}秒有効、" if $p{ExpireTime};
			if ($p{Retry}){$auth .= '認証リトライ'.$p{Retry}.'回';}
			else {$auth .= '認証リトライ無制限';}
		} else {
			$auth = '認証不要';
		}
		#$p{HTMLMessage} =~ s/\|+//g;
		# 送付ファイルリスト
		for my $i (1 .. $bigfilemax){
			my $str = 'File'.$i;
			next if (!$p{$str.'ID'} || !-f "$bigfileroot/$dir/$p{$str.'ID'}");
			$files .= "_icon${i}_$p{$str.'Name'}_icon_";
			$files .= "($p{$str.'Desc'})" if $p{$str.'Desc'};
			$files .= "/$p{$str.'Size'}(KB)";
			$files .= "/$p{$str.'Limit'}回制限" if $p{$str.'Limit'};
			$files .= "|";
		}
		# オープン数/ログイン数/ダウンロード数を得る
		my @tmp;
		if (open(FILE,"$bigfileroot/$dir/history.txt")){
				while (<FILE>){
					$_ = &dec_utf($_,$charset);
					push(@tmp,$_);
				}
			close(FILE);
			foreach my $a (@tmp){
				chomp($a);
				# 0ID 1日時 2ban/download/login/open/create 3status(0/1) 4ファイルID 5所要時間 6IP 7Referer
				my @a = split(/\t/,$a);
				if (!$a[3]){
					$open++ if $a[2] eq 'open';
					$login++ if $a[2] eq 'login';
					$download++ if $a[2] eq 'download';
				}
			}
		}
		# 送り先
		my ($from,$to) = (decode("MIME-Header",encode($charset,$p{SentFrom})),decode("MIME-Header",encode($charset,$p{SentTo})));
		$from = "$p{SenderName}($from)" if $p{SenderName};
		$to = "$p{RCPTName}($to)" if $p{RCPTName};
		
		my $line = join("\t",$dir,$p{Created},$period,$auth,$p{ExpireTime},$to,$from,$files,$open,$login,$download);
		push(@sites,"$line\t\n");
	}
	
	# インデックス保存
	if (@sites && open(FILE,">$index")){
			## 0ID 1作成日 2開始/終了 3認証 4有効時間 5送付先 6送付元 7ファイルリスト 8オープン数 9ログイン数 10ダウンロード数
			print FILE @sites;
		close(FILE);
		$count = @sites;
	}
	
	($count,@sites);
}
