### uK4 - メールボックスの管理共通
### key4:MSGリスト開始位置、key5:ソート方法、key6:アドレス帳/添付ファイル処理用
### key7:フォルダ名orファイル名、key8:ソートキー、key9:前へ/次へ、key10:MSGファイル key11:検索
use utf8;
$cgistart = 'mailbox_start.cgi';		# トップページ
$cgiaddress='mailbox_address.cgi';		# アドレス帳管理
$cgidistribute = 'mailbox_distribute.cgi';	# 振り分けの管理
$cgidown = 'mailbox_download.cgi';		# MSGダウンロード
$cgidraft = 'mailbox_draft.cgi';		# 下書き/ひな形MSGリスト
$cgidraftv ='mailbox_draft_view.cgi';	# 下書き/ひな形MSG閲覧
$cgifile = 'mailbox_file.cgi';			# MSG削除/移動
$cgifolder = 'mailbox_folder.cgi';		# フォルダ管理
$cgiforward = 'mailbox_forward.cgi';	# オリジナルのまま転送
$cgimsglist ='mailbox_msg_list.cgi';	# 送受信トレイ・送受信フォルダMSGリスト
$cgimsglist2 = 'mailbox_msg_list2.cgi';	# 非ソートバージョン
$cgimsgrest ='mailbox_msg_rest.cgi';	# 超過分メッセージ管理
$cginew = 'mailbox_new.cgi';			# 新規MSG作成
$cgiprint = 'mailbox_print.cgi';		# 印刷表示
$cgireply = 'mailbox_reply.cgi';		# 返信/転送
$cgisearch = 'mailbox_search.cgi';		# MSG検索
$cgisig = 'mailbox_sig.cgi';			# 署名
$cgispam = 'mailbox_spam.cgi';			# 迷惑メール
$cgispamv = 'mailbox_spam_view.cgi'; 	# 迷惑メールMSG閲覧
$cgitrash = 'mailbox_trash.cgi';		# ごみ箱MSGリスト
$cgitrashv = 'mailbox_trash_view.cgi';	# ごみ箱MSG閲覧
$cgiupload = 'mailbox_upload.cgi';		# 添付Fアップロード
$cgiupload2 = 'mailbox_upload2.cgi';	# ビッグファイル送付
$cgiupload3 = 'mailbox_upload3.cgi';	# ビッグファイル受領
$cgiview = 'mailbox_view.cgi';			# MSG閲覧
$class = "class='doc13'";
$confirm = "onClick=\"if(!confirm('送信してもよろしいですか？')){return false;}\"";
$stop = "<img src='$idir/stop.gif' height=32 width=32 title='警告！'>";
$textstyle = "style='font-size:14px;line-height:$linespace'";
&auth();
$bigfileflag = "../temp/$loginid/.bigfile";	# ビッグファイル送付モードを示すフラグ
$bigfileflag2 = "$tempdir/$loginid/.bigfile2";	# ビッグファイル受領モードを示すフラグ
$bigfilemode = 1 if -f $bigfileflag;
$bigfilemode2 = 1 if -f $bigfileflag2;
$sortflag = "$userdir/temp/.nosort";	# 高速表示モード(非ソート)を示すフラグ
$sortmode = 2 if -f $sortflag;
@formReg = qw(
	key4 key5 key6 key7 key8 key9 key10 key11 key12 startBigfile startBigfile2 stopBigfile stopBigfile2
	Bcc Cc date1 from inreplyto msgid message references subject to RTo 
	attachment1 attachment2 attachment3 attachment4 attachment5 attachment6 attachment7 attachment8 
	attachment9 attachment10 attachment11 attachment12 attachment13 attachment14 attachment15 
	attachment16 attachment17 attachment18 attachment19 attachment20 
	o_p_t_1 created readsig replyall quot1 quot2 sig template fw1 opx1 opx2 opx3
);

## アドレス帳リストを作成
sub addressbook{
	local ($desc,$email,@ad1,@ad2,@ad3);
	my $tab = 'K4.book.tab';
	my $rcpt;
	
	if (open(FILE,"$userdir/$xmailcfg/addressbook.tab")){
			@ad1 = <FILE>;		# 個人用
		close(FILE);
	}
	if ($extstr3){
		foreach my $group (split(/_+/,$extstr3)){
			$group =~ s/^[A-Z]//i;
			my @tmp;
			open(FILE,"$groot/$group/$tab") || next;
				@tmp = <FILE>;	# グループ共有
			close(FILE);
			push(@ad2,@tmp);
		}
	}
	if (open(FILE,"$mailroot/domains/$domain1/k4.book.tab")){
			@ad3 = <FILE>;		# ドメイン共有
		close(FILE);
	}
	for (1 .. 3){
		@{'ad'.$_} = &sorting(1,0,0,@{'ad'.$_});
	}
	
	my $str = ',';				# 重複チェック用
	for my $l (1..3){
		foreach (@{'ad'.$l}){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			if (/^\s*$/ || /^#/){next;}
			($email,$desc) = split(/\t+/,$_);
			my ($email2) = &mod_str($email);
			next if (!$email || $str =~ /,$emai2,/i);
			$str .= $email.',';
			if (!$desc){
				if ($email =~ /^([^<]+)<$emreg1/ || $email =~ /$emreg\s*\((.+)\)/){$desc = $1;}
				else {$desc = $email;}
			}
			$desc =~ s/^"(.+)"\s*$/$1/;
			&htmlconv(qw(desc email));
			my $op = "[共用] " if $l >= 2;
			$rcpt .= "<option value=\"$email\">$op$desc</option>";
		}
	}
	
	$rcpt = "<option value=''>アドレス帳</option>$rcpt" if $rcpt;
	$rcpt;
}


## ビッグファイル送付・受領処理 - 通知メッセージ送信前準備
sub bigfile_1 {
	my ($op) = @_;		# op=1のときは受領処理
	my ($file,$str0,$str1,$str2) = ($bigfileflag,'bigfilemode','送付','送付');
	($file,$str0,$str1,$str2) = ($bigfileflag2,'bigfilemode2','受領','受領サイト') if $op;
	
	my %b = &getenv($file,'=','',1,$charset);
	my $Id = $b{BigfileID};
	my ($dir,$msg,$Message) = ("$tempdir/$loginid/bigfile");;
	
	# 送付・受領メッセージを得る
	if (open(FILE,"$dir/$Id/message.txt")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$Message .= $_;
			}
		close(FILE);
	}
	
	# 処理を中止(アップロード済みファイル等を削除)
	if ($key6 eq 'suspend' || $Message eq '' || (!$op && !glob("$dir/$Id/???????????????*"))){
		rmtree(["$dir"],0,0) if -d $dir;
		unlink($file);
		$$str0 = $Message = '';
		$msg = 'ビッグファイル'.$str1.'モードを中止しました。';
	}
	
	# 送付・受領続行
	else {
		my %p = &getenv("$dir/$Id/profile.txt",'=','',1,$charset);
		my $str = " (大文字・小文字を区別) " if $p{Sensitive};
		$Message =~ s/#+_+pass(word)*_+#+/$p{PassPhrase}$str/gi;
		$Message =~ s/[ \n\r\t]*$/\n\n/;
		$msg = 'メッセージに'.$str2.'案内文を挿入しました。';
	}
	
	# 退避データを復活
	while (my($key,$val) = each %b){
		$$key = $val;
	}
	
	# 送付メッセージを挿入
	$message =~ s/\|\|/\n/g;
	$message = "$Message$message";
	
	$msg;
}

## ビッグファイル送付処理 - 通知メッセージ送信後のファイル格納・ロギング
sub bigfile_2 {
	my ($op) = @_;		# op=1のときは受領処理
	my ($file,$root,$str0,$str1,$str2,$str3) = ($bigfileflag,$bigfileroot,'bigfilemode','送付','送付','bigfile');
	($file,$root,$str0,$str1,$str2,$str3) = ($bigfileflag2,$bigfileroot2,'bigfilemode2','受領','受領サイト','bigfile2') if $op;
	
	my %b = &getenv($file,'=','',1,$charset);
	my ($to2,$bcc2,$cc2) = ($to,$Bcc,$Cc);
	$to2 =~ s/,\s+/,/g;
	$bcc2 =~ s/,\s+/,/g;
	$cc2 =~ s/,\s+/,/g;
	my $Id = $b{BigfileID};
	mkdir("$root/$Id",0755);
	foreach my $file1 (glob("../temp/$loginid/bigfile/$Id/*")){
		my $name = $& if $file1 =~ /[^\/]+$/;
		next if $name =~ /\.html?$/;
		rename($file1,"$root/$Id/$name");
	}
	my $date = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat')[$wday];
	$date .= ", $mday ".('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon];
	my $tza = abs($tz);
	my $tzastr = '-'; $tzastr = '+' if $tz>=0;
	$date .= " $year $hour:$min:$sec ". $tzastr . sprintf("%02s",$tza) . '00';
	open(FILE,">$root/$Id/message.txt");
		print FILE "From: $from\n";
		print FILE "To: $to\n";
		print FILE "Cc: $Cc\n" if $Cc;
		print FILE "Bcc: $Bcc\n" if $Bcc;
		print FILE "Subject: $subject\n" if $subject;
		print FILE "Content-Type: text/plain; charset=\"$charset\"\n";
		print FILE "Date: $date\n";
		print FILE "X-IP: $ENV{'REMOTE_ADDR'}\n";
		print FILE "\n";
		print FILE $message;
	close(FILE);
	open(FILE,">>$root/$Id/profile.txt");
		print FILE "\nSentFrom = $from\n";
		print FILE "SentTo = $to2\n";
		print FILE "SentBcc = $bcc2\n" if $Bcc;
		print FILE "SentCc = $cc2\n" if $Cc;
	close(FILE);
	
	# ロギング
	if (open(FILE,">>$root/$Id/history.txt")){
			flock(FILE,2);
			print FILE "$Id\t$year/$month/$mday $hour:$min:$sec\tcreate\t0\t\t\t";
			print FILE "$ENV{'REMOTE_ADDR'}\t$ENV{'HTTP_REFERER'}\n";
		close(FILE);
	}
	# インデックス削除
	unlink("$tempdir/$loginid/.my_${str3}_site.txt");
}

## メッセージ送信完了
sub complete {
	my $title = '送信完了';
	my $K4 = <<"EOF";
$table1
<tr><td height=30></td></tr>
<tr valign='bottom'><td width=30></td>
<td><img src='$idir/foot_1.gif' width=160 height=152 title='$title' border=0></td>
<td><p class='doc15'>$_[2]</p>
<p><a href='$_[0]?$key4+$key5+0+$key7+$key8'>$_[1] $arrowR</a></p></td></tr>
</table>
EOF
	&print_utf($K4);
	&print_footer();
}

## <前へ/次へ>リンクを作成
sub do_backforward {
	local ($cgi) = @_;
	local ($a1,$a2,$a3,$BF1,$BF2,$page);
	if (!$key6){$key6 = 0;}
	
	undef $BF;
	($a1,$a2) = split(/_/,$key9);
	if ($item * $key4 + $a1 != 1){
		$page = $key4;
		if ($a1 == 1){
			$page--;
			$a3 = $item;
		}
		else {$a3 = $a1 - 1;}
		my $title = '前のメッセージを表示';
		$BF1 = "<img src='$idir/button_back.gif' height=26 width=26 title='$title' border=0><br>前へ";
		$BF1 = "<td nowrap><a href='$cgi?$page+$key5+$key6+$key7+$key8+$a3\_$a2\_'>$BF1</a></td>";
	}
	if ($a2 > $item * $key4 + $a1){
		my ($cgi2,$str,$title) = ($cgi,'次へ','次のメッセージを表示');
		$page = $key4;
		if ($a1 == $item){
			$page++;
			if ($sortmode && !-f "$userdir/temp/msg$sortmode-$key7-$page.lst"){
				($str,$title) = ('次ページ','次のページのメッセージ一覧を表示');
				$cgi2 = "$cgimsglist2?$page+$key5+$key6+$key7+9";
				# 高速表示モードで次ページのインデックスがない場合はMSG一覧へもどる
			} else {
				$a3 = 1;
				$cgi2 .= "?$page+$key5+$key6+$key7+$key8+$a3\_$a2\_";
			}
		} else {
			$a3 = $a1 + 1;
			$cgi2 .= "?$page+$key5+$key6+$key7+$key8+$a3\_$a2\_";
		}
		$BF2 = "<img src='$idir/button_next.gif' height=26 width=26 title='$title' border=0><br>$str";
		$BF2 = "<td nowrap><a href='$cgi2'>$BF2</a></td>";
	}
	if ($BF1 || $BF2){
		$BF = "<table align='right' cellpadding=2 class='doc131' border=0><tr align='center' bgcolor='white'>$BF1$BF2</tr>";
		if ($key9 =~ /^(\d+)_(\d+)/){
			my ($ct,$at) = ($1,$2);
			$cpage = $key4*$item+$ct;
			$BF .= "<tr><td align='center' colspan=2 nowrap>(現 $cpage/$at)</td></tr>";
			$cpage = "($cpage/$at)";
		}
		$BF .= '</table>';
	}
}

## 送信フォームを表示
sub do_form {
	local($bigfile,$rcptBcc,$rcptCc,$rcptfrom,$rcptRTo,$rcptto,$tmp1,$tmp2);
	&htmlconv(qw(from to Cc Bcc RTo));
	
	my $str = "size=45 $nosubmit";
	if($allowmad){
		$str .= " maxlength=1024";
		$allowmad = "<li>送信先(To) や 同報(Cc)、内報(Bcc) はカンマで区切って複数アドレスを指定できます。</li>";
	} else {
		$str .= " maxlength=70";
		$allowmad = '';
	}
	
	&getsiglist($user1,$domain1);
	$siglist =~ s/.+<br>(.+)/$1/i;
	if ($allowattach){
		$attachment1 = "<tr><td height=2></td></tr><tr><td nowrap>&nbsp;添付";
		$attachment1 .= "<font class='doc12'> (Attachment:)&nbsp;</font></td><td colspan=2>";
		$attachment1 .= "<a href='JavaScript:opn_win(\"$cgiupload?___\",440,360)'>";
		$attachment1 .= "添付処理ページを開く$arrowR</a></td></tr><tr><td height=2></td></tr>";
		if ($attachment){				# 転送・再送/ファイルの管理で既存添付ファイルがある場合
			$attachment2 = "<tr><td nowrap>&nbsp;添付<font class='doc12'> (Attachment:)&nbsp;</font></td>";
			$attachment2 .= "<td>$attachment</td></tr>";
		}
	}
	if (($key7 ne $draftbox && $key7 ne $templatebox) && ($allowbigfile || $allowbigfile2)){	# ビッグファイル送付または受領
		$bigfile = "<tr><td height=4></td></tr><tr><td nowrap>&nbsp;[ビッグファイル]&nbsp;</font></td><td>";
		if ($allowbigfile && !$bigfilemode2){		# ビッグファイル送付機能
			if ($bigfilemode){
				$bigfile .= "<input type='submit' name='stopBigfile' value='送付モードを停止 &raquo;'>";
			} else {
				$bigfile .= "<input type='submit' name='startBigfile' value='送付機能を利用 &raquo;'>";
			}
		}
		if ($allowbigfile2 && !$bigfilemode){		# ビッグファイル受領機能
			if ($bigfilemode2){
				$bigfile .= "<input type='submit' name='stopBigfile2' value='受領モードを停止 &raquo;'>";
			} else {
				$bigfile .= " <input type='submit' name='startBigfile2' value='受領機能を利用 &raquo;'>";
			}
		}
		$bigfile .= "</td></tr>";
		if ($bigfilemode){
			$bigfile .= "<tr><td nowrap valign='top'>&nbsp;</td><td class='doc13' colspan=2><font color='#a00000'>";
			my %b = &getenv($bigfileflag,'=','',1,$charset);		# $bigfileflagにビッグファイル処理に関する情報がある
			my %p = &getenv("$tempdir/$loginid/bigfile/$b{BigfileID}/profile.txt",'=','',1,$charset);		# 送付情報がある
			for my $i (1 .. $bigfilemax){
				my $str = 'File'.$i;
				next if $p{$str.'Name'} eq '';
				my $size = $p{$str.'Size'};
				1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
				$bigfile .= "$p{$str.'Name'} (${size}KB)<br>";
			}
			$bigfile .= "</font></td></tr>";
		}
	}
	
	$rcpt = &addressbook();
	if ($rcpt){
		foreach(qw(from to Cc Bcc RTo)){
			${'rcpt'.$_} = "</td><td><font class='doc12'><input $class type='button' value='&laquo;' onclick='ad$_()'></font></td>";
			${'rcpt'.$_} .= "<td><select name='K$_'>$rcpt</select>";
		}
	}
	
	if (!$allowfrom){$allowfrom = "&nbsp;<span class='doc15'>$from</span>";}
	else {
		$allowfrom = "$table1<tr><td><input name='from' value='$from' $str></td>";
		$allowfrom .= "<td>$rcptfrom</td></tr></table>";
	}
	
	my $K4 = <<"EOF";
$table0
<tr><td height=2>
<tr><td $bgcolor3>
	<table cellpadding=0 cellspacing=0 class='doc131' border=0 width='100%'>
	<tr $bgcolor0><td colspan=3 height=1>$null</td></tr>
	$bigfile
	<tr><td height=4></td><td width='100%'></td></tr>
	<tr><td nowrap>&nbsp;送信者<font class='doc12'> (From:)&nbsp;</font></td>
	<td>$allowfrom</td><td rowspan=4 valign='top'>$BF</td></tr>
	<tr><td nowrap>&nbsp;送信先<font class='doc12'> (To:)&nbsp;</font></td>
	<td>$table1<tr><td><input name='to' value="$to" $str></td><td>$rcptto</td></tr></table></td></tr>
	<tr><td nowrap>&nbsp;同報<font class='doc12'> (Cc:)&nbsp;</font></td>
	<td>$table1<tr><td><input name='Cc' value="$Cc" $str></td><td>$rcptCc</td></tr></table></td></tr>
	<tr><td nowrap>&nbsp;内報$fe<font class='doc12'> (Bcc:)&nbsp;</font></td>
	<td>$table1<tr><td><input name='Bcc' value="$Bcc" $str></td><td>$rcptBcc</td></tr></table></td></tr>
	<tr><td nowrap>&nbsp;返信先<font class='doc12'> (Reply-To:)&nbsp;</font></td>
	<td>$table1<tr><td><input name='RTo' value="$RTo" $str></td><td>$rcptRTo</td></tr></table></td></tr>
	<tr><td nowrap>&nbsp;用件$fe<font class='doc12'> (Subject:)&nbsp;</font></td>
	<td colspan=2><input name='subject' value="$subject" size=74 maxlength=1024 $nosubmit></td></tr>
	<tr><td height=4></td></tr>
	<tr><td>&nbsp;署名<font class='doc12'> (Signature:)&nbsp;</font></td><td colspan=2>$siglist</td></tr>
	<tr><td height=2></td></tr>
	$attachment1
	<tr><td height=2></td></tr>
	<tr><td colspan=3><textarea class='doc15' cols=81 rows=21 name='message' wrap='soft'>
EOF
	&print_utf($K4);
	Encode::_utf8_off($message);
	print "$message";
	
	if ($o_p_t_1 >= 2){$bchk2 = 'checked';}
	elsif ($o_p_t_1 == 1){$bchk1 = 'checked';}
	else {$bchk0 = 'checked';}
	
	my $notice1 = "添付ファイル情報";
	$notice1 .= "とビッグファイル情報" if $allowbigfile;
	my $title = 'このメッセージを送信(再確認はありません)';
	$K4 = <<"EOF";
</textarea></td></tr>
	<tr><td height=4></td></tr>
	<tr><td colspan=3><img src='$idir/arrow_red.gif' width=31 height=13 title='$title'> 
	<input type='reset' $class value='リセット'>&nbsp;
	<img src='$idir/arrow_red.gif' width=31 height=13 title='$title'>&nbsp;
	<input type='submit' class='doc17' value='$title'></td></tr>
	<tr><td height=8></td></tr>
	$attachment2
	<tr valign='top'><td align='right' nowrap>$fs7　$fe オプション:</td>
	<td colspan=2>
	$draftop1
	<input type='checkbox' name='opx1' value='1'>フォーム本文の行頭と行末の空白を削除して送信<br>
	<input type='checkbox' name='opx2' value='1'>フォーム本文の空白行を削除して送信<br>
	<input type='checkbox' name='opx3' value='1'>フォーム本文のすべての改行を削除して送信<br>
	<input type='radio' name='o_p_t_1' value='2' $bchk2>送信済みメッセージは$box{$outbox}に入れる<br>
	<input type='radio' name='o_p_t_1' value='1' $bchk1>送信済みメッセージは$box{$inbox}に入れる<br>
	<input type='radio' name='o_p_t_1' value='0' $bchk0>送信済みメッセージは捨てる。<br>
	&nbsp; ---<br>
	<input type='radio' name='o_p_t_1' value='8'>$box{$templatebox}として保存/更新 (${notice1}は保存されません)<br>
	<input type='radio' name='o_p_t_1' value='9'>$box{$draftbox}として保存/更新 (〃) $draftop2</td></tr>
	<tr><td height=4></td></tr>
	<tr><td></form></td></tr>
	$draftop4
	<tr $bgcolor0><td colspan=3 height=1>$null</td></tr>
	</table></td></tr>
<tr><td height=2></td></tr>
</table>
$goback

$table0
<tr><td height=6></td></tr>
<tr><td class='doc13'>
<ul>
$draftop3
$allowmad
<li>メッセージには適切な位置（全角30文字程度）に強制改行を入れることをすすめます。</li>
<li>半角カタカナは全角文字に変換されます。
<div align='right'>$arrowU&nbsp;</div></li>
</ul></td></tr>
</table>
<br>
EOF
	$K4 =~ s/^\s+//;
	&print_utf($K4);
}

## MBox管理メニューを表示
sub do_header {
	# title:メニュータイトル、op1:エラーMSGまたはサブタイトル、op2:検索ウインドウ表示、
	# op3,op4:(空、メールアドレス自動挿入JavaScriptで使用)、op5:画面自動再表示指定
	local($title,$op1,$op2,$op3,$op4,$op5) = @_;
	if ($op5 eq 'refresh'){$op5= "<meta http-equiv='Refresh' content='60'>";}
	else {$op5 = '';}
	if ($op2 =~ /検索/i){
		$op2 = <<"EOF";
$table1
<tr><td><form method='post' action='$cgisearch'></td>
<td>
<input type='hidden' name='key4' value='0'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='0'>
<input type='hidden' name='key7' value='$key7'>
<input type='hidden' name='key8' value='9'>
<input type='hidden' name='f1' value="from">
<input type='hidden' name='f2' value="to">
<input type='hidden' name='f3' value="subject">
<input type='hidden' name='f7' value="message">
$op2 
<input name='keyword' size=20 maxlength=50>
<input type='submit' title='指定キーワードで検索します' value='検索'>
</td>
<td></form></td></tr>
</table>
EOF
	}
	else {$op2 = '';}
	if ($op1 =~ /^\s*-+\s/){
		$op1 = "<b>$op1</b>";		# フォルダ名の表示
	} elsif ($op1){		# エラーメッセージの表示
		$op1 = "<table class='doc15'><tr><td nowrap>&nbsp;$alert</td><td nowrap>$fs5R$op1$fe</td></tr></table>";
		$op2 = '';
	}
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	print "<html><head>$op5$charcss<script type='text/javascript'>";
	print "<!--\nfunction SetChecked(val){dml=document.mList;len=dml.elements.length;var i=0;for(i=0;i<len;i++){";
	print "if(dml.elements[i].name=='delx'){dml.elements[i].checked=val;}}}";
	foreach(qw(from RTo)){print "function ad$_(){k=document.K4.K$_.value;if(k){document.K4.$_.value=k;}}";}
	if ($allowmad){$op3 = '+'; $op4 = "+','";}
	foreach(qw(to Cc Bcc)){
		print "function ad$_(){k=document.K4.K$_.value;l=document.K4.$_.value;m=new RegExp('(^ *|, *)'+k,'i');";
		print "if(l.search(m)==-1){document.K4.$_.value"."$op3".'=k'."$op4;}}";
	}
	print "//--></script></head>";
	
	if ($title ne 'メールボックスの管理'){$title0 = "メールボックスの管理 - $title";} else {$title0 = $title;}
	my $K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4 $cbody0>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'>
<td><a href='$cgistart?0+1'><img src='$idir/letter.gif' width=34 height=24 title='$title0' border=0></a></td>
<td nowrap>&nbsp;$fs7G<b>$title</b>$fe&nbsp;&nbsp;</td>
<td nowrap>$op1</td>
<td align='right' width='100%'>$op2</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=4 height=1>$null</td></tr>
<tr><td height=12></td></tr>
</table>
EOF
	&print_utf($K4);
}

## ビッグファイル受領サイト一覧を得る
sub get_bigfile2 {
	my ($account) = @_;		# $account(メールアドレス)があるときは特定アカウントのデータのみ得る
	my $index = "../temp/$loginid/.my_bigfile2_site.txt";
	my ($count,@sites,@tmp1,@tmp2) = (0);
	$account = lc($account);
	
	# 有効インデックスがある
	if ((stat($index))[9] >= time() - $ttlmidx && open(FILE,$index)){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				chomp;
				push(@tmp1,$_);
				next if !$account;
				my @s = split(/\t/,$_);
				my $owner = lc($s[2]);
				push(@tmp2,$_) if $account eq $owner;
			}
		close(FILE);
		if ($account){@sites = @tmp2;}
		else {@sites = @tmp1;}
		$count = @sites;
		return($count,@sites);
	} else {
		unlink($index);
	}
	
	# インデックス作成
	foreach my $dir (&getdirs($bigfileroot2,"\\w{32}")){
		my $dir2 = "$bigfileroot2/$dir";
		next if !-f "$dir2/profile.txt";
		my %B = &getenv("$dir2/profile.txt",'=','',1);
		my $line = join("\t",$dir,$B{Created},$B{Owner},$B{Start},$B{End},$B{SiteName},$B{Amount},
			$B{Auth},$B{ExpireTime},$B{PassPhrase},$B{Sensitive},$B{Size},$B{Retry},
			$B{RCPTName},$B{OwnerName},$B{HTMLMessage},$B{SentTo});
		push(@tmp1,"$line\n");
		next if !$account;
		my $owner = lc($B{Owner});
		push(@tmp2,$line) if $account eq $owner;
	}
	
	# データ保存
	if (@tmp1 && open(FILE,">$index")){
			## 0サイトID 1作成日 2XMailアカウント 3開始日 4終了日 5サイト名 6ファイル個数
			## 7認証フラグ 8有効秒数 9パスフレーズ 10大文字小文字 11サイズ制限 12認証リトライ回数
			## 13あて先名 14運営者名 15メッセージ 16送付先メールアドレス
			foreach (@tmp1){
				Encode::_utf8_off($_);
				print FILE;
			}
		close(FILE);
		if ($account){@sites = @tmp2;}
		else {@sites = @tmp1;}
		$count = @sites;
	}
	
	($count,@sites);
}

## $key7によりフォルダ情報を得る
sub getfolderinfo {
	my ($folderlist,$foldername,$type);
	
	if ($key7 eq $inbox){$type = $box{$inbox};}
	elsif ($key7 eq $outbox){$type = $box{$outbox};}
	elsif ($key7 =~ /^i/i){$type = '受信フォルダ';}
	else {$type = '送信フォルダ';}
	if ($key7 =~ /^[io]\d+/i){
		($folderlist,$foldername) = &getfolderlist1($key7);
		$foldername = "- $foldername" if $foldername;
	}
	
	($folderlist,$foldername,$type);
}

## 追加フォルダのリストを作成
sub getfolderlist1 {
	my ($folderlist,$foldername);
	my $type = substr($_[0],0,1);
	$type = lc($type);
	my @tmp = &getfolders;
	my @tmp1 = &sorting(1,0,0,@tmp);
	
	foreach(@tmp1){
		my ($name,$exp) = split(/\t/,$_);
		if ($name =~ /^$_[0]$/i){$folderid = $name; $foldername = $exp; next;}
		if ($name =~ /^$type/ || ($type eq 'm' && $name =~/^i/)){$folderlist .= "<option value='$name'>$exp</option>";}
	}
	if ($type eq 'o' && $_[0] ne "$outbox"){$folderlist .= "<option value='$outbox'>$box{$outbox}</option>";}
	if ($type ne 'm'){$folderlist .= "<option value='$inbox'>$box{$inbox}</option>";}
	if ($type eq 'm' || $type eq 'i'){$folderlist .= "<option value='$outbox'>$box{$outbox}</option>";}
	($folderlist,$foldername);
}

## フォーム入力を得る
sub getform {
	# attachmentXは転送時のファイル指定で使用
	# fw1はメッセージをそのまま添付ファイルにするためのフラグ
	&parse_form(@formReg);
	for (1 .. 20){
		if ("${'attachment' . $_}"){
			push(@attachall,"${'attachment' . $_}");
		}
	}
}

## 署名リストを得る
sub getsiglist {
	local($line,$sig,$chk);
	for(1 .. $siglimit){
		$sig = "sig".$_; $sig0 = $sig."t"; $count = 1;
		open(MyFILE2,"$mailroot/domains/$_[1]/$_[0]/$xmailcfg/$sig.tab") || next;
			while ($line = <MyFILE2>){
				$line = &dec_utf($line,$charsetM);
				chomp($line);
				$line =~ s/\s+$//;
				if ($count == 1 && $line =~ /^\[SignatureTitle\] *(.*)/){$$sig0 = $1; $count++; next;}
				if ($line){$chk = 1; last;}
				$count++;
			}
		close(MyFILE2);
		if ($chk && $$sig0){$siglist .= "<option value='$sig'>[署名 $_] $$sig0</option>";}
	}
	if ($siglist){	# $siglist0 は &do_optionで使用
		$siglist0 = "<select name='sig'><option value=''>署名を付加する場合は選択してください</option>$siglist</select>";
		$siglist = "<select name='sig'><option value=''>(選択したものを送信時に自動付加します)</option>$siglist</select>";
		$siglist .= "<input type='submit' name='readsig' $class value='送信前に挿入して再表示'>";
	}
	else {$siglist = "<a href='$cgisig?0+$key5'>新規作成ページを開く$arrowR</a><span class='doc17'> </span>";}
	$siglist = "<br>■署名<br>$siglist";
}

## 個人用アドレス帳を読む
sub readbook {
	my ($type) = @_;
	my ($book,$total,$total1);
	my @reg;
	
	if (!$type){$book = "$userdir/$xmailcfg/addressbook.tab";}
	elsif ($extstr3 && $type =~ /^\d{3}$/){$book = "$groot/$type/K4.book.tab";}
	else {$book = "$mailroot/domains/$type/K4.book.tab";}
	
	if (open(FILE,$book)){
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);	# ファイルはEUCとみなす
			chomp;
			next if (/^[ \t"#]*$/ || /^#/ || !/\@/);
			push(@reg,$_);
			$total++;
		}
		close(FILE);
	}
	if ($total){$total1 = "<b>$total</b> 件";}
	else {$total1 = "(未登録)";}
	
	($total1,@reg);
}

## 再試行
sub retry {
	local($msg) = @_;
	&htmlconv(qw(from message msg subject to Bcc Cc));
	&body($msg,1);		# 1はExpireチェックを停止するため
	exit;
}

## 年選択リスト
sub s_year {
	my ($val) = @_;
	my $select = "<option value=''>▽</option>\n";
	my $start = $year;
	my $end = $year*2-$start+10;
	
	for ($start .. $end){
		my $str = 'selected' if $val eq "$_";
		$select .= "<option $str value='$_'>&nbsp;$_</option>\n";
	}
	$select;
}

## 月選択リスト
sub s_month {
	my ($val) = @_;
	my $select = "<option value=''>▽</option>\n";
	for (1 .. 12){
		$_ = sprintf("%02d",$_);
		my $str = 'selected' if $val eq "$_";
		$select .= "<option $str value='$_'>&nbsp;$_</option>\n";
	}
	$select;
}

## 日選択リスト
sub s_day {
	my ($val) = @_;
	my $select = "<option value=''>▽</option>\n";
	for (1 .. 31){
		$_ = sprintf("%02d",$_);
		my $str = 'selected' if $val eq "$_";
		$select .= "<option $str value='$_'>&nbsp;$_</option>\n";
	}
	$select;
}

## 下書き/ひな形の保存/削除
sub savedraft {
	local($file,$msg1) = @_;
	local($wday) = ('日','月','火','水','木','金','土')[$wday];
	if ($o_p_t_1 == 11 || $o_p_t_1 == 8){$box = $templatebox; $msg1 = 'ひな形';}
	else {$box = $draftbox; $msg1 = '下書き';}
	if (!$from && !$to && !$subject && $message =~ /^\s*$/){
		unlink("$userdir/$box/$file");
		$msg = "1 個の".$msg1."を削除しました。";
		return();
	}
	my $date = "$year/$month/$mday($wday) $hour:$min";
	if (!$file || $o_p_t_1 >= 10){
		$file = time() . ".$box";
		$created = $date;
	} else {$updated = $date;}
	
	## 必要ならBase64エンコード
	my $subject2 = $subject;
	foreach (qw(Cc created Bcc file from message RTo subject to updated)){
		$$_ =~ s/[,\s]+$//;
		Encode::_utf8_off($$_);
		if ($$_ =~ /[^$zstr]/ && /^(Cc|Bcc|from|RTo|subject|to)$/){
			$$_ = '=?'.$charset.'?B?'.encode_base64($$_,'').'?=';
		}
	}
	## UTFで保存
	if (open(FILE,">$userdir/$box/$file")){
			print FILE "file: $file\n";
			print FILE "created: $created\n";
			print FILE "updated: $updated\n";
			print FILE "from: $from\n";
			print FILE "to: $to\n";
			print FILE "subject: $subject\n";
			print FILE "Cc: $Cc\n";
			print FILE "Bcc: $Bcc\n";
			print FILE "RTo: $RTo\n";
			print FILE "Content-Type: text/plain; charset=\"$charset\"\n";
			#print FILE "Content-Transfer-Encoding: 7bit\n";
			if ($inreplyto) {print FILE "inreplyto: $inreplyto\n";}
			if ($msgid)     {print FILE "msgid: $msgid\n";}
			if ($references){print FILE "references: $references\n";}
			print FILE "\n";
			print FILE "$message\n";
		close(FILE);
		
		if (!$subject){$subject = "(無題)";}
		$msg = "&quot;用件: $subject2&quot; &nbsp;のメッセージを<br>$msg1 として保存しました。";
	}
	else {$msg = "$alert $msg1 を保存できませんでした。<br>管理者までご連絡ください。";}
}

## メッセージ送信
sub sendmail {
	&retry("このアカウントでは実行できません！") if $k4fixed;
	local ($count,$signature,$temp,@tmp);
	my %ad = ('from','送信者','to','送信先','Cc','同報先(Cc:)','Bcc','内報先(Bcc:)','RTo','返信先(Reply-To:)');
	
	if ($readsig){		# 署名の挿入再表示
		&retry("署名を選択してください。") if !$sig;
		my ($count,$file) = (1,"$userdir/$xmailcfg/$sig.tab");
		&retry("署名データがありません。") if !-f $file;
		open(FILE,"$userdir/$xmailcfg/$sig.tab");
			while(<FILE>){
				$_ = &dec_utf($_,$charsetM);
				next if ($count == 1 && /^\[SignatureTitle\] */i);
				$signature .= $_;
				$count++;
			}
		close(FILE);
		$signature =~ s/^\n+//;
		$signature =~ s/[ \n\t]+$//;
		if ($signature){
			$message .= "\n\n$signature";
			$msgslimit += length($signature) if $msgslimit;
		}
		&retry("署名を挿入しました。");
	}
	if ($o_p_t_1 >= 8){			# 下書きまたはひな形を保存して終了
		&savedraft($_[0]);
		return $msg;
	}
	
	$from =~ s/[, ]+$//;
	$to =~ s/[, ]+$//;
	if (!$allowfrom){
		$from = "$user1\@$domain1";
		&getenv("$userdir/user.tab",'','1');	# RealNameがあれば得る
		$from = "$RealName <$from>" if $RealName;
	} else {
		&retry("$ad{'from'}アドレスを指定してください。") if (!$from && !$from1);
		&retry("指定できる$ad{'from'}アドレスは 1 つだけです。") if ($from =~ /.+?,\s*.+/);
	}
	&retry("$ad{'to'}を指定してください。") if !$to;
	&retry("指定できる$ad{'RTo'}アドレスは 1 つだけです。") if ($RTo && $RTo =~ /.+?,.+/);
	
	my $ermsg;
	foreach(qw(from to Cc Bcc RTo)){
		next if !$$_;
		next if ($key9 eq 'Fw2' && /Cc|Bcc|RTo/);
		$$_ =~ s/[, ]+$//;
		if (!$allowmad && $$_ =~ /,.+/){$ermsg = "複数の$ad{$_}指定は許可されていません。"; last;}
		my @rep = &emchk($$_);
		if ($rep[1]){$ermsg = "$ad{$_}の $rep[1] が正しくありません。"; last;}
		@{$_.'_'} = split(/,+/,"$rep[0]");
	}
	&retry($ermsg) if $ermsg;
	
	# メッセージファイル($key10)をそのまま転送する場合
	if ($key9 eq 'Fw2'){
		if ($from =~ /^[^<]*<(.+)>/ || $from =~ /^([^\(]+)\(.+\)/){$from = $1;}
		@To = @to_;
		my $msg = &startmail2("$mailroot/domains/$domain1/$user1/$key7/$key10");
		return $msg;
	}
	
	&retry("用件を書いてください。") if !$subject;
	&retry("何かメッセージを書いてください。") if !$message;
	&retry("メッセージ量が制限を超えています。$msgslimit バイト以内にしてください。") if (length($message) > $msgslimit && $msgslimit);
	$subject =~ s/[\n\r\s]+/ /g;
	$message =~ s/\r*\n/\n/g;
	$message =~ s/\r/\n/g;
	$message =~ s/\s*$/\n/;
#	$message =~ s/\n\n+/\n\n/g;
	1 while $message =~ s/( |\t|　)+\n/\n/;
	if ($opx1){1 while $message =~ s/^( |\t|　)+//; 1 while $message =~ s/\n( |\t|　)//;}
	if ($opx2 || $opx3){
		$message =~ s/(\n([ \t]*|(　)*)\n)+/\n/g;
		if ($opx3){$message =~ s/\n//g;}
	}
	
	# 添付ファイルつきメッセージの添付ファイルを添付して返信する場合(@attachallには一時ファイル名が入っている)
	$fileid = time();
	$updir = "$tempdir/$loginid";
	foreach my $file (@attachall){
		$fileid++;
		# 拡張子を得る
		my $ext = $1 if $file =~ /\.([^.]+)$/;
		$ext = lc($ext);
		# オリジナル名を得る
		my @tmp;
		my ($vname,$rname);
		if (open(FILE,"$updir/$file.tmp")){
				@tmp = <FILE>;
			close(FILE);
			my $tmp = shift(@tmp);
			chomp($tmp);
			($vname,$rname) = split(/\t/,$tmp);
		}
		rename("$updir/$file","$updir/upload/$fileid");
		open(FILE,">$updir/upload/$fileid.txt");
			print FILE "$fileid\t$ext\t$rname\t\n";
		close(FILE);
	}
	
	# メッセージをそのまま添付ファイルとして転送する場合
	if ($fw1){
		while (-f "$updir/upload/$fileid"){$fileid++;}
		copy("$mailroot/domains/$domain1/$user1/$key7/$key10","$updir/upload/$fileid");
		open(FILE,">$updir/upload/$fileid.txt");
			print FILE "$fileid\ttxt\tForwarded_Message_$fileid.txt\t\n";
		close(FILE);
	}
	
	# 送信直前処理
	foreach(qw(Bcc Cc from to)){$$_ =~ s/[\s,]+$//; $$_ =~ s/^[\s,]+//;}
	@To = @to_;
	@Cc = @Cc_;
	@Bcc = @Bcc_;
	&startmail;
}

## ビッグファイル送付・受領機能の利用を開始
sub start_bigfile {
	my ($cgi,$arg,$op) = @_;		# op=1のときは受領モード
	my ($flag,$cgi2) = ($bigfileflag,$cgiupload2);
	($flag,$cgi2) = ($bigfileflag2,$cgiupload3) if $op;
	$time = time();
	
	# ビッグファイルダウンロードサイトIDを得る
	my $str = "$user1\@$domain1". time() .$ENV{'REMOTE_ADDR'}.$ENV{'HTTP_REFERER'};
	my $BigfileID = md5_hex $str;
	
	# メッセージデータの改行を変換
	$message =~ s/\n/\|\|/g;
	$message =~ s/[\s\|]+$//;
	open(FILE,">$flag");
		print FILE "BigfileID = $BigfileID\n";
		print FILE "BackTo = $cgi\n";
		print FILE "BackArg = $arg\n";
		print FILE "Time = $time\n";
		foreach my $i (@formReg){			# 現在のフォームデータを退避
			Encode::_utf8_off($$i);
			print FILE "$i = $$i\n";
		}
	close(FILE);
	
	print "Location: $cgi2?$BigfileID\n\n";
	exit;
}

## ビッグファイル送付・受領モードを抜ける
sub stop_bigfile {
	my ($op) = @_;		# op=1のときは受領モード
	my ($flag,$str,$str2) = ($bigfileflag,'bigfilemode','送付');
	($flag,$str,$str2) = ($bigfileflag2,'bigfilemode2','受領') if $op;
	
	my %b = &getenv($flag,'=','',1,$charset);
	my $dir = "$tempdir/$loginid/bigfile/$b{BigfileID}";;
	
	# アップロード済みファイル等を削除
	rmtree(["$dir"],0,0) if -d $dir;
	
	# 情報ファイルを削除
	unlink($flag);
	$$str = '';
	$str2 = 'ビッグファイル'.$str2.'モードを停止しました。';
	&retry($str2);
}

## メッセージリスト取得(ソート対応版、ひな形と下書きでは使用しない)
sub view_list {
	local($mbox,$cgi,$msg) = @_;	# $msgはエラー表示用
	my $mbox2 = $mbox;
	$mbox2 =~ s/\//-/g;
	my $index  = "$userdir/temp/msg-$mbox2.lst";
	my $index2 = "$userdir/temp/msg-$mbox2-rest.lst";
	$rest = '';			# $maxmsgfile超過分メッセージ存在フラグ
	@all = @reg = ();
	
	# 全メッセージを取得
	if ((!$slogin || $k4fixed) && 
		(stat($index))[9] >= time() - $ttlmidx && open(FILE2,$index)){		# 有効インデックス存在
			while (<FILE2>){
				$_ = &dec_utf($_,$charset);
				push(@reg,$_);
			}
		close(FILE2);
		@all = @reg;
		$rest = 1 if -f $index2;
	} else {						# さもなければインデックスを作成
		my @tmp = glob("$userdir/$mbox/*.*");
		if (!@tmp){
			$nomsg = "<tr><td align='center' colspan=7 height=120>"."$msg"."は空です。";
			$total = 0;
			return();
		}
		
		@tmp = reverse(@tmp);
		# 総数が制限を越えていれば
		if ($maxmsgfile && @tmp > $maxmsgfile){
			$rest = 1;
			@all = splice(@tmp,0,$maxmsgfile);
			if ($mbox ne 'spam'){
				open(F2,">$index2");	# 通常メールなら別途保存
					flock(F2,2);
					foreach(@tmp){
						print F2 "$_\n";
					}
				close(F2);
			} else {					# 迷惑メールなら削除
				foreach (@tmp){unlink($_);}
			}
		} else {
			@all = @tmp;
		}
		
		if ($mbox eq 'spam'){			# 30日より古いスパムは削除
			my $time = time();
			@tmp = ();
			foreach my $file (@all){
				my $stamp = (stat($file))[9];
				if (($time-$stamp)/(60*60*24) > $expirespam){
					unlink($file);
					next;
				}
				push(@tmp,$file);
			}
			@all = @tmp;
		}
		
		# インデックス作成
		@reg = &msg_list(@all);
		if (@reg){
			my @tmp = @reg;
			open(MyFILE2,">$index");
				foreach (@tmp){
					Encode::_utf8_off($_);
					print MyFILE2;
				}
			close(MyFILE2);
		} else {
			unlink($index,$index2);
		}
	}
	
	$total = @all;
	
	# 改ページリンクを作成
	if ($total <= $item*$key4 || ($maxmsgfile && $maxmsgfile <= $item*$key4)){$key4--;}
	if ($total > $item){&makelink($cgi);}
	if ($cgi eq $cgidraft){return();}
	
	# ソート
	if ($key8 == 5){@reg = &sorting($key8,0,'num',@reg);}
	elsif ($key8 =~ /^[0-3]$/ && $key8 ne ''){@reg = &sorting($key8,0,0,@reg);}
	if (!$key5){@reg = reverse(@reg);}
	
	# 表示部分を抜き出す
	splice(@reg,$item*$key4,$item);
}

## ヘッダ情報の表示
sub viewheader {
	local ($tmp) = @_;
	return() if (!$tmp || !$showheader);
	&htmlconv('tmp');
	$tmp =~ s/[\n\r\s]+$//;
	$tmp =~ s/\n/<br>/g;
	$tmp =~ s/\t/    /g;
	$tmp =~ s/  / &nbsp;/g;
	$tmp =~ s/,([^\s])/, $1/g;
	$tmp =~ s/[\w\-]+:\s+/<font color='#a06060'>$&<\/font>/g;
	my $str = "<span class='doc13'>【参考】 このメッセージのヘッダ情報</span><br>";
	$str .= "<span class='doc12'>$tmp";
	$str .= "<div align='right'>$arrowU</div></span>";
	Encode::_utf8_off($str);
	print $str;
}

1;
