#!C:/usr/perl/bin/perl.exe

### uK4 - メッセージの削除/移動/コピー/インデックスの削除
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use File::Copy;
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";

if (@ARGV){
	&log('r','?','?','?','run','不正実行',"$0");
	&redirect();
}

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	&redirect if $k4envstr =~ /,$name,/;
	$value =~ tr/+/ /;
	$value =~ s/%([\da-fA-F][\da-fA-F])/pack("C", hex($1))/eg;
	if ($name =~ /^delx/){push(@reg,"$value"); next;}
	$$name = $value;
}

$tdir = "$userdir/temp";
@DELindex = ($key7);		# 削除インデックス情報

if ($op eq 'del'){			# 削除/ごみ箱移動
	$url = "$script?$key4+$key5+0+$key7+$key8";
	if (!@reg || $k4fixed){print "Location: $url\n\n"; exit;}
	elsif ($key7 =~ /^($draftbox|$spambox|$trashbox)$/ || $quick eq 'y' || $deltype){
		foreach (@reg){
			unlink("$userdir/$key7/$_");
		}
	}
	elsif ($movetype){
		foreach(@reg){
			next if -f "$userdir/$to/$_";
			copy("$userdir/$key7/$_","$userdir/$to/$_");
			unlink("$userdir/$key7/$_");
			if ($to eq $inbox && -e $tdir){
				open(FILE,">$tdir/$_") && close(FILE);	# 既読にしておく
			}
		}
		push(@DELindex,$to);
	}
	else {
		mkdir("$userdir/$trashbox",0755);
		my $str = $key7;
		$str =~ s/\//-/;	# Maildir/new対策
		foreach (@reg){
			copy("$userdir/$key7/$_","$userdir/$trashbox/$key7\_$_");
			unlink("$userdir/$key7/$_");
		}
		push(@DELindex,$trashbox);
	}
	&updateSearchIndex(@reg) if $script eq $cgisearch;
	print "Location: $url\n\n";
}
elsif ($op eq 'move'){						# フォルダ間移動/コピー
	# 同名ファイルがある場合は実行しない
	if (!-f "$userdir/$to/$msgfile" && !$k4fixed){
		open(F1,">$userdir/$to/$msgfile");
			flock(F1,2);
			open(F2,"$userdir/$from/$msgfile");
				while(<F2>){print F1 "$_";}
			close(F2);
		close(F1);
		push(@DELindex,$from,$to,'rest');
		if ($move eq 'move'){
			unlink("$userdir/$from/$msgfile");
		}
		if ($to eq $inbox && -e $tdir){
			open(FILE,">$tdir/$msgfile") && close(FILE);	# 既読にしておく
		}
	}
	&updateSearchIndex("$msgfile") if $script eq $cgisearch;
	print "Location: $script?$key4+$key5+0+$from+$key8\n\n";
}

## インデックス削除
my %count;
@DELindex = grep(!$count{$_}++, @DELindex);
&refresh_index(@DELindex);

exit;

### -----------------------
sub updateSearchIndex {
	my @tmp = @_;
	my $file = "$userdir/temp/msg$sortmode-search.lst";
	my ($chk,$tmp,@tmp1);
	
	if (open(FILE,"$file")){
		while(<FILE>){
			$chk = '';
			foreach $tmp (@tmp){
				$tmp =~ s/[.\-]/\\$&/g;
				if (/\t$tmp\t/){$chk = 'y'; last;}
			}
			if (!$chk){push(@tmp1,"$_");}
		}
		close(FILE);
	}
	if (@tmp1 && open(FILE,">$file")){
			flock(FILE,2);
			print FILE @tmp1;
		close(FILE);
	}
	else {unlink($file);}
}
