#!C:/usr/perl/bin/perl.exe

### uK4 - フォルダの管理
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";
@array = qw(id folder newname into);

## 初期表示/再表示
if (@ARGV){
	if ($key4 eq 'refresh'){&tophtml();}
	if ($key8 eq 'del'){
		if ($k4fixed){&body("このアカウントでは削除できません！",1);}
		&removefolder();
	}
	&body();
}

## フォーム入力を処理
&parse_form(@array);
foreach(@array){
	$$_ =~ s/\t+/ /g;
	$$_ =~ s/^\s+//;
	$$_  =~ s/\s+$//;
	if ($$_ eq '#'){$$_ = '';}
}

# 未入力フィールドのチェック
if ($k4fixed){&body("このアカウントでは作成/変更できません！",1);}
if ($id eq 'new'){				# 新規作成
	if (!$folder){&body("フォルダ名を書いてください！",1);}
	if ($into eq ''){&body("作成先を選択してください！",1);}
}
else {							# 名前変更
	if ($folder eq ''){&body("フォルダを選択してください！",1);}
	if (!$newname){&body("新しい名前を指定してください！",1);}
}

# 更新
&getfolderstat("update");
if ($id eq 'new'){
	($exp) = &mod_str($folder);
	if ($into eq 'i'){@reg = @ifolder;} else {@reg = @ofolder;}
	if (grep(/^[^\t]+\t+$exp$/i,@reg)){&body("同名フォルダが存在します！",1);}
	for (1 .. $folderlimit){
		$n = "$into". sprintf("%02s",$_);
		if (grep(/^$n\t/i,@reg)){next;}
		else {
			push(@flist,"$n\t$folder");
			last;
		}
	}
	if (!@flist){&body("フォルダを作成できませんでした！ 管理者にご連絡ください。",1);}
	push(@flist,@ifolder);
	push(@flist,@ofolder);
	@flist = sort(@flist);
	$msg = "フォルダを追加しました。";
}
else {
	push(@flist,@ifolder);
	push(@flist,@ofolder);
	foreach (@flist){
		if (/^$folder\t+(.+)/i){$_ = "$folder\t$newname";}
		push(@flist0,"$_");
	}
	@flist = @flist0;
	$msg = "フォルダをリネームしました。";
}

# 保存、フォルダ作成
open(FILE,">$userdir/$xmailcfg/folder.tab") || &body("フォルダを作成できませんでした！ 管理者にご連絡ください。",1);
	flock(FILE,2);
	foreach(@flist){
		Encode::_utf8_off($_);
		Encode::from_to($_,$charset,$charsetE);		# EUCで保存(XMailCFGでも参照するので)
		print FILE "$_\n";
	}
close(FILE);
if ($id eq 'new'){
	mkdir("$userdir/$n",0755);
	if (!-e "$userdir/$n"){&body("フォルダを作成できませんでした！ 管理者にご連絡ください。",1);}
}

# 終了
&finished($msg);
exit;

# --------
sub body {
	if ($Expired && !$_[1]){&expire($_[0]);}
	&do_header("フォルダの管理","$_[0]");
	&getfolderstat();
	
	my $K4 = <<"EOF";
$table0
<tr><td>送受信フォルダの作成/変更/削除</td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr><td $bgcolor3>
	<table class='doc131'>
	<tr><td height=4></td></tr>
	$makefolder
	$renaming
	<tr><td height=4></td></tr>
	</table></td></tr>
<tr><td></form></td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
</table>

$table0
<tr><td $bgcolor3>
	<table cellpadding=4 cellspacing=0 class='doc131' border=0>
	<tr><td height=4></td></tr>
	<tr><td colspan=2 nowrap>
	<img src='$idir/folder.gif' height=18 width=20 title='受信フォルダ'> 受信フォルダ</td>
	<td width=10></td>
	<td colspan=2 nowrap><img src='$idir/folder.gif' height=18 width=20 title='送信フォルダ'> 送信フォルダ</td></tr>
	<tr valign='top'><td $bgcolor0 width=15><br></td><td nowrap>$ifolder</td>
	<td></td><td $bgcolor0 width=15><br></td><td nowrap>$ofolder</td></tr>
	</table></td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr><td $bgcolor3></td></tr>
<tr><td height=6></td></tr>
</table>

$table0
<tr><td class='doc13'><ul>
<li>フォルダ名には全半角のすべての文字が使えます。ただし半角カタカナは全角文字に変換されます。</li>
<li>作成できるフォルダは受信用/送信用とも最大 $folderlimit 個です。</li>
<li><img src='$idir/folder1.gif' height=17 width=23 title='フォルダを開きます' border=0> 
フォルダアイコンまたはフォルダ名のリンクをクリックするとメッセージ一覧を表示します。</li>
<li><img src='$idir/trash.gif' height=16 width=16 title='削除用アイコンです' border=0> 
ごみ箱アイコンをクリックするとそのフォルダを内部のメッセージとともに削除します。<br>
削除したくないメッセージは個々のフォルダを開き、他のフォルダまたはごみ箱に移動してください。</li>
$gotop
</ul></td></tr>
</table>
EOF
	&print_utf($K4);
	&print_footer();
	&exit();
}

sub finished {			# 完了時リンク表示
	local($msg) = @_;
	
	&do_header("フォルダの管理");
	my $K4 = <<"EOF";
<table cellpadding=1 cellspacing=0 class='doc131' border=0 width='100%'>
<tr $bgcolor0><td height=1>$null</td></tr>
<tr><td align='center' $bgcolor1 height=120>
<p>$fs7 $msg $fe</p>
<p><a href='$cgifolder?refresh' target='_parent'><u>&nbsp;メニューを再表示します。</u></a></p></td></tr>
<tr $bgcolor0><td height=1>$null</td></tr>
</table>
EOF
	&print_utf($K4);
	&print_footer();
}

sub getfolderstat {		# フォルダ情報を取得
	local($allfolders,$count,$exp,$f,$file,$name,$target,$tmp,@aifolder,@aofolder,@tmp);
	local($arg) = "0+1+0";
	@aifolder = ('ifolder','受信',$cgimsglist);
	@aofolder = ('ofolder','送信',$cgimsglist);
	undef $ifolder;
	undef $ofolder;
	undef @ifolder;
	undef @ofolder;
	
	if (open(FILE,"$userdir/$xmailcfg/folder.tab")){
		while(<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			if (!/\t/ || /^[^io]/i || /^[ \t"]*$/){next;}
			s/</&lt;/g;
			s/>/&gt;/g;
			s/"/&quot;/g;
			($name,$exp) = split(/\t+/,"$_");
			$exp =lc($exp);
			if (!-e "$userdir/$name"){next;}
			elsif (/^i/i){push(@ifolder,"$exp\t$_");}
			elsif (/^o/i){push(@ofolder,"$exp\t$_");}
			else {}
		}
		close(FILE);
	}
	
	foreach ('ifolder','ofolder'){
		if (@{$_}){
			foreach $f (sort(@{$_})){
			$count = 0;
				($tmp,$name,$exp) = split(/\t+/,"$f");
				push(@{$_ . '_tmp'},"$name\t$exp");
				foreach(glob("$userdir/$name/*.*")){$count++;}
				$$_ .= <<"EOF";
<a href='$cgifolder?$arg+$name+del' $confirm1>
<img src='$idir/trash.gif' height=16 width=16 title='このフォルダを削除します' border=0></a> - 
<a href='${'a'. $_}[2]?$arg+$name+9'>
<img src='$idir/folder1.gif' height=17 width=23 title='このフォルダを開きます' border=0> 
$exp($count)</a><br>
EOF
				$allfolders .= "<option value='$name'>(${'a'. $_}[1]) $exp</option>";
			}
		}
		else {$$_ = "(未作成)";}
	}
	
	if ($_[0] eq 'update'){
		@ifolder = @ifolder_tmp;
		@ofolder = @ofolder_tmp;
		return();
	}
	
	if ($#ifolder < $folderlimit - 1){$target = '<option value="i">受信フォルダ内</option>';}
	if ($#ofolder < $folderlimit - 1){$target .= '<option value="o">送信フォルダ内</option>';}
	if ($#ifolder >= 20 || $#ofolder >= 20){$gotop = "<div align='right'>$arrowU</div>";}
	
	if ($allfolders){
		$renaming = <<"EOF";
<tr><td><form method='post' action='$cgifolder' $nosubmit></td>
<td><input type='hidden' name='id' value='rename'>
<input type='submit' value='名前変更' $class></td>
<td><select name='folder'><option value='#'>フォルダを選択</option>$allfolders</select> 
$arrowR <input name='newname' value='$newname' size=40 maxlength=$maxchars></td>
<td></form></td></tr>
EOF
	}
	if ($target){
		$makefolder = <<"EOF";
<tr><td><form method='post' action='$cgifolder' $nosubmit></td>
<td><input type='hidden' name='id' value='new'>
<input type='submit' value='新規作成' $class></td>
<td><input name='folder' value='$folder' size=40 maxlength=$maxchars> 
<select name='into'>
<option value='#'>作成先を選択</option>
$target
</select></td><td></form></td></tr>
EOF
	}
}

sub removefolder {
	my $file = "$userdir/$xmailcfg/folder.tab";
	if (open(FILE,"$file")){
		while(<FILE>){
			chomp;
			if (!/\t/ || /^[^io]/i || /^[ \t"]*$/){next;}
			if (/^$key7\t/i){next;}
			push(@reg,"$_\n");
		}
		close(FILE);
	}
	
	open(FILE,">$file");
		flock(FILE,2);
		print FILE @reg;
	close(FILE);
	
	if (-e "$userdir/$key7"){rmtree(["$userdir/$key7"],0,0);}
	&finished("フォルダを削除しました。");
	exit;
}

sub tophtml {
	if (!$k4framesize){$k4framesize = 38;}
	if (!$framesize){$framesize = $framesize0;}
	
	print "Content-type: text/html; charset=$charset\n\n";
	print <<"EOF";
<html>
<head>
$nocache
<title>$ttitle</title>
</head>
<frameset rows='$k4framesize,*' border=0 frameborder=0 framespacing=0>
	<frame src='menu.cgi?___' marginheight=0 marginwidth=0 noresize scrolling='no' noresize>
	<frameset cols='$framesize,*' border=0 frameborder=0 framespacing=0>
		<frame src='menu1.cgi?___' name='menu' marginheight=2 marginwidth=2 scrolling='auto' noresize>
		<frame src='mailbox_folder.cgi?0+1' name='main' marginheight=20 marginwidth=15 scrolling='auto' noresize>
	</frameset>
</frameset>
</html>
EOF
	exit;
}
