#!C:/usr/perl/bin/perl.exe

### uK4 - 自動応答メッセージを作成/編集する
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
use CGI_Lite;
require "./config.cgi";
$cgi  = "autoreply.cgi";
$colmax = 76;				# 最大カラム数
$datmax = 10000;			# 最大データ量
$autoreplylist = 'autoreplylist.tab';
$autoreplytab = 'autoreply.tab';
@array = qw(AutoReply autoreply noreply message option);
&auth();

## 初期表示
if (@ARGV){
	&readmessage();
	&getenv("$userdir/$xmailcfg/config.tab",'=',1);
	foreach(@k4array){
		if (!/^Notify/ && !/^Net/ && !/^k4mlist/ && $$_ eq ''){$$_ = 0;}
	}
	$autoreply = $AutoReply;
	&html();
}

## フォーム入力を処理
&parse_form(@array);
&html("このアカウントでは保存できません！",1) if $k4fixed;
$autoreply += 7 if ($autoreply && !$option);

if ($noreply){
	&zenhan("noreply") if $noreply =~ /[^$zstr]/;
	$noreply =~ s/^[,\s]+//;
	$noreply =~ s/[,\s]+$//;
	$noreply =~ s/[,\s]+/,/g;
	&html("応答しないアドレスに不適切な文字が含まれています！",1) if $noreply =~ /[^\w,.\-\@]/i;
}
if ($message){
	@reg = split(/[\r\n]+/,$message);
	foreach(@reg){
		chomp;
		&html("1行の長さが制限を超えています！ $colmax バイト以内にしてください。",1) if length($_) > $colmax;
	}
	&html("テキスト量が制限を超えています！ $datmax バイト以内にしてください。",1) if length($message) > $datmax;
	$message =~ s/^\n+//;
	$message =~ s/\s*$/\n/;
}

# 応答済み記録の削除
unlink("$userdir/$xmailcfg/$autoreplylist") if !$autoreply;

# 保存(euc)
my ($noreply2,$message2) = ($noreply,$message);
Encode::_utf8_off($message2);
Encode::_utf8_off($noreply2);
Encode::from_to($message2,$charset,'JIS');
Encode::from_to($noreply2,$charset,'JIS');
open(FILE,">$userdir/$xmailcfg/$autoreplytab");
	flock(FILE,2);
	print FILE "[noreply] $noreply2\n";
	print FILE $message2;
close(FILE);

if ($AutoReply != $autoreply){
	$AutoReply = $autoreply;
	&saveenv('k4',$domain1,$user1,'AutoReply');
}
&html("自動応答の指定を保存しました。");

## ページを表示 --------------------------------
sub html {
	my ($emsg) = @_;
	$emsg = "$alert $fs5R $emsg $fe" if $emsg;
	if ($Expired && !$_[1]){&expire($_[0]);}
	&htmlconv(qw(message noreply));
	my $a4 = 'checked';
	if ($autoreply > 7){
		$autoreply -= 7;
		$a4 = '';
	}
	if ($autoreply == 1){$a1 = 'checked';}
	elsif ($autoreply){$a2 = 'checked';}
	else {$a3 = 'checked';}
	my $na = $nofilter if -f "$tempdir/$nf";
	
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "<html><head>$charcss</head>";
	
	my $title = '自動応答の指定';
	$K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc13' topmargin=10 leftmargin=4 marginheight=10 marginwidth=4 $cbody0>
<form method='post' action='$cgi'>
<input type='hidden' name='AutoReply' value="$AutoReply">
$table1
<tr><td>
	$table1
	<tr><td><img src='$idir/autoreply.gif' width=31 height=24 title='$title'></td>
	<td nowrap valign='bottom'>&nbsp;$fs7<b>$title</b>$fe &nbsp;$na $emsg</td></tr>
	</table></td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=2 height=1>$null</td></tr>
<tr><td height=16></td></tr>
<tr><td>
	$table1
	<tr><td $bgcolor0 height=3>$null</td></tr>
	<tr><td $bgcolor3>
		<table cellpadding=4 cellspacing=0 class='doc131' border=0>
		<tr><td>■自動応答:<br>
		&nbsp; <input type='radio' name='autoreply' $a1 value='1'> 実行する 
		- 同じ相手からは最初の 1 回だけ応答する。<br>
		&nbsp; <input type='radio' name='autoreply' $a2 value='2'> 実行する 
		- すべてのメッセージに毎回応答する。<br>
		&nbsp; <input type='radio' name='autoreply' $a3 value='0'> 実行しない<br>
		&nbsp; <input type='checkbox' name='option' $a4 value='1'> 受信メッセージを引用する。</td></tr>
		<tr><td>■応答しないアドレス:<br>
		<input name='noreply' size=78 maxlength=200 value='$noreply' $nosubmit></td></tr>
		<tr><td>■応答メッセージ本文:<br>
		<textarea name='message' cols=77 rows=7 wrap='soft'>
EOF
	
	&print_utf($K4);
	print "$message";
	
	$K4 = <<"EOF";
</textarea></td></tr>
		</table></td></tr>
	<tr><td $bgcolor0 height=3>$null</td></tr>
	<tr><td><br>
	<input type='submit' value='　この内容で保存　'>$fe
	$hr</td></tr>
	<tr><td class='doc13'>
	<ul>
	<li>メッセージが到着したとき自動的に定型文メッセージで応答するのが自動応答です。
	休暇などでメッセージを長期間チェックできないときや商品情報を自動送信するときなどに利用できます。</li>
	<li>応答しないアドレスとは、たとえばメーリングリストなどです。
	半角カンマで区切って複数のアドレスを指定することができます。</li>
	<li>同一アドレスからの応答を最初の一回だけにしている場合、
	設定を一度解除すると応答済みアドレス情報はクリアされます。</li>
	<li>応答メッセージ本文は 1 行あたり $colmax バイト以内にしてください。</li>
	</ul>
	</td></tr>
	</table></td></tr>
</table>
</form>
EOF
	&print_utf($K4);
	&print_footer();
	&exit();
}

sub readmessage {
	local($count) = 0;
	open(FILE,"$userdir/$xmailcfg/$autoreplytab") || return();
		while(<FILE>){
			$count++;
			$_ = &dec_utf($_,'JIS');
			chomp;
			s/</&lt;/g;
			s/>/&gt;/g;
			if ($count == 1 && /^\[noreply\] *(.*)$/i){$noreply = $1; next;}
			$message .= "$_\n";
		}
	close(FILE);
	$message =~ s/^\n+//;
	$message =~ s/\s*$/\n/;
	$noreply =~ s/^[,\s]+//;
	$noreply =~ s/[,\s]+$//;
	$noreply =~ s/[,\s]+/,/g;
}
