#!c:/usr/perl/bin/perl.exe

### uK4 - BBS新記事を投稿する
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use MIME::Base64;
use Net::SMTP;
use utf8;
require './config.cgi';
require './bbs_common.cgi';
$cgi1  = 'bbs_post_article.cgi';
$cgi2  = 'bbs_articles.cgi';		# もどり先
$flagF = "$tempdir/$loginid/$ip";	# 重複登録防止用フラグファイル
$flagT = 10;						# 同、有効時間

### 初期表示
if (@ARGV){
	($bbsid,$field,$method,$page) = @ARGV;
	%bbs = &get_bbs_profile($bbsid);	# 掲示板情報を得る
	$maxsize = $bbs{Size};				# アップロードファイルサイズ
	$maxsize = $bbsmaxupload if !$maxsize;
	$FName = $handle;
	&html();
}

### フォーム処理
%f = &get_form2();
while (($key,$value) = each %f){
	next if $key =~ /^file/;
	&redirect if $k4envstr =~ /,$key,/;
	$$key = $value;
	&zenhan($key);
	1 while $$key =~ s/^(\s|　)+//;
	1 while $$key =~ s/(\s|　)+$//;
	if ($key eq 'Text'){
		$$key =~ s/\r*\n/\n/g;
		$$key =~ s/\n\n+/\n\n/g;
		next;
	}
	$$key =~ s/[\r\n]//g;
	$$key =~ s/\t+/ /g;
}

($bbsid,$field,$method,$page) = split(/\+/,$arg);
%bbs = &get_bbs_profile($bbsid);

## エラー処理
&html("ゲストアカウントでは投稿できません！",1) if $k4fixed;
&html("指定もれ(${r}マーク)があります。",1) if (!$Title || !$FName || !$Text);
&html("ハンドル名にあなたのメールアドレスを書くことはできません。",1) if $FName =~ /$user1\@$domain1/i;

## 多重登録防止
if (-f $flagF && time() - (stat($flagF))[9] < $flagT){
	print "Location: $cgi2?$arg\n\n";
	exit;
}

## 関連フォルダを作成
$target = "$bbsroot/$bbsid/articles/$year-$month";
mkdir($target, 0755);

## ファイルアップロード/ウイルススキャン
$saved = &upload($f{file1}) if -s "$tempdir/temp/$f{file1}";

## 投稿IDを決定/ファイル情報を保存
$aID = &get_article_id("$bbsroot/$bbsid/$counter");
if ($saved){
	Encode::_utf8_off($saved);
	Encode::from_to($saved,$charset,$charsetE);
	if (open(FILE,">$bbsroot/$bbsid/articles/files/$aID.txt")){
			flock(FILE,2);
			print FILE "$saved\n";
		close(FILE);
	}
}

## 投稿を保存(EUCで)
foreach (qw(FName Title Text)){
	${$_.2} = $$_;
	Encode::_utf8_off(${$_.2});
	Encode::from_to(${$_.2},$charset,$charsetE);
}
open(FILE,">$target/$aID.article");
	print FILE <<"EOF";
BBS: $bbsid
Part: $year-$month
ArticleID: $aID
Created: $date_5
IP: $ENV{'REMOTE_ADDR'}
From: $user1\@$domain1
FName: $FName2
Priority: $pri
Notify: $bbs{Notify}
Title: $Title2

$Text2
EOF
close(FILE);

## 重複登録防止用フラグファイル
open(FILE,">$flagF") && close(FILE);

## 通知/ロギング
$aid = sprintf("%05d",$aID);
$logstr = "$FName($user1\@$domain1) が記事「$Title($aid)」を新規投稿しました。";
Encode::_utf8_off($logstr);
Encode::from_to($logstr,$charset,$charsetE);
&logging("$bbsroot/$bbsid/logs/bbs.txt",$logstr);
if ($bbs{Notify}){
	my $str1 = " <$user1\@$domain1>" if $bbs{DispEmail};
	# 通知メッセージ作成
	my $Pri0 = '普通';
	$Pri0 = '最重要' if $pri == 2;
	$Pri0 = '重要' if $pri == 1;
	my $notice1 = "■ファイルがアップロードされています。\n" if $saved;
	$message = <<"EOF";
$FName が新しい記事を書きました。
----------------
■日時
$date_2
■掲示板
$bbs{Title}($bbsid)
■投稿者
$FName$str1
■記事番号
$aid
■タイトル
$Title
■重要度
$Pri0
$notice1■投稿本文
$Text
----------------
* このメッセージに返信しないでください。
* 関連発言は掲示板で行ってください。
EOF
	
	$msg = &notify_bbs($bbsid,$message,$bbs{NotifyTag},$bbs{NotifySender},$bbs{NotifyTo},$bbs{OwnersEmail});
	$msg = "<br>$msg" if $msg;
}

## 終了処理
unlink("$bbsroot/$bbsid/articles.txt");		# インデックス更新
open(FILE,">$target/$aID.read");
	flock(FILE,2);
	print FILE $userid ."\t". time() ."\n";
close(FILE);
&complete("記事番号は #$aid です。$msg");

### -------------------------------------------
sub html {
	my ($error,$op3) = @_;
	&expire($error) if ($Expired && !$op3);
	$arg = "$bbsid+$field+$method+$page";
	$select_pri  = &get_priority($pri);
	&htmlconv(qw(Title Text text1));
	my $cnf = "onClick=\"if(!confirm('この記事を投稿してもよろしいですか？')){return false;}\"";
	
	&print_common($error);
	
	print <<"EOF";
<table cellpadding=1 cellspacing=0 class='doc13' border=0>
<form action='$cgi1' method='post' ENCTYPE='multipart/form-data'>
<input type='hidden' name='arg' value='$arg'>
<input type='hidden' name='maxsize' value='$maxsize'>
<tr $bgcolor3><td nowrap>記事のタイトル:$r&nbsp;</td><td><input name='Title' size=81 maxlength=256 $nosubmit value="$Title"></td></tr>
<tr><td>ハンドル名:$r</font></td><td><input name='FName' size=30 maxlength=128 value='$FName'></td></tr>
<tr $bgcolor3><td>重要度:</td><td><select name='pri'>$select_pri</select></td></tr>
<tr><td colspan=2>記事:$r</td></tr>
<tr><td colspan=2><textarea class='doc15' name='Text' cols=75 rows=13 wrap='soft'>$Text</textarea></td></tr>
<tr><td height=4></td></tr>
<tr><td><input type='reset' value='リセット'></td>
<td align='right'><input type='submit' value='この記事を投稿する' $cnf></td></tr>
<tr><td height=4></td></tr>
EOF
	
	# ファイルアップロード可能なら
	if ($bbsallowupload && $bbs{'Upload'}){
		my $size = $maxsize;
		1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
		print "<tr $bgcolor3><td nowrap>ファイルの<br>アップロード:</td>";
		print "<td><input type='file' name='file1' size=30 $nosubmit><br>\n";
		print "<input name='text1' size=30 maxlength=100 $nosubmit value='$text1'> (ファイルの説明)</td></tr>\n";
		print "<tr><td height=4></td></tr>\n";
		print "<tr><td class='doc12' colspan=2>&nbsp;* アップロードできるファイルは $size(KB) に制限されています。</td></tr>\n" if $size;
	}
	print "<tr><td class='doc12' colspan=2>&nbsp;* この掲示板ではあなたのメールアドレス($user1\@$domain1)が投稿者情報として表示されます。</td></tr>\n" if $bbs{'DispEmail'};
	
	print "</table>\n</form>\n</blockquote>\n";
	
	# 一時ファイル残骸削除
	foreach (glob("../temp/$loginid/temp/*__")){unlink($_);}
	
	&print_footer();
	exit;
}

## 投稿完了
sub complete {
	local ($msg) = @_;
	&htmlconv(qw(Text));
	$Text =~ s/\n/<br>/g;
	$Text =~ s/\t/    /g;
	1 while $Text =~ s/  /&nbsp; /;
	my $str = $fs7R.'投稿完了です。'.$fe;
	
	&print_common();
	
	print <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc13' border=0>
<tr><td>$iii</td><td>$str</td></tr>
<tr><td></td><td>
$FName 名で投稿が完了しました。<br>
$msg<br>
<br>
<a href='$cgi2?$arg'>記事一覧にもどる$arrowR</a></td></tr>
<tr><td height=10></td></tr>
</table>
<table cellpadding=8 cellspacing=2 class='doc13' border=0 bgcolor='#d0ffd0' width='90%'>
<tr><td bgcolor='#ffffff'>$Text</td></tr>
</table>
</blockquote>
EOF
	
	&print_footer();
	exit;
}

## 共通ヘッダ
sub print_common {
	my ($error) = @_;
	my $str = $fs7G.'新規投稿'.$fe;
	
	&do_header1($error,1);
	
	print <<"EOF";
<table cellpadding=0 cellspacing=2 class='doc12' border=0 width='90%'>
<tr valign='bottom'><td>$str&nbsp; 掲示板に新しい記事を書きます。</td>
<td align='right'><a href='$cgi2?$arg'>記事一覧にもどる$arrowR</a></td></tr>
<tr><td bgcolor='#a0a0a0' colspan=2 height=1></td></tr>
<tr><td height=10></td></tr>
</table>
EOF
}
