#!c:/usr/perl/bin/perl.exe

### uK4 - BBS投稿記事/コメントの検索
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require './config.cgi';
require './bbs_common.cgi';
$cgi1 = 'bbs_search.cgi';
$cgi2 = 'bbs_view.cgi';
$cgi3 = 'bbs_articles.cgi';
($bgc,$ouryear) = ("bgcolor='#ffffff'",'1');

## 初期表示(入力フォームまたは検索結果表示)
if (@ARGV){
	($bbsid,$field,$method,$page,$op) = @ARGV;
	
	if ($op eq 'top'){
		($pri,$type) = (9,0);
		&html();
	} elsif ($op eq 'search' && !-s "$tempdir/$bbsid-$indexS"){
		($pri,$type) = (9,0);
		if (-s "$tempdir/$bbsid-search.txt"){
			my %i = &getenv("$tempdir/$bbsid-search.txt","=");
			while (my($key,$value) = each %i){$$key = $value;}
		}
		&html("直前の検索結果はありません。");
	}
	
	&print_result();
}

## 検索処理
my %f = &get_form2;
while (($key,$value) = each %f){
	&redirect if $k4envstr =~ /,$key,/;
	&zenhan('value') if $value =~ /[^$zstr]/;
	$value =~ s/^\s+//;
	$value =~ s/\s+$//;
	$value =~ s/[\n\r\s]+/ /g;
	$$key = $value;
}
($bbsid,$field,$method,$page) = split(/\+/,$arg);
&html("デモ用ページでは実行できません。",1) if $demo;

# ゴミ処理、整形処理
if ($aid){
	$aid =~ s/#//g;
	&html("記事番号の指定が正しくありません。",1) if $aid =~ /[^\d\-*? ]/;
}
if ($sY){
	$start = $sY;
	if ($sM){
		$start .= $sM;
		if ($sD){$start .= $sD;}
		else {$start .= '01';}
	} else {$start .= '0101';}
}
if ($eY){
	$end = $eY;
	if ($eM){
		$end .= $eM;
		if ($eD){$end .= $eD;}
		else {$end .= '12';}
	} else {$end .= '1231';}
}
$start = '19700101' if !$start;
$end = '99991231' if !$end;
&html("対象期間の指定が正しくありません。",1) if $start > $end;

# 結果条件を保存(作業フォルダ内)
my $sStr = join("\n","date = $date_5","type = $type","aid = $aid","title = $title","name = $name",
	"kw1 = $kw1","kw2 = $kw2","pri = $pri","start = $start","end = $end","file = $file");
Encode::_utf8_off($sStr);
open(FILE,">$tempdir/$bbsid-search.txt");
	print FILE "$sStr\n";
close(FILE);

# 検索母データを読んでおく(記事とコメント)
@data = &get_bbs_index($bbsid);
&html("検索可能なインデックスがありません。",1) if !@data;

# キーワードの退避/エスケープ
($Aid,$KW1,$KW2,$Name,$Title) = ($aid,$kw1,$kw2,$name,$title);
($aid,$kw1,$kw2,$name,$title) = &mod_str($aid,$kw1,$kw2,$name,$title);

# キーワードのワイルドカード処理
foreach (qw(aid title name kw1 kw2)){
	$$_ =~ s/^\\([*?])/.$1?/;
	$$_ =~ s/([^\\])\\([*?])/$1.$2/g;
}

# 検索実行
@found = ();
foreach my $line (@data){
	chomp($line);
	# 0BBS 1年月 2記事番号 3投稿日 4タイトル 5投稿者ID 6投稿者名 7重要度
	# 8ファイル 9記事本文 10コメント者 11コメント本文 12ステータス
	($bid0,$part0,$aid0,$date0,$title0,$from0,$name0,$pri0,$file0,$kw10,$Cfrom,$Ctext,$stat) = split(/\t/,$line);
	$kw20 = "$Cfrom$Ctext";
	if ($type){$ok = 1;} else {$ok = '';}
	my $line2 = join("\t",$bbsid,$part0,$aid0,$date0,$title0,$from0,$name0,$pri0,$file0);
	
	# 削除・停止を除外
	next if $stat;
	
	# 重要度を評価
	next if ($pri < 9 && $pri0 != $pri);
	
	# 投稿日を評価
	next if ($date0 < $start || $date0 > $end);
	
	# オプションを評価
	next if ($file && !$file0);
	
	# キーワードが何も指定されなかった場合は全ヒット
	if (!$aid && !$kw1 && !$kw2 && !$name && !$title){push(@found,"$line2\n"); next;}
	
	# 記事番号キーワードを評価
	foreach my $str (split(/\s+/,$aid)){
		if ($str !~ /-/){
			if ($type && $aid0 !~ /$str$/){$ok = ''; last;}
			elsif (!$type && $aid0 =~ /$str$/){$ok = 1; last;}
		} elsif ($str =~ /(.+?)-(.+)/){
			my ($str1,$str2) = ($1,$2);
			if ($type && ($aid0 <= $str1 || $aid0 >= $str2)){$ok = ''; last;}
			elsif (!$type && $aid0 >= $str1 && $aid0 <= $str2){$ok = 1; last;}
		}
	}
	
	# タイトル/投稿者名/記事内キーワードを評価
	foreach my $str1 (qw(title name kw1 kw2)){
		next if $$str1 eq '';
		foreach my $str2 (split(/\s+/,$$str1)){
			next if $str2 eq '';
			my $str3;
			if ($str2 =~ /^"(.+)"$/i){$str3 = $1;}	# フレーズ検索
			else {$str3 = $str2;}
			if ($type && ${$str1.'0'} !~ /$str3/i){$ok = ''; last;}
			elsif (!$type && ${$str1.'0'} =~ /$str3/i){$ok = 1; last;}
		}
		
	}
	
	# 判定
	if ($ok){push(@found,"$line2\n");}
}

# 結果インデックスと検索情報を保存
open(FILE,">$tempdir/$bbsid-$indexS");
	print FILE @found;
close(FILE);

# 結果表示
if (@found){&print_result();}
else {
	($kw1,$kw2,$name,$title) = ($KW1,$KW2,$Name,$Title);
	&html("検索条件にマッチする記事は見つかりませんでした。");
}

### 検索結果を表示 ----------------------------------------------------------
sub print_result {
	$arg = join('+',$bbsid,$field,$method,$page);
	
	# BBS情報を得る
	%info = &get_bbs_profile($bbsid);
	$item = $info{'Item'};
	
	## 検索結果を得る
	my @index = &get_bbs_index($bbsid);
	$count2 = @index;
	
	## 記事番号でソート
	@index = &sorting('2',$method,0,@index);
	
	## ページ処理(表示ページ分を抜き出す)
	($links,@index) = &page_split("$cgi1?$bbsid+$field+$method",$page,@index);
	
	## 記事リストを作成
	my $data;
	foreach (@index){
		chomp;
		next if (/^\s*$/ || /^#/);
		# 0BBS 1年月 2記事番号 3投稿日 4タイトル 5投稿者ID 6投稿者名 7重要度 8ファイル
		my ($bid,$dir,$aid,$date,$title,$from,$fname,$pri,$file) = split(/\t/,$_);
		
		my $str1;
		my $bgc = ${'pcolor'.$pri};
		if ($pri >= 2){$str1 = '最重要記事です';}
		elsif ($pri >= 1){$str1 = '重要記事です';}
		else {$str1 = '通常記事です';}
		
		my $anchor = "<a href='$cgi2?$arg+$dir+$aid+search'>";
		
		# 名前の処理
		$fname =~ s/\s+//g;
		$fname .= " &lt;$from&gt;" if $info{'DispEmail'};
		
		# 既読チェック
		my $c1 = &read_check($bid,$dir,$aid);
		my $read = " bgcolor='#ffffa0'" if $c1;
		
		my $aid1 = sprintf("%05d",$aid);
		$data .= <<"EOF";
<table cellpadding=1 cellspacing=1 border=0>
<tr$read><td bgcolor='$bgc'><img src='$idir/null.gif' height=20 width=6 title='$str1'></td>
<td width='100%'>
	<table cellpadding=0 cellspacing=2 border=0>
	<tr valign='bottom'><td class='doc15'>$anchor<span class='doc121'> #$aid1</span> $title</a></td>
	<td class='doc111'><font color='#808080'>$date &nbsp;</font></td>
	<td class='doc121'><font color='#808080'>$fname</font></td></tr>
	</table></td></tr>
<tr><td height=2></td></tr>
</table>
EOF
	}
	
	if (!$data){
		print "Location: $cgi1?$field+1+0+search+nodata\n\n";
		exit;
	} else {
		my $title2 = <<"EOF";
<table cellpadding=0 cellspacing=0 border=0 width='90%'>
<tr><td bgcolor='#000000'>
	<table cellpadding=2 cellspacing=1 class='doc121' border=0 width='100%'>
	<tr bgcolor='#ffffe0'>
	<td nowrap>&nbsp;<a href='$cgi3?$arg'>検索終了</a>&nbsp;</td>
	<td nowrap>&nbsp;<a href='$cgi1?$arg+top'>再検索</a>&nbsp;</td>
	<td align='right' width='100%'>$links</td></tr>
	</table></td></tr>
</table>
EOF
		
		&do_header1($error,1);
		print $title2;
		
		# 検索条件を得る
		my %i = &getenv("$tempdir/$bbsid-search.txt");
		while (my($key,$value) = each %i){$$key = $value;}
		if ($i{'type'}){$type = 'アンド検索';} else {$type = 'オア検索';}
		if ($pri >= 9){$pri = 'すべて';}
		elsif ($pri == 2){$pri = '最重要';}
		elsif ($pri == 1){$pri = '重要';}
		else {$pri = '普通';}
		$start =~ s/(\d\d\d\d)(\d\d)(\d\d)/$1\/$2\/$3/;
		$end =~ s/(\d\d\d\d)(\d\d)(\d\d)/$1\/$2\/$3/;
		$option = 'ファイルアップロードのある記事のみ<br>' if $file;
		foreach (qw(aid title name kw1 kw2 option)){$$_ = '-' if $$_ eq '';}
		1 while $count2 =~ s/(.*\d)(\d\d\d)/$1,$2/;
		foreach (qw(aid title name kw1 kw2 option)){$$_ = '-' if $$_ eq '';}
		1 while $count2 =~ s/(.*\d)(\d\d\d)/$1,$2/;
		
		print <<"EOF";
<table align='center' cellpadding=0 cellspacing=0 border=0 width=600>
<tr><td height=8></td></tr>
<tr valign='top'><td align='center' nowrap>$search2 &nbsp;</td>
<td bgcolor='#f0f0f0' width='100%'>
	<table cellpadding=0 cellspacing=0 class='doc121' border=0 width='100%'>
	<tr $bgc><td><font color='red'>ヒット件数</font></td>
		<td class='doc131' width='100%'><b>$count2</b></td></tr>
	<tr><td>検索方法</td><td width='100%'>$type</td></tr>
	<tr $bgc><td>記事番号</td><td>$aid</td></tr>
	<tr><td>記事のタイトル</td><td>$title</td></tr>
	<tr $bgc><td>記事の投稿者名</td><td>$name</td></tr>
	<tr><td>記事内キーワード</td><td>$kw1</td></tr>
	<tr $bgc><td nowrap>コメント内キーワード &nbsp;</td><td>$kw2</td></tr>
	<tr><td>重要度</td><td>$pri</td></tr>
	<tr $bgc><td>投稿日の対象期間</td><td>$start - $end</td></tr>
	<tr><td>オプション</td><td>$option</td></tr>
	</table></td></tr>
<tr><td height=8></td></tr>
</table>
EOF
		
		print $data;
		print $title2 if @index > 10;
	}
	
	print "</blockquote>\n";
	&print_footer();
	exit;
}

### 検索フォーム表示 ---------------------------------
sub html {
	my ($error,$op3) = @_;
	if ($Expired && !$op3){&expire($error);}
	$arg = join('+',$bbsid,$field,$method,$page);
	&htmlconv(qw(title name kw1 kw2));
	my $ch = 'checked';
	
	if ($type){$ct1 = $ch;} else {$ct2 = $ch;}
	$dc = $ch if $done;
	$fc = $ch if $file;
	$rc = $ch if $rcpt;
	foreach(qw(0 1 2 3 9)){${'pr'.$_} = $ch if $pri == $_;}
	
	my $str1 = "<td nowrap>&nbsp;<a href='$cgi1?$arg+search'>直前の検索結果を再表示</a>&nbsp;</td>";
	my $str2 = "<input type='checkbox' name='file' $fc value='1'>ファイルアップロードのある記事のみを検索";
	
	&do_header1($error,1);
	
	print <<"EOF";
<form action='$cgi1' method='post'>
<input type='hidden' name='arg' value='$arg'>

<table cellpadding=0 cellspacing=0 border=0 width='90%'>
<tr><td bgcolor='#c0c0c0'>
	<table cellpadding=2 cellspacing=1 class='doc121' border=0 width='100%'>
	<tr bgcolor='#ffffe0'>
	<td nowrap>&nbsp;<a href='$cgi3?$arg'>検索終了</a>&nbsp;</td>
	$str1
	<td align='right' width='100%'></td></tr>
	</table></td></tr>
<tr><td height=10></td></tr>
</table>

<table cellpadding=0 cellspacing=1 class='doc13' border=0>
<tr><td align='right' colspan=2><input type='submit' value='検索実行'></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td height=2></td></tr>
<tr><td>検索方法</td><td>
	<input type='radio' name='type' $ct1 value='1'>アンド検索&nbsp;
	<input type='radio' name='type' $ct2 value='0'>オア検索</td></tr>
<tr><td>記事番号</td><td><input name='aid' size=80 value='$aid' $nosubmit></td></tr>
<tr><td>記事のタイトル</td><td><input name='title' size=80 value='$title' $nosubmit></td></tr>
<tr><td>記事の投稿者名</td><td><input name='name' size=80 value='$name' $nosubmit></td></tr>
<tr><td>記事内キーワード</td><td><input name='kw1' size=80 value='$kw1' $nosubmit></td></tr>
<tr><td nowrap>コメント内キーワード &nbsp;</td><td><input name='kw2' size=80 value='$kw2' $nosubmit></td></tr>
<tr><td>重要度</td><td>
	<input type='radio' name='pri' $pr9 value='9'>すべて
	<input type='radio' name='pri' $pr0 value='0'>普通
	<input type='radio' name='pri' $pr1 value='1'>重要
	<input type='radio' name='pri' $pr2 value='2'>最重要</td></tr>
EOF
	
	print "<tr><td>投稿日の対象期間</td><td><select name='sY'>\n<option value=''>▽</option>";
	for (0 .. $ouryear){
		my $y = $year-$_;
		my $chk = 'selected' if $sY eq $y;
		print "<option $chk value='$y'>$y</option>\n";
	}
	print "</select>年 <select name='sM'>\n<option value=''>▽</option>";
	for (1 .. 12){
		my $m = $_;
		$m = sprintf("%02d",$m);
		my $chk = 'selected' if $m eq $sM;
		print "<option $chk value='$m'>$_</option>\n";
	}
	print "</select>月 <select name='sD'>\n<option value=''>▽</option>";
	for (1 .. 31){
		my $d = $_;
		$d = sprintf("%02d",$d);
		my $chk = 'selected' if $d eq $sD;
		print "<option $chk value='$d'>$_</option>\n";
	}
	
	print "</select>日から <select name='eY'>\n<option value=''>▽</option>";
	for (0 .. 1){
		my $y = $year-$_;
		my $chk = 'selected' if $eY eq $y;
		print "<option $chk value='$y'>$y</option>\n";
	}
	print "</select>年 <select name='eM'>\n<option value=''>▽</option>";
	for (1 .. 12){
		my $m = $_;
		$m = sprintf("%02d",$m);
		my $chk = 'selected' if $m eq $eM;
		print "<option $chk value='$m'>$_</option>\n";
	}
	print "</select>月 <select name='eD'>\n<option value=''>▽</option>";
	for (1 .. 31){
		my $d = $_;
		$d = sprintf("%02d",$d);
		my $chk = 'selected' if $d eq $eD;
		print "<option $chk value='$d'>$_</option>\n";
	}
	print "</select>日まで\n</td></tr>\n";
	
	print <<"EOF";
<tr><td>オプション</td><td>$str2</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
</table></td></tr>
</table>
</form>

<table cellpadding=0 cellspacing=0 class='doc13' border=0>
<tr><td class='doc15'><font color='$fcolor0'>■<b>検索のヒント</b></td></tr>
<tr><td>
$buttonG "アンド検索" にすると検索条件のすべてが一致または部分一致する記事を検索します。"オア検索" では検索条件が一つでも一致または部分一致する記事を検索します。ただし、キーワードが指定されない項目は評価が行なわれません。<br>
$buttonG 英大文字と英小文字、全角英数文字と半角英数文字(アスキー文字)、全角カタカナと半角カタカナは、それぞれ同一視されます。<br>
$buttonG キーワード内にスペース文字(空白文字)が含まれる場合、それにより分割される複数のキーワードを指定したものとみなされます。スペース文字を含む文字列をひとかたまりに検索(フレーズ検索)する場合は、文字列をダブルクオートで括ってください。<br>
$buttonG キーワードにはワイルドカード(* と ?)が使用できます。* は任意の 0 文字以上の文字列を、? は任意の 0 文字または 1 文字を指定したことになります。正規表現には対応していません。<br>
$buttonG 記事番号の指定では、(1) "00100" または "100" のように単一記事を指定、(2) "00100 00102" または "100 102" のように複数指定、(3) "00100-00200" または "100-200" のように範囲を指定することができます。<br>
$buttonG ダブルクオートやワイルドカード文字を含む検索文字列を指定する場合は、それらの文字の前にエスケープ文字(\\)を付けてください。<br>
$buttonG 検索対象記事について日本語の分かち書きは行なっていないので、無意味な短いキーワードを指定すると多量の記事がヒットする場合があります。<br>
$buttonG 保存記事数が多い場合、検索が完了するまで長く待たされることがあります。<br>
EOF
	
	# インデックスの作成時間を得る
	my $index = "$bbsroot/$bbsid/$indexS";
	my ($idate,$stamp);
	$idate = (stat($index))[9] if -s $index;
	if ($idate){
		($sec1,$min1,$hour1,$mday1,$mon1,$year1,$wday1) = localtime($idate);
		my $wday = ('日','月','火','水','木','金','土')[$wday1];
		$year1 += 1900; $month1 = $mon1+1;
		foreach (qw(month1 mday1 min1 hour1 sec1)){$$_ = sprintf("%02d",$$_);}
		$stamp = "$year1/$month1/$mday1($wday) $hour1:$min1";
	}
	print "$buttonG 検索は $stamp に作成された検索用インデックスを対象に行います。<br>"
		if ($stamp && (!$bbsupdateindex || ($idate+$index_ttl>time())));
	print "</td></tr></table></blockquote>\n";
	&print_footer();
	exit;
}

## 検索用インデックス(UTFで保存)を得る
sub get_bbs_index {
	my ($bbsid) = @_;
	my $index = "$bbsroot/$bbsid/$indexS";
	my @data;
	
	## インデックスがあれば
	if (-s $index){
		open(MyFILE,$index);
			while (<MyFILE>){
				next if (/^\s*$/ || /^#/);
				$_ = &dec_utf($_,$charset);
				push(@data,$_);
			}
		close(MyFILE);
	}
	if ($bbsupdateindex && @data && (stat($index))[9] + $index_ttl > time()){return @data;}
	elsif (!$bbsupdateindex){return @data;}
	unlink($index);
	
	# 掲示板ディレクトリ一覧を得る
	my @dirs = &getdirs($bbsroot,'B\d{3}');
	
	# インデックス作成
	foreach my $bbs (@dirs){
		foreach my $part (&getdirs("$bbsroot/$bbs/articles",'\d{4}-\d{2}')){
			foreach my $article (glob("$bbsroot/$bbs/articles/$part/*.article")){
				my $file = $1 if $article =~ /^(.+).article$/i;
				my $id = $& if $file =~ /[^\/]+$/;
				
				# 記事データを得る
				my %a = &get_bbs_article2($article);
				next if !$a{articleid};
				$a{created} =~ s/\s.+//;
				$a{created} =~ s/\D//g;
				my ($stat,$upld) = (0,0);
				$stat = 1 if -f "$bbsroot/$bbs/articles/$part/$id.deleted";
				$upld = 1 if -s "$bbsroot/$bbs/articles/files/$id.txt";
				
				# コメントデータを得る
				my %c = &get_bbs_comments2("$file.comments");
				
				my $line = join("\t",$bbs,$part,$a{articleid},$a{created},$a{title},$a{from},$a{fname},
					$a{priority},$upld,$a{text},$c{name},$c{text},$stat);
				push(@data,"$line\n");
			}
		}
	}
	
	return() if !@data;
	
	# 保存
	open(FILE,">$index");
		my @data2 = @data;
		flock(FILE,2);
		# 0BBS 1年月 2記事番号 3投稿日 4タイトル 5投稿者ID 6投稿者名 7重要度
		# 8ファイル 9記事本文 10コメント者 11コメント本文 12ステータス
		foreach (@data2){
			Encode::_utf8_off($_);
			print FILE;
		}
	close(FILE);
	
	@data;
}

## 検索用記事データを得る
sub get_bbs_article2 {
	my ($file) = @_;
	my %tmp;
	
	my $count = 0;
	open(FILE,$file) || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			$_ =~ tr/０-９Ａ-Ｚａ-ｚ　！”“＃＄％＆’（）＊＋，－．／：；＜＝＞？＠［￥］＾＿‘｛｜｝～/0-9A-Za-z \!\"\"#\$\%\&'\(\)\*\+,\-\.\/:;<=>\?\@\[\\\]\^_`{\|}~/;
			s/ +/ /g;
			if ($count == 0 .. /^$/i){
				if (/^(\w+):\s*(.*)/){
					my ($key,$value) = ($1,$2);
					$key = lc($key);
					$tmp{$key} = $value;
				}
				$count++;
				next;
			}
			$_ = lc($_);
			s/^(>\s*)*//;
			$tmp{text} .= $_;
		}
	close(FILE);
	
	%tmp;
}

## 検索用コメントデータを得る
sub get_bbs_comments2 {
	my ($file) = @_;
	my $line;
	my %temp;
	
	open(FILE,$file) || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			$line .= $_;
		};
	close(FILE);
	
	foreach my $data (split(/\n*#+\s*-+\s*#+\n*/,$line)){
		my $count = 0;
		my %c;
		foreach (split(/\r*\n/,$data)){
			$_ =~ tr/０-９Ａ-Ｚａ-ｚ　！”“＃＄％＆’（）＊＋，－．／：；＜＝＞？＠［￥］＾＿‘｛｜｝～/0-9A-Za-z \!\"\"#\$\%\&'\(\)\*\+,\-\.\/:;<=>\?\@\[\\\]\^_`{\|}~/;
			s/ +/ /g;
			if ($count == 0 .. /^$/i){
				if (/^(\w+):\s*(.*)/){
					my ($key,$value) = ($1,$2);
					$key = lc($key);
					$c{$key} = $value;
				}
				$count++;
				next;
			}
			$_ = lc($_);
			s/^(>\s*)*//;
			$c{text} .= $_;
		}
		next if !$c{name};
		$temp{name} .= $c{name}.' ';
		$temp{text} .= $c{text};
	}
	
	%temp;
}
