#!c:/usr/perl/bin/perl.exe

### uK4 - BBS記事/コメントを表示
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require './config.cgi';
require './bbs_common.cgi';
$cgi1  = 'bbs_view.cgi';
$cgi2  = 'bbs_post_comment.cgi';
$cgi3  = 'bbs_articles.cgi';
$cgi4  = 'bbs_download.cgi';
$cgi5  = 'bbs_search.cgi';
$color = '#ffffe0';
$TW = 600;		# 記事・コメント領域の横幅

### 初期表示
if (@ARGV){
	($bbsid,$field,$method,$page,$part,$aID,$op) = @ARGV;
	my $dir = "$bbsroot/$bbsid/articles/files";
	
	# 読んだ？フラグ保存
	open(FILE,">>$bbsroot/$bbsid/articles/$part/$aID.read");
		flock(FILE,2);
		print FILE $userid ."\t". time() ."\n";
	close(FILE);
	
	&html();
}

### 記事の削除/コメント禁止/完了フラグ
my %f = &get_form2;
while (($name,$value) = each %f){
	&redirect if $k4envstr =~ /,$name,/;
	$value =~ s/[\r\n]//g;
	&zenhan('value') if $value =~ /[^$zstr]/;
	$value =~ s/^\s+//;
	$value =~ s/\s+$//;
	$value =~ s/\s+/ /;
	$$name = $value;
}
($bbsid,$field,$method,$page,$part,$aID,$op) = split(/\+/,$arg);

## 削除
if ($del){
	&html("ゲストアカウントでは削除できません！",1) if $k4fixed;
	&html("記事を削除するにはパスワードの入力が必要です。",1) if !$pass;
	my $base2 = "$bbsroot/$bbsid";
	my ($name,$domain) = split(/\@/,$userid);
	my ($pass2,@tmp);
	if (open(FILE,"$mailroot/mailusers.tab")){
			while (<FILE>){
				$_ = &dec_utf($_);
				chomp;
				push(@tmp,$_);
			}
		close(FILE);
		foreach my $user (@tmp){
			$user = lc($user);
			$user =~ s/"//g;
			my ($domain0,$name0,$pass0) = split(/\t/,$user);
			if ($name eq $name0 && $domain eq $domain0){
				$pass2 = &dec_str($pass0);
				last;
			}
		}
	}
	&html("パスワードが正しくありません。",1) if (!$pass2 || $pass ne $pass2);
	
	open(FILE,">$base2/articles/$part/$aID.deleted");
		print FILE "$date_5\t$bbsid+$part+$aID\t$userid\t$ENV{'REMOTE_ADDR'}\n";
	close(FILE);
	&logging("$base2/logs/bbs.txt","$handle($user1\@$domain1) が記事 $bbsid+$part+$aID を削除しました。");
	&html("記事 $aID を削除しました。");
}
exit;

### ---------------------------------
sub html {
	my ($error,$op3) = @_;
	if ($Expired && !$op3){&expire($error);}
	$arg = "$bbsid+$field+$method+$page+$part+$aID+$op";
	$base1 = "$bbsroot/$bbsid/articles/files";			# 関連ファイルの格納場所
	$base = "$bbsroot/$bbsid/articles/$part";			# 記事・コメントの格納場所
	%article = &get_bbs_article("$base/$aID.article");	# 記事情報を得る
	%profile = &get_bbs_profile($bbsid);				# 掲示板情報を得る
	my $NoComment = 1 if -f "$base/$aID.nocomment";		# コメント禁止記事である
	
	## コメントを得る
	my ($chk,$line);
	if (open(FILE,"$base/$aID.comments")){
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				$line .= $_;
			}
		close(FILE);
	}
	my @comments = split(/\n*#+\s*-+\s*#+\n*/,$line);
	my $all = @comments;
	
	## 関連ファイルの処理
	my ($files,%cfile);		# %cfile はコメント者によるアップロードファイル
	if (open(FILE,"$base1/$aID.txt")){
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				if (/^#/ || /^\s*$/ || !/\t/){next;}
				my ($name,$ext,$realname,$size,$text,$from,$pri,$date,$commentid) = split(/\t/,$_);
				next if (!-f "$base1/$name" || -f "$base1/$name.deleted");
				1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/g;
				$text = $realname if !$text;
				my $link = "<a href=\"JavaScript:opn_win('$cgi4?$bbsid+$aID+$name',400,320)\">$text(${size}KB)</a><br>";
				if (!$commentid){$files .= $link;}
				else {$cfile{$commentid} .= $link;}
			}
		close(FILE);
		
		if ($files){
			my $files1 = $files;
			$files = "<table cellpadding=4 cellspacing=0 class='doc121' border=0>";
			$files .= "<tr bgcolor='#ffffff' valign='top'><td nowrap>";
			$files .= "<font color='#a00000'>ファイル&raquo;</font></td>";
			$files .= "<td align='right'>$files1</td></tr></table>\n";
		}
	}
	
	## 投稿記事を表示
	local ($name,$title,$text) = ($article{FName},$article{Title},$article{Text});
	&htmlconv(qw(name title text));
	$name .= " &lt;$article{From}&gt;" if $profile{DispEmail};
	$text =~ s/  /&nbsp; /g;
	if ($profile{Url}){
		$text = &convert_url($text,'_blank');
		$text =~ s/\t/    /g;
		$text =~ s/  /&nbsp; /g;
	}
	$text =~ s/[\r\n]/<br>/g;
	
	my ($extstr,$sorting);
	if ($bbsallowsort && $profile{Sort} && @comments > 1){
		my ($str1,$str2);
		if ($method){$str1 = 0; $str2 = '昇順で表示';} else {$str1 = 1; $str2 = '降順で表示';}
		$sorting = "<a href='$cgi1?$bbsid+$field+$str1+$page+$part+$aID+$op'><font color='#6060ff' size=2>$str2</font>$arrowS</a>";
		$extstr = "<table class='doc121' width=$TW><tr><td align='right'>$sorting $arrowD</td></tr></table>\n";
	}
	
	&do_header1($error,1);
	
	my $back = $cgi3;
	$back = $cgi5 if $op eq 'search';
	$back = "<a href='$back?$bbsid+$field+$method+$page+$op'>記事一覧にもどる$arrowR</a>";
	my $aid = sprintf("%05d",$aID);
	my $bottom = "<table width=$TW><tr><td align='right'>$arrowD</td></tr></table>\n" if @comments > 1;
	print <<"EOF";
<form action='$cgi1' method='post'>
<table cellpadding=0 cellspacing=0 class='doc13' border=0 width='90%'>
<tr><td>記事 #$aid へのコメントは以下の通りです。</td><td align='right'>$back</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td height=10></td></tr>
</table>
EOF
	
	if (-f "$base/$aID.deleted"){
		print "<br><table class='doc13' width=$TW><tr><td align='center'><font color='red'>記事が見つかりません。<br><br>\n";
		print "おそらくこの記事 #$aid は削除されました。</font></td></tr></table>";
		&print_footer();
		exit;
	}
	if ($bbsallowremove && $article{'From'} =~ /^$userid$/i){
		$remove = "<tr><td align='right' colspan=2><input type='hidden' name='arg' value='$arg'>";
		$remove .= "この記事を削除: <input class='doc121' type='password' name='pass' size=20 $nosubmit>";
		$remove .= "<input type='submit' name='del' value='実行' onClick=\"if(!confirm('この記事を削除してもよろしいですか？ 削除後は復活できません。')){return false;}\"></td></tr>";
	}
	
	print <<"EOF";
<table cellpadding=0 cellspacing=0 border=0 width=$TW>
<tr><td bgcolor='${'pcolor'.$article{Priority}}' colspan=3></td></tr>
<tr><td bgcolor='${'pcolor'.$article{Priority}}'><img src='$idir/null.gif' height=1 width=8 alt=''></td>
<td><img src='$idir/null.gif' height=1 width=6 alt=''></td>
<td width='100%'>
	<table cellpadding=0 cellspacing=1 class='doc13' border=0>
	<tr><td height=4></td></tr>
	<tr $bgcolor5'><td nowrap>記事ID &nbsp;</td><td width='100%'>#<b>$aid</b></td></tr>
	<tr $bgcolor5'><td>投稿日</td><td>$article{'Created'}</td></tr>
	<tr $bgcolor5'><td>投稿者</td><td>$name</td></tr>
	<tr $bgcolor5'><td>タイトル</td><td class='doc17'><font color='#006000'><b>$title</b></font></td></tr>
	<tr><td colspan=2>
		<table cellspacing=8 class='doc15' width='100%'>
		<tr><td><font color='#404040'>$text</font>
		<div align='right'>$files</div></td></tr>
		</table></td></tr>
	$remove
	<tr><td height=2></td></tr>
	</table></td></tr>
<tr><td bgcolor='${'pcolor'.$article{Priority}}' colspan=3></td></tr>
</table>
$extstr
</form>
EOF
	
	## コメント書込み終了
	print "<p><font color='red'>この記事へのコメントの書き込みは終了しています。</font></p>\n" if $NoComment;
	
	## 投稿画像の処理???
	if ($profile{Inline} && $files){
		#####
		#####
	}
	
	## 短縮タイトル
	my $stitle = $title;
	if (length($stitle) > 34){
		$stitle =~ s/^(.{34}).*/$1/;
		$stitle =~ s/.$// if ($stitle =~ /\x8F$/ || $stitle =~ tr/\x8E\xA1-\xFE// % 2);	# 末尾のゴミ削除
		$stitle .= '…';
	}
	$stitle = "<font color='#a0a0a0'>$stitle</font>";
	
	## コメントの表示
	if ($method){@comments = reverse(@comments);}
	while (my $data = shift @comments){
		my $count = $count1 = 0;
		my ($bgc1,$email,%cmt) = ('#ffffff');
		foreach my $cm (split(/\r*\n/,$data)){
				if ($count == 0 ... $cm =~ /^$/i){
					if ($cm =~ /^(\w+):\s*(.*)/){$cmt{$1} = $2;}
					$count++;
					next;
				}
				$cmt{Text} .= "$cm\n";
		}
		next if $cmt{Deleted};
		
		my $commentid = $cmt{CommentID};
		my $files = $cfile{$commentid};
		$files = "<table class='doc121'><tr bgcolor='#ffffff'><td><font color='#a00000'>ファイル&raquo;</font>&nbsp;</td><td>$files</td></tr></table>" if $files;
		$cmt{Text} =~ s/^[\n\r\s]*//;
		$cmt{Text} =~ s/[\n\r\s]*$//;
		next if !$cmt{Text};
		
		my ($id,$name,$text) = ($cmt{ID},$cmt{Name},$cmt{Text});
		$name =~ s/\s+//g;
		$name =~ s/</&lt;/g;
		$name =~ s/>/&gt;/g;
		$name .= " &lt;$id&gt;" if $profile{DispEmail};
		$text =~ s/</&lt;/g;
		$text =~ s/>/&gt;/g;
		$text =~ s/\t/    /g;
		$text =~ s/  /&nbsp; /g;
		$text = &convert_url($text,'_blank') if $profile{Url};
		$text =~ s/[\r\n]/<br>/g;
		my $bottom = $arrowD if @comments > 1;
		my $cid = sprintf("%03d",$commentid);
		
		if (!$NoComment){
			my $font = "<font color='#6060ff'>";
			print "<table class='doc13' width=$TW><tr><td align='right'><font color='#a04040' size=2>コメントを書く </font>$write ";
			print "<a href='$cgi2?$arg'>$font 引用なし$fe$arrowR</a> ";
			print "<a href='$cgi2?$arg+1'>$font 親記事を引用$fe$arrowR</a> ";
			print "<a href='$cgi2?$arg+$commentid'>$font コメント<b>#$cid</b>を引用$fe$arrowR</a></td></tr></table>\n";
		}
		print <<"EOF";
<table cellpadding=0 cellspacing=0 border=0 width=$TW>
<tr><td bgcolor='#c0c0c0' colspan=3></td></tr>
<tr><td bgcolor='#c0c0c0'><img src='$idir/null.gif' height=1 width=8 alt=''></td>
<td><img src='$idir/null.gif' height=1 width=6 alt=''></td>
<td width='100%'>
	<table cellpadding=0 cellspacing=1 class='doc13' border=0>
	<tr $bgcolor5'><td nowrap>コメントID &nbsp;</td><td width='100%'>#<b>$cid</b></td></tr>
	<tr $bgcolor5'><td>投稿日</td><td>$cmt{'Date'}</td></tr>
	<tr $bgcolor5'><td>投稿者</td><td>$name</td></tr>
	<tr><td colspan=2>
		<table cellspacing=8 width='100%'>
		<tr><td class='doc15'><font color='#404040'>$text</font>
		<div align='right'>$files</div></td></tr>
		</table></td></tr>
	</table><td></tr>
<tr><td bgcolor='#c0c0c0' colspan=3></td></tr>
</table>
<table class='doc121' width=$TW>
<tr><td>$stitle</td><td align='right'>$sorting $bottom $arrowU&nbsp;</td></tr>
</table>
EOF
		$chk = 1;
	}
	
	print "<table class='doc121' width=$TW><tr><td width='100%'></td><td align='right' bgcolor='#ffe0e0' nowrap>&nbsp;$back&nbsp;</td></tr></table>\n" if $all > 1;
	if (!$chk && !$NoComment){
		print "<table class='doc13' width=$TW><tr><td align='right'><font color='#a04040'>コメントを書く</font> $write ";
		print "<a href='$cgi2?$arg+1'>引用あり$arrowR</a>&nbsp; <a href='$cgi2?$arg'>引用なし$arrowR</a></td></tr></table>\n";
	}
	
	&print_footer();
	exit;
}
