#!C:/usr/perl/bin/perl.exe

### uK4 - ドメインの管理-ユーザの管理-ユーザの追加
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./domain_common.cgi";
($cgi,$help) = ("domain_user.cgi","$helper?u");
@array = qw(
	tdomain username pass1 pass2 k4login k4allowallow k4allowmail k4allowdeny k4allowantispam k4allownotify 
	k4allowusertab k4allowdistribute k4allowbigfile k4bigfile2 k4autoreply k4forward k4fservice k4menu k4mklist
	k4mlist k4password k4popsync RealName CompanyName Telephone Address HomePage MaxMBSize SmtpPerms memo menuid
);

## 初期表示
if (@ARGV){
	&domainadmin();
	$tdomain = $key4;
	&check_domaininfo($tdomain);
	$k4login = 1;
	if ($key6 eq 'retry'){
		$menuid = $key7;
		if ($usertotal == 0){$msg = "アカウントが作成されていません！";}
		else {$msg = "アカウントを選択してから実行してください！";}
	}
	elsif ($key6 eq 'you'){
		$menuid = $key7;
		$msg = "あなた自身は削除できません！";
	}
	elsif ($key6 =~ /@/){
		$msg = "アカウント $key6 を削除しました。";
		$menuid = 'del';
	}
	else {}
	if ($menuid eq ''){$menuid = 'property';}
	&html('',$msg);
}

## アカウント作成
&parse_form(@array);
&domainadmin();
&html("このアカウントからはユーザを追加できません！") if $k4fixed;
if ($k4password){$k4password = '';} else {$k4password = 1;}
if ($k4forward){$k4forward = '';} else {$k4forward = 1;}
&html("ユーザ名を指定してください！") if !$username;
&check_domaininfo($tdomain);
$tmp = "$username\@$tdomain";
&html("<b>$username</b> はシステムで予約されています！") if ($tmp =~ /^($postmaster1|$robot1)$/i);
&html("ユーザ名に不正な文字が含まれています！") if $username =~ /[^\w.\-]/;
&html("ドットで開始または終了するユーザ名は使用できません！") if ($username =~ /^\./ || $username =~ /\.$/);
&html("パスワードを指定してください！") if ($pass1 eq '' || $pass2 eq '');
&html("パスワードが一致しません！") if $pass1 ne $pass2;
&html("パスワードに不正な文字が含まれています！") if $pass1 =~ /["\|<>]/;
&html("パスワードの長さを $passmin 字以上にしてください！") if length($pass1) < $passmin;
&html("メーリングリスト開設許可数は数値を指定してください！") if $k4mklist =~ /\D/;
&html("メーリングリスト開設許可数は $maxlist までです！") if ($k4mklist && $k4mklist > $maxlist);
$kmlist =~ s/[\n\r\s]+/ /g;

# 同一アカウントチェック
open(FILE,"$mailroot/mailusers.tab");
	while (<FILE>){
		$_ = &dec_utf($_);
		chomp;
		push(@reg,$_);
	}
close(FILE);
if (grep(/"$tdomain"\t"$username"/i,@reg)){&html("$username\@$tdomain はすでに存在します！");}
if (-s "$mailroot/cmdaliases/$tdomain/$username.tab"){&html("$username\@$tdomain はシステムで予約済みです！");}

# アカウント作成
&ctrlcmd("\"useradd\"	\"$tdomain\"	\"$username\"	\"$pass1\"	\"U\"");
&set_chown("$mailroot/domains/$tdomain/$username") if $OS;
if (!-e "$mailroot/domains/$tdomain/$username/$inbox"){
	&log('f',$domain1,$user1,'?','admin','ユーザアカウント作成に失敗',$0);
	&html("アカウントを作成できませんでした。管理者までご連絡ください。");
}

# 環境を保存（config.tab/user.tab）
foreach(qw(PopEnable ReceiveEnable)){$$_ = 1;}
&saveenv('user',$tdomain,$username,'RealName','ComapnyName','Telephone','Address','HomePage','MaxMBSize','SmtpPerms');
&saveenv('k4',$tdomain,$username,'k4login','k4allowallow','k4allowmail','k4allowdeny','k4allowantispam','k4allownotify',
	'k4allowusertab','k4allowdistribute','k4allowbigfile','k4allowbigfile2','k4autoreply','k4forward','k4fservice',
	'k4menu','k4mklist','k4mlist','k4password','k4popsync');

# メモがあれば保存
if ($memo){&savememo($tdomain,$username);}

$msg = "アカウント $username\@$tdomain を追加しました。";
foreach(qw(username RealName CompanyName Telephone Address HomePage k4mlist k4mklist memo)){$$_ = '';}
&html('',$msg);

## ページを表示 -------------------------
sub html {
	my ($emsg) = @_;
	$emsg = "$alert $fs5R $emsg$fe" if $emsg;
	if ($Expired && !$_[0]){&expire($_[1]);}
	&env2();
	&check_domaininfo($tdomain);
	&htmlconv(qw(RealName CompanyName HomePage Address Telephone memo));
	
	&selectmenu_u();
	&header('user');
	
	my $title = 'ユーザの管理';
	$K4 = <<"EOF";
<table cellpadding=4 cellspacing=0 border=0>
<tr><td colspan=3>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title'> 
$fs7G<b>$title</b>$fe <span class='doc15'>$usertotal1</span>
$hr
$fs5R $_[1]$fe</td></tr>
<tr valign='top'><td>$selectmenu</td><td width=1></td><td>
EOF
	&print_utf($K4);
	
	if ($usertotal < $maxuser || $maxuser == 0){
		$K4 = <<"EOF";
<table cellpadding=0 cellspacing=1 class='doc131' border=0>
<tr><td class='doc17' colspan=2>$buttonP ユーザアカウントの追加
$hr
$emsg</td></tr>
<tr><td height=4>
<form method='post' action='$cgi'>
<input type='hidden' name='tdomain' value='$tdomain'>
<input type='hidden' name='MaxMBSize' value='$MaxMBSize'>
<input type='hidden' name='SmtpPerms' value='$SmtpPerms'>
<input type='hidden' name='menuid' value='$menuid'></td></tr>
<tr><td align='right'><a href="JavaScript:opn_win('$help+username'$wsize)">ユーザ名</a>:</td>
<td><input name='username' size=25 maxlength=50 value='$username' $nosubmit></td></tr>
<tr><td align='right'><a href="JavaScript:opn_win('$help+password'$wsize)">パスワード</a>:</td>
<td><input type='password' name='pass1' size=25 maxlength=50 $nosubmit></td></tr>
<tr><td align='right' nowrap><a href="JavaScript:opn_win('$help+password1'$wsize)">パスワード確認</a>:</td>
<td><input type='password' name='pass2' size=25 maxlength=50 $nosubmit></td></tr>
<tr><td height=4></td></tr>
<tr><td></td><td><input type='submit' value='このアカウントを追加'></td></tr>
<tr><td colspan=2><br>
$fs2 必要があれば以降を指定/変更してください。$fe<br>
EOF
		&print_utf($K4);
		&printuserstat();
		$K4 = "</table></td></tr></table><div align='right'>$arrowU</div></form>";
	} else {
		$K4 = <<"EOF"
<br>
<table cellpadding=0 cellspacing=1 class='doc13' border=0>
<tr><td><p>$fs5R ユーザアカウントの追加はできません。<br>
このドメインの最大ユーザ数は $maxuser 個です。$fe</p>
<p>アカウントの一部を削除してください。</p></td></tr>
</table>
EOF
	}
	
	&print_utf($K4);
	&print_footer();
	&exit();
}
