#!C:/usr/perl/bin/perl.exe

### uK4 - グループの管理 - メンバーの管理
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./group_common.cgi";
$cgi = "group_members.cgi";

## 初期表示
if (@ARGV){
	($gid) = @ARGV;
	exit if $extstr4 !~ /$gid/;
	
	&html();
}

## フォームからの入力を処理
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/,$buffer);
foreach $pair (@pairs){
	($name, $value) = split(/=/, $pair);
	&redirect if $k4envstr =~ /,$name,/;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value = &dec_utf($value,$charset);
	$value =~ s/\s+//g;
	if ($value && $name =~ /^del_\d/){push(@DEL,$value);}
	$$name = $value;
}
&html("このアカウントでは実行できません！") if $k4fixed;

# 追加の場合
if ($add){
	&html("メールアドレスを指定してください。") if !$member;
	&html("メールアドレスを確認してください。") if $member !~ /$emreg/;
	&html("登録済みのメールアドレスです。") if -f "$groot/$gid/members/$member";
	
	# ローカルユーザチェック
	my @users;
	foreach my $m (&get_userlist()){
		$m =~ s/<.+?>//g;
		push(@users,$m);
	}
	my ($tmp) = &mod_str($member);
	if (!grep(/^$tmp$/i,@users)){
		&html("ローカルユーザだけが追加できます。");
	}
	
	# 登録OK
	open(FILE,">$groot/$gid/members/$member") && close(FILE);
	
	$member = '';
	&html("新メンバーを追加しました。");
}

# 削除の場合
&html("削除メンバーにチェックをつけてください。") if !@DEL;
$c = 0;
foreach (@DEL){
	if (unlink("$groot/$gid/members/$_")){$c++;}
}

# 完了
&html("メンバー  $c 人を削除しました。");

## ページを表示 ----------------------------
sub html {
	&expire if ($Expired && !$_[1]);
	
	&header(@_);
	&print_mytitle('members');
	
	# 表示用データを得る
	my ($data,$count) = &get_my_members();
	
	my ($str0,$str1,$str2);
	$str0 = "<input type='submit' name='del' value='削除' $confirm1>" if $count;
	$str1 = "<tr $bgcolor0><td>&nbsp;メンバーアドレス</td><td>名前</td>";
	$str1 .= "<td nowrap>住所/電話</td><td>$str0</td></tr>\n";
	if ($count > 10){$str2 = $str1;}
	else {$str2 = "<tr><td colspan=4>$hr</td></tr>";}
	
	# メンバー一覧、登録用フォームを表示
	print <<"EOF";
<table cellpadding=1 cellspacing=0 border=0 width='100%'>
<tr><td height=8><form action='$cgi' method='post'><input type='hidden' name='gid' value='$gid'></td></tr>
<tr><td $bgcolor0>
	<table cellpadding=0 cellspacing=0 class='doc131' border=0>
	<tr><td>&nbsp;新メンバーを追加(メールアドレスで) &nbsp;</td>
	<td><input name='member' size=35 maxlength=128 value="$member">&nbsp;</td>
	<td><input name='add' type='submit' value='追加'></td></tr>
	</table></td></tr>
<tr><td height=16></td></tr>
</table>

<table cellpadding=1 cellspacing=0 class='doc131' border=0 width='100%'>
EOF
	
	if (!$count){
		print "<tr><td colspan=4 align='center' height=60>このグループにはメンバーがありません。</td></tr>";
	} else {
		print $str1;
		print $data;
	}
	
	print "$str2</table>";
	
	if ($count){
		print <<"EOF";
<li>追加できるのはローカルユーザのみです。</li>
<li>一覧にはグループ内グループの直属メンバー、グループ内ドメインのメンバーも統合して表示しています。</li>
<li>削除できるのは [$g{Name}] グループ直属のメンバーだけです。</li>
<li>削除ではグループ登録が削除されるだけです。メールサービス利用アカウント自体は削除されません。</li>
EOF
	}
	
	print "<div align='right'>$arrowU</div>" if $count > 10;
	print "</form>";
	&print_footer();
	&exit();
}

## グループメンバーを得る
sub get_my_members {
	my $data;
	
	# グループ内直属メンバーを得る
	foreach my $m (glob("$groot/$gid/members/*")){
		my $name = $& if $m =~ /[^\/]+$/;
		$name = lc($name);
		if ($name =~ /$emreg/){push(@members,$name);}
	}
	
	# グループ内グループメンバーを得る
	foreach my $g (glob("$groot/$gid/groups/*")){
		my $name = $1 if $g =~ /\/(\d{3})$/;
		foreach my $m (glob("$groot/$name/members/*")){
			my $name = $& if $m =~ /[^\/]+$/;
			$name = lc($name);
			my ($tmp) = &mod_str($name);
			if ($name =~ /$emreg/ && !grep(/^$tmp$/i,@members)){push(@membersG,"$name\@1");}
		}
	}
	
	# グループ内ドメインメンバーを得る
	foreach my $d (glob("$groot/$gid/domains/*")){
		my $domain = $& if $d =~ /[^\/]+$/;
		foreach my $m (&get_userlist($domain)){
			$m =~ s/<.+?>//g;
			$m = lc($m);
			my ($tmp) = &mod_str($m);
			if (!grep(/^$tmp$/i,@members)){push(@membersD,"$m\@1");}
		}
	}
	
	push(@membersG,@membersD);
	my %count;
	@membersG = grep(!$count{$_}++, @membersG);
	push(@members, sort(@membersG));
	
	# ソート、抽出
	#($link,@members) = &paging("$cgi?$gid",$item,'',@members);
	
	# 表示用データを得る
	my $c = 0;
	foreach my $m (@members){
		my ($user,$domain,$op) = split(/\@/,$m);
		my %i = &getenv("$mailroot/domains/$domain/$user/user.tab");
		my ($name,$companyname,$address,$phone) = ($i{RealName},$i{CompanyName},$i{Address},$i{Telephone});
		$name = '-' if !$name;
		$companyname = '-' if !$companyname;
		$address = '-' if !$address;
		$phone = '-' if !$phone;
		my $bgc = $bgcolor3;
		$bgc = '' if $c%2 == 0;
		$data .= "<tr $bgc><td class='doc15'>$user\@$domain</td><td>$name</td>";
		$data .= "<td>$address<br>$phone</td><td nowrap>";
		if ($op){$data .= '-';}
		else {$data .= "<input type='checkbox' name='del_$c' value=\"$user\@$domain\">削除";}
		$data .= "</td></tr>";
		$c++;
	}
	
	($data,$c);
}
