### uK4 - ドメイン管理・ユーザの管理用ヘルプファイル

### property ### プロパティを編集
選択したユーザの登録情報や権限情報を表示/更新します。内容の更新は直ちに有効になります。

### message ### メッセージを送信
選択したユーザに対してメッセージを送信します。管理者からの通知などに利用してください。

### loginmsg ### ログインMSGを編集
選択したユーザがこのツール集にログインしたときに表示する管理者からのメッセージを任意の内容で指定します。メッセージのタイトルは赤色表示になります。段落以外の場所では強制改行を入れないでください。

### deluser ### アカウントを削除
選択したユーザを削除します。削除は確認なしで直ちに行われます。メールボックスフォルダを、内部のすべてのメッセージファイルとともに削除するので十分な注意が必要です。一度削除された関連ファイルは回復することはできません。

### username ### ユーザ名
このアカウントのユーザ名を指定します。メールアドレスのうちドメイン名を除く部分です。ただし、メーリングリストで使っている名前をユーザ名にすることはできません。
ユーザ名には、すべての英数文字、ピリオド、ハイフン、アンダーバーが使えます。

### companyname ### 所属組織
必要ならこのアカウントの所有者の所属組織を登録します。会社名などを登録してください。

空白にしてもかまいません。

### password ### パスワード
このアカウントのパスワードを指定します。覚えやすいからといってあまり短いバスワードを指定するのはすすめられません。適当に長く、記号文字を含むバスワードが安全です。
パスワードに使える文字は、すべての英数文字と
  " | < >
を除くすべての記号文字です。

### password1 ### パスワード確認
確認のためにパスワードをもう一度入力してください。二つのバスワードが一致しないとやり直しになります。

### system ### システムへのアクセス権
メールサービスの利用に関する指定を行います。アカウントを一時的に停止する場合は [POP サービスの利用を許可] と [SMTP サービスの利用を許可] のチェックを外します。ただし、アカウントが停止された場合でも本ツール集を使ってメッセージの閲覧を行うことは可能です。

### k4 ### 本ツール集へのアクセス権
このツール集の利用に関する指定を行います。なお、[ログインを許可] 以外の選択肢にチェックがついた場合、自動的に [ログインを許可] が有効になります。

### k4pass ### ログインを許可
このユーザに対し、このツール集の利用を許可します。これにより、ユーザはこのツール集にログインし、パスワードの更新と転送の指定を行うことができるようになります。

### k4password ### パスワードの更新を許可
このユーザに対し、このツール集からの POP パスワードの更新を許可します。このパスワードは本ツール集へのログイン時にも使用されます。

### k4forward ### 転送の指定を許可
このユーザに対し、このツール集からの転送の指定・更新を許可します。転送時にはメッセージのコピーを残す指定が可能です。

### mailbox ### メールボックスの管理を許可
このユーザに対し、メッセージの送信機能や送受信トレイ・フォルダの管理機能など、メールボックスの管理を許可する場合にチェックをつけます。

### forcefrom ### 受信制限(受信許可)の指定を許可
このユーザに対し、特定アドレスからのみメッセージを受け取るための指定を実行できるようにする場合にチェックをつけます。

### notify ### お知らせメールの指定を許可
K4 の利用にあたり、お知らせメールの指定もできるようにするかどうかを選択します。お知らせメールとは、特定のメールアドレスからの着信を他の特定のメールアドレス（たとえば携帯電話のアドレス）に直ちに通知する機能です。

### finger ### ユーザ情報の参照を許可
このユーザに対し、他のユーザの個人情報(名前や住所、電話番号など)の参照を許可する場合にチェックをつけます。

### autoreply ### 自動応答の指定を許可
このユーザに対し、自動応答の実行/停止や応答メッセージの作成/編集を許可するかどうかを選択します。自動応答とは、このユーザのメールボックスにメッセージが到着したとき、自動的に定型文メッセージで応答するものです。休暇などでメッセージを長期間チェックできないときに、あるいは顧客サービスのためなどに利用できます。

### popsync ### 自動受信の指定を許可
このユーザに対し、自動受信(他のメールサーバのメールボックスからメッセージを自動的にダウンロードすること)のための指定を許可するかどうかを選択します。

### usertab ### 個人情報の更新を許可
このユーザに対し、名前や電話番号、住所などのアカウント情報をユーザ自身に更新させるかどうかを選択します。

### deny ### 受信拒否の指定を許可
このユーザに対し、特定アドレスからのメッセージ受信を拒否するための指定を許可するかどうかを選択します。

### antispam ### アンチ・スパムの指定を許可
このユーザに対し、スパムフィルタ機能を利用するための設定を許可するかどうかを選択します。

### distribute ### 振り分けの指定
このユーザに対し、到着メッセージの自動振り分けを実行するための設定を許可するかどうかを選択します。

この機能を許可する場合、[メールボックスの管理を許可] にもチェックをつける必要があります。

### bigfile ### ビッグファイル送付機能の利用を許可
E-mail に添付できないほど大きなサイズのファイルを送付可能にするのがビッグファイル送付機能です。

E-mail には実際にはファイルを添付せず、それをウェブサイトからダウンロードできるようにし、その URL を E-mail で相手に通知します。相手は指定 URL にアクセスし、指定ファイルをダウンロードします。

### bigfile2 ### ビッグファイル受領機能の利用を許可
E-mail に添付できないほど大きなサイズのファイルを受領可能にするのがビッグファイル受領機能です。

E-mail にファイルを添付してもらうのではなく、それをウェブサイトにアップロードしてもらい、そこからファイルをダウンロードします。アップロードサイトは E-mail で相手に通知します。相手は指定 URL にアクセスし、指定ファイルをアップロードします。

### k4menu ### 追加メニューがあれば表示を許可
[ドメインの管理]-[追加メニュー] に有効な登録メニューがある場合、このユーザがログインしたときにそれらを追加表示するかどうかを選択します。

### listadmin ### メーリングリスト開設を許可
このユーザに個人用メーリングリストの開設を許可する場合はその個数を指定します。ただし、ここで開設を許可しない場合でも [リストの管理] から特定のメーリングリストの管理者としてこのユーザが指定されている場合はそのリストについては管理が可能です。

### mlist ### 閲読できるメーリングリストアーカイブ
ローカルサーバ上のメーリングリストアーカイブ(過去に投稿されたメッセージの一覧)の閲覧を許可する場合、そのリストアドレスを1行に1つずつ指定します。指定アーカイブが存在しなければ処理をスキップし、エラーにはなりません。

### personal ### 個人情報
このアカウントの個人情報などを指定します。ここで登録した内容は他のユーザから参照される可能性があります。

### memo ### 管理用メモ
自由な内容で管理者のためのメモを書きます。このメモは [ユーザ情報の検索] メニューからは隠されます。

### popservice ### POP サービスの利用を許可
本ツール集以外のメールクライアントを使ってメールサーバからのメッセージの受信を許可するかどうかを選択します。アカウントを一時停止する場合にチェックを外します。ただし、本ツール集を使う場合はこのサービスが不許可になっていてもメッセージの閲覧を行うことができます。

### smtpservice ### SMTP サービスの利用を許可
外部からこのユーザへあてたメッセージの受信や、このユーザから外部へのメッセージの送信を許可するかどうかを選択します。本ツール集からも送信はできません。アカウントを一時停止する場合にチェックを外します。

### mailboxlimit ### メールボックス制限
このアカウントのメールボックス内に保存できるメッセージの最大合計サイズをキロバイトで指定します。このサイズを超えてメッセージを保存(受信)することはできません。ただし、1通のメッセージの受信中に制限値を超える場合は受信は正常に行われます。

### msglimit ### メッセージサイズ制限
ここに有効な数値(キロバイト)を指定すると、このアカウントあてのメッセージやこのアカウントから送信されるメッセージそれぞれについてサイズ制限が行われるようになり、制限を超えたメッセージは受け取りを拒否されるようになります。何も指定しない場合システム既定の制限が行われます。

### diskspace ### ディスク使用量
このアカウントのメールボックスにあるすべてのメッセージファイルと設定ファイルとの合計サイズと、それらの個数です。メッセージファイルが一つもなくてもファイル数はゼロにはなりません。サイズの単位はキロバイトです。

### alias ### エイリアス情報
このアカウントが持っているエイリアス(別名定義)の一覧を表示します。エイリアスを編集するには [エイリアスの管理] メニューを利用します。

### k4title ### メッセージのタイトル
ログインメッセージのタイトルを指定してください。メッセージを表示しない場合はタイトルとメッセージ本文を空白にしてください。日本語が使えます。

### k4info ### メッセージ本文
ログインメッセージ本文を書いてください。メッセージを表示しない場合はタイトルとメッセージ本文を空白にしてください。日本語が使えます。

#######
