#!C:/usr/perl/bin/perl.exe

### uK4 - 個人用リストの管理(自動処理)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./list_common.cgi";
@array = qw(ldomain lname lp lperm ClosedML Owner MaxUser ListAdmin 
	WelcomeMessage WelcomeMessageText WelcomeMessageSubject 
	GoodbyeMessage GoodbyeMessageText GoodbyeMessageSubject 
	RobotHelp RobotHelpSubject RobotHelpText RobotInfo RobotInfoText RobotInfoSubject);
$maxtext = 10000;

## 初期表示
if (@ARGV){
	$ml = $key4;
	&getLinfo($ml);
	&listadmin($user1,$domain1,$ml);
	($l{lname},$l{ldomain}) = split(/\@/,$ml);
	$l{lp} = 1 if $l{Robot};
	$l{lperm} = 'W' if $l{Robot} =~ /W/i;
	foreach my $f (qw(goodbye help info welcome)){
		my $count = 1;
		my $s = $f."sub";
		my $t = $f."txt";
		open(FILE,"$mailroot/domains/$l{ldomain}/$l{lname}/$xmailcfg/$f.tab") || next;
			while(<FILE>){
				$_ = &dec_utf($_,'JIS');
				if ($count == 1 && /^\[Subject\]\s*(.*)/i){$$s = $1; $count++; next;}
				$$t .= $_;
			}
		close(FILE);
		($l{GoodbyeMessageSubject},$l{GoodbyeMessageText},$l{RobotHelpSubject},$l{RobotHelpText},
			$l{RobotInfoSubject},$l{RobotInfoText},$l{WelcomeMessageSubject},$l{WelcomeMessageText}) 
			= ($goodbyesub,$goodbyetxt,$helpsub,$helptxt,$infosub,$infotxt,$welcomesub,$welcometxt);
	}
	&html();
}

## フォーム入力を処理
&parse_form(@array);
foreach(@array){
	$$_ =~ s/^\s+//;
	$$_ =~ s/\s+$//;
	$l{$_} = $$_;
	
}
$ml = "$l{lname}\@$l{ldomain}";
&listadmin($user1,$domain1,$ml);

# エラーチェック
&html("このアカウントでは保存できません！",1) if $k4fixed;
&html("通知先アドレスを確認してください。",1) if ($l{Owner} && $l{Owner} !~ /^$emreg1$/i);
$l{MaxUser} =~ s/,//g;
&html("定員は数値を指定してください。",1) if $l{MaxUser} =~ /\D/;
if ($Lmember){
	$l{MaxUser} = $Lmember if !$l{MaxUser};
	&html("定員を $Lmember 以下にしてください。",1) if $l{MaxUser} > $Lmember;
}
&html("From:アドレスを確認してください。",1) if ($l{ListAdmin} && $l{ListAdmin} !~ /^$emreg1$/i);
&html("ウェルカムメッセージは $maxtext バイト以内にしてください。",1) if length($l{WelcomeMessageText}) > $maxtext;
&html("バイバイメッセージは $maxtext バイト以内にしてください。",1) if length($l{GoodbyeMessageText}) > $maxtext;
&html("HELP コマンド応答メッセージは $maxtext バイト以内にしてください。",1) if length($l{RobotHelpText}) > $maxtext;
&html("INFO コマンド応答メッセージは $maxtext バイト以内にしてください。",1) if length($l{RobotInfoText}) > $maxtext;

# 保存準備
if ($l{lp}){
	if ($l{lperm}){$l{Robot} = 'RW';}
	else {$l{Robot} = 'R';}
} else {$l{lperm} = '';}

# 更新情報保存
my @array1 = qw(GoodbyeMessage ListAdmin MaxUser Owner RobotHelp RobotInfo Robot WelcomeMessage);
foreach(@array1){$$_ = $l{$_};}
unshift(@array1,$l{lname});
unshift(@array1,$l{ldomain});
unshift(@array1,'k4m');
&saveenv(@array1);

# メッセージテキスト保存
foreach(qw(WelcomeMessage GoodbyeMessage RobotHelp RobotInfo)){
	$tmp = "[Subject] $l{$_.'Subject'}\n"."$l{$_.'Text'}";
	Encode::_utf8_off($tmp);
	Encode::from_to($tmp,$charset,'JIS');
	my $tmp1;
	if ($_ eq 'WelcomeMessage'){$tmp1 = 'welcome';}
	elsif ($_ eq 'GoodbyeMessage'){$tmp1 = 'goodbye';}
	elsif ($_ eq 'RobotHelp'){$tmp1 = 'help';}
	elsif ($_ eq 'RobotInfo'){$tmp1 = 'info';}
	else {&redirect;}
	open(FILE,">$mailroot/domains/$l{ldomain}/$l{lname}/$xmailcfg/$tmp1.tab");
		flock(FILE,2);
		print FILE "$tmp";
	close(FILE);
}

$msg = "自動処理の設定を更新しました。";
&html($msg);

## ページを表示 ----------------------------------------
sub html {
	if ($Expired && !$_[1]){&expire($_[0]);}
	&do_header1("$ml の管理",'robot',$_[0]);
	&printstat("$l{lname}\@$l{ldomain}");
	
	foreach(qw(WelcomeMessage GoodbyeMessage RobotHelp RobotInfo)){
		my $tmp = $_.'Text'; my $tmp1 = $_.'Subject';
		$l{$tmp} =~ s/</&lt;/g; $l{$tmp1} =~ s/</&lt;/g;
		$l{$tmp} =~ s/>/&gt;/g; $l{$tmp1} =~ s/>/&gt;/g;
		$l{$tmp} =~ s/"/&quot;/g; $l{$tmp} =~ s/"/&quot;/g;
	}
	
	if ($l{lp}){$chk1 = 'checked';}
	if ($l{lperm}){$chk2 = 'checked';}
	if ($l{WelcomeMessage}){$chk3 = 'checked';}
	if ($l{GoodbyeMessage}){$chk4 = 'checked';}
	if ($l{RobotHelp}){$chk5 = 'checked';}
	if ($l{RobotInfo}){$chk6 = 'checked';}
	
	my $K4 = <<"EOF";
<dl><dd>
<form method='post' action="$robotcgi">
<input type='hidden' name='ldomain' value="$l{ldomain}">
<input type='hidden' name='lname' value="$l{lname}">
<input type='hidden' name='ClosedML' value="$l{ClosedML}">

<table cellpadding=0 cellspacing=1 class='doc131' border=0>
<tr><td colspan=2><input type='checkbox' name='lp' $chk1 value='1'>
<a href="JavaScript:opn_win('$help+subscribe'$wsize)">$fs5R 自動登録/自動削除を許可する$fe$na</a>
$hr</td></tr>
EOF
	&print_utf($K4);
	
	if ($l{ClosedML}){
		print <<"EOF";
<tr><td colspan=2><input type='checkbox' name='lperm' $chk2 value='RW'>
<a href="JavaScript:opn_win('$help+perm'$wsize)">投稿を許可するメンバーとして登録する</a></td></tr>
EOF
	}
	
	$K4 = <<"EOF";
<tr><td height=4></td></tr>
<tr><td nowrap><a href="JavaScript:opn_win('$help+report'$wsize)">・ 自動処理の通知先アドレス:</a></td>
<td><input name='Owner' size=35 maxlength=50 value="$l{Owner}" $nosubmit></td></tr>
<tr><td><a href="JavaScript:opn_win('$help+limit'$wsize)">・ 自動登録による定員:</a></td>
<td><input name='MaxUser' size=7 maxlength=5 value="$l{MaxUser}" $nosubmit></td></tr>
<tr><td><a href="JavaScript:opn_win('$help+sender'$wsize)">・ 送信メッセージ(下記)のFrom:アドレス:</a></td>
<td><input name='ListAdmin' size=35 maxlength=50 value="$l{ListAdmin}" $nosubmit></td></tr>
<tr><td colspan=2>
<input type='checkbox' name='WelcomeMessage' $chk3 value="1">
<a href="JavaScript:opn_win('$help+welcome'$wsize)">登録時に以下のメッセージ(ウェルカムメッセージ)を送信する(日本語可)</a><br>
&nbsp; 用件: <input name='WelcomeMessageSubject' size=60 maxlength=100 value="$l{WelcomeMessageSubject}"><br>
EOF
	&print_utf($K4);
	
	print <<"EOF";
<textarea name='WelcomeMessageText' cols=70 rows=7 wrap='soft'>$l{WelcomeMessageText}</textarea></td></tr>
<tr><td colspan=2>
<input type='checkbox' name='GoodbyeMessage' $chk4 value="1">
<a href="JavaScript:opn_win('$help+bye'$wsize)">削除時に以下のメッセージ(バイバイメッセージ)を送信する(日本語可)</a><br>
&nbsp; 用件: <input name='GoodbyeMessageSubject' size=60 maxlength=100 value="$l{GoodbyeMessageSubject}"><br>
<textarea name='GoodbyeMessageText' cols=70 rows=7 wrap='soft'>$l{GoodbyeMessageText}</textarea></td></tr>
<tr><td colspan=2>
<input type='checkbox' name='RobotHelp' $chk5 value="1">
<a href="JavaScript:opn_win('$help+helpcmd'$wsize)">HELP コマンドを受け付け、以下のメッセージを送信する(日本語可)</a><br>
&nbsp; 用件: <input name='RobotHelpSubject' size=60 maxlength=100 value="$l{RobotHelpSubject}"><br>
<textarea name='RobotHelpText' cols=70 rows=7 wrap='soft'>$l{RobotHelpText}</textarea></td></tr>
<tr><td colspan=2>
<input type='checkbox' name='RobotInfo' $chk6 value="1">
<a href="JavaScript:opn_win('$help+infocmd'$wsize)">INFO コマンドを受け付け、以下のメッセージを送信する(日本語可)</a><br>
&nbsp; 用件: <input name='RobotInfoSubject' size=60 maxlength=100 value="$l{RobotInfoSubject}"><br>
<textarea name='RobotInfoText' cols=70 rows=7 wrap='soft'>$l{RobotInfoText}</textarea></td></tr>
EOF
	$K4 = <<"EOF";
<tr><td height=6></td></tr>
<tr><td colspan=2>
<input type='submit' value='環境を保存する'>
$hr</td></tr>
</table>
<div align='right'>$arrowU</div>
</dl>
<blockquote>
<p>$fs5R 【自動処理のためのコマンド】$fe</p>

<ul>
<li><p>このメーリングリスト $ml に自動登録したい場合、あるいはそこから自動削除したい場合、または HELP コマンドや INFO コマンドを利用したい場合、その人は $fs5R<b>$robot</b>$fe あて（$ml あてではありません）に以下の内容の Subject: または本文を書いて送信します。</p>
<p>
<table cellpadding=8 cellspacing=0 class='doc131' border=1><tr><td>
<b>Subscribe &nbsp;$ml</b> &nbsp; -- リストへ参加します。<br>
<b>Join &nbsp;$ml</b> &nbsp; -- リストへ参加します。<br>
<br>
<b>Unsubscribe &nbsp;$ml</b> &nbsp; -- リストから削除します。<br>
<b>Leave &nbsp;$ml</b> &nbsp; -- リストから削除します。<br>
<br>
<b>Help &nbsp;$ml</b> &nbsp; -- ヘルプを要求します。<br>
<b>Info &nbsp;$ml</b> &nbsp; -- 案内情報を要求します。<br>
<br>
<b>Stop</b> &nbsp; -- コマンドを終了します。なくてもかまいません。<br>
</table>
</p></li>
<li><p>Subscribe(Join) や Unsubscribe(Leave)、Help、Info、Stop が自動処理関連のコマンドです。コマンドは大文字でも小文字でもかまいませんが、全角文字は使えません。コマンドに続くメールアドレスが処理対象リストになります。</p></li>

<li><p>どれかのコマンド文字列が見つかると、<b>$robot</b> のリストプロセッサはこのメーリングリストでそれらのコマンドが許可されているかどうかを調べ、許可されていれば、既定の処理を行います。たとえば登録の場合、メッセージヘッダの From:タグの値をメーリングリストに登録します。</p></li>
<li><p>一つのメッセージの中には複数行のコマンド文字列を入れることができます。コマンドは見つかった順番に実行されます。ただし、<b>Stop</b> コマンドが見つかると、処理はそこで終了します。また、同一のコマンド行が複数の場所に現れる場合、実行されるのは最初に見つかったものだけです。</p></li>
</ul>
EOF

	if ($Lsubscribe && $plsubscribe){
		$K4 .= <<"EOF";
<p>$fs5R 【空メッセージ投稿による自動処理】$fe</p>
<ul>
<p>メーリングリストへのメンバーの自動登録やそこからの自動削除は、もしこのメーリングリストが登録メンバーでなくても投稿が許されるタイプのものであれば、[環境設定]-[空メッセージ投稿による登録/削除を実行する] にチェックをつけることでも実行できます。</p>
<p>この場合、空メッセージ(本文のないメッセージ)をこのメーリングリストに投稿することでメンバーの登録または削除が自動的に行われます。</p>
</ul>
EOF
	}
	
	$K4 .= <<"EOF";
</blockquote>
<div align='right'>$arrowU</div>
</form>
EOF
	&print_utf($K4);
	&print_footer();
	exit;
}
