#!C:/usr/perl/bin/perl.exe

### uK4 - アドレス帳の検索
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";
$cgi2 = "mailbox_address.cgi";
$keyword = "$tempdir/$loginid/search_keyword.cgi";
$result = "$tempdir/$loginid/search_address.cgi";

### 初期表示
if (@ARGV){
	#unlink($keyword,$result);
	
	if (open(FILE,"$keyword")){
			while (<FILE>){
				chomp();
				my ($key,$val) = split(/\s*=\s*/,$_);
				$$key = $val;
			}
		close(FILE);
	}
	
	&body();
}

### フォーム入力を処理
my $doc = new CGI_Lite;
my %k4 = $doc->parse_form_data();
while(my($name,$value) = each %k4){
	&redirect if $k4envstr =~ /,$name,/;
	$value = &dec_utf($value,$charset);
	$value =~ s/^\s+//;
	$value =~ s/\s+$//;
	$value =~ s/\s+/ /g;
	if ($name =~ /^to/ && $value ne ''){$TO .= $value . '_'; next;}
	if ($name =~ /^cc/ && $value ne ''){$CC .= $value . '_'; next;}
	if ($name =~ /^bcc/ && $value ne ''){$BCC .= $value .'_'; next;}
	$$name = $value;
}

## メッセージ送信(mailbox_new.cgiを起動)
if ($mailto){
	foreach(qw(TO CC BCC)){if (!$$_){$$_ = '_';}}
	print "Location: $cginew?mailto+$TO+$CC+$BCC+100\n\n";
	exit;
}

## アドレスを削除
elsif ($del){
	&body("このアカウントでは実行できません！",1) if $k4fixed;
	($total1,@reg) = &readbook();
	my ($c1,$c2,@address) = (0,0);
	foreach (@reg){
		if (${'a'.$c1}){$c2++; $c1++; next;}
		push(@address,"$_\n");
		$c1++;
	}
	if ($c2){
		open(FILE,">$mailroot/domains/$domain1/$user1/$xmailcfg/$addressbook");
			flock(FILE,2);
			print FILE sort(@address);
		close(FILE);
		&body("$c2 件のアドレスを削除しました。");
	} else {
		&body("削除するアドレスにチェックをつけてください。",1);
	}
}

&body("キーワードを指定してください。",1) if (!$email && !$name && !$desc);

## 検索準備
## 0.キーワードの成形
&zenhan('name','email','desc');
($name2,$email2,$desc2) = &mod_str($name,$email,$desc);

## 1.個人用アドレス帳を得る
@AD1 = &get_my_address(0,"$userdir/$xmailcfg/addressbook.tab");

## 2.グループ共用アドレス帳を得る
@AD2 = ();
if ($extstr3){
	foreach my $group (split(/_+/,$extstr3)){
		$group =~ s/^[A-Z]//i;
		my @tmp = &get_my_address($group,"$mailroot/groups/$group/K4.book.tab");
		next if !@tmp;
		push(@AD2,@tmp);
	}
	sort(@AD2);
}

## 3.ドメイン共用アドレス帳を得る
@AD3 = &get_my_address($domain1,"$mailroot/domains/$domain1/k4.book.tab");

## 検索開始
@AD0 = ();
foreach my $i (@AD1,@AD2,@AD3){
	my ($type,$email,$desc,$name) = split(/\t/,$i);
	
	if (
		($email2 && $email =~ /$email2/i) ||
		($name2 && $name =~ /$name2/i) ||
		($desc2 && $desc =~ /$desc2/i)){
		push(@AD0,$i);
	}
}

## 結果処理
&body("条件にマッチするアドレスはありません。") if !@AD0;

## 結果保存
open(FILE,">$result");
	print FILE @AD0;
close(FILE);
open(FILE,">$keyword");
	print FILE <<"EOF";
name = $name
email = $email
desc = $desc
EOF
close(FILE);

# 再表示
my $count = @AD0;
&body("$count 件のアドレスが見つかりました。");

## -------------------------------------
sub body {
	my ($error) = @_;
	if ($Expired && !$_[1]){&expire($error);}
	&do_header("アドレス帳の検索","$error");
	&htmlconv(qw(name desc));
	
	$hidden .= "<input type='hidden' name='key4' value='$key4'>";
	$hidden .= "<input type='hidden' name='key5' value='$key5'>";
	
	$K4 = <<"EOF";
$table0
<form method='post' action='mailbox_address_search.cgi'>
$hidden
<tr><td>アドレス帳全データを対象に検索を行います。キーワードを指定してください。
<a href='$cgiaddress?0+1'><font color='blue'>アドレス帳へもどる$arrowR</font></a></td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr><td $bgcolor3>
	<table cellpadding=2 cellspacing=0 class='doc131' border=0>
	<tr><td $bgcolor0 nowrap rowspan=5>キーワード<br>の指定</td><td height=4></td></tr>
	<tr><td>&nbsp;アドレス</td>
	<td><input name='email' value='$email' size=60 maxlength=128 $nosubmit> (ex: foo\@domain.jp)</td></tr>
	<tr><td>&nbsp;アドレス名</td>
	<td><input name='name' value="$name" size=60 maxlength=128 $nosubmit> (ex: Taro)</td></tr>
	<tr><td>&nbsp;説 明</td>
	<td><input name='desc' value='$desc' size=60 maxlength=128 $nosubmit></td></tr>
	<tr><td colspan=2>&nbsp;<input type='submit' title='検索を実行します' value='検索を実行' $class></td></tr>
	</table></td></tr>
<tr><td></td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr><td height=6></td></tr>
<tr><td class='doc13'>
<ul>
<li>大文字と小文字とは同一視されます。正規表現やワイルドカード指定には対応していません。</li>
<li>複数のキーワードを指定した場合や複数フィールドにキーワードを指定した場合はオア検索を行います。</li>
</ul>
</td></tr>
</table>
EOF
	&print_utf($K4);
	
	my @result;
	if (open(FILE,"$result")){
			@result = <FILE>;
		close(FILE);
	}
	if (!@result){
		&print_footer();
		exit;
	}
	
	## 検索結果を表示
	$K4 = "$table0";
	my $title = <<"EOF";
<tr align='center' $bgcolor0><td nowrap>&nbsp;#&nbsp;</td>
<td nowrap>アドレス名 &lt;アドレス&gt;</td>
<td width='100%'>説　明</td>
<td><input type='submit' name='mailto' value='メッセージ' title='選択したアドレスにメッセージを送信します' $class></td>
<td bgcolor='#ccccff'>
<input type='submit' name='del' value='削除' title='選択したアドレスを削除します' $confirm1 $class></td></tr>
EOF
	
	my ($c,$c1,$data) = (0);
	my $type2 = 'checkbox' if $allowmad;
	$type2 = 'radio' if !$type;
	foreach (@result){
		chomp();
		s/</&lt;/g;
		s/>/&gt;/g;
		s/"/&quot;/g;
		my ($type,$email,$desc,$name) = split(/\t/,$_);	# type=0,グループID,domain1
		my ($bgc,$str1);
		if ($type){
			$str1 = '[共用]';
			if ($type =~ /^\d{3}$/){
				$bgc = "bgcolor='#fff4f4'";
			} else{
				$bgc = "bgcolor='#f0f0ff'";
			}
		} else {
			$bgc = $bgcolor3;
			$type = '';
		}
		$email = "\"$name\" &lt;$email&gt;" if $name;
		
		my $tmp2 = $c + 1;
		$data .= "<tr $bgc><td nowrap><font class='doc12'>";
		if ($str1){$data .= $str1;}
		else {$data .= sprintf("%03s",$tmp2);}
		$data .= "</font></td><td nowrap>&nbsp;";
		$data .= "$email";
		$data .= "&nbsp;</td><td>$desc<br></td><td nowrap><font class='doc12'>";
		$data .= "<input type='$type2' name='to$c1' value='$c/$type'>To";
		$data .= "<input type='$type2' name='cc$c1' value='$c/$type'>Cc";
		$data .= "<input type='$type2' name='bcc$c1' value='$c/$type'>Bcc</font></td>";
		if ($op1){$data .= "<td></td></tr>";}
		else {
			$data .= "<td align='center' bgcolor='#ccccff' nowrap>";
			$data .= "<input type='checkbox' name='a$c' value='$tmp2'></td></tr>";
		}
		$c++;
		$c1++ if $allowmad;
	}
	
	$K4 = "<table cellpadding=0 cellspacing=1 $class border=0 width='100%'>$title$data";
	if ($c > 10){$K4 .= $title2;}
	else {$K4 .= "<tr><td $bgcolor0 colspan=5 height=1>$null</td></tr>";}
	$K4 .= "</table></form>";
	
	&print_utf($K4);
	if ($c >= 20){print "<div align='right'>$arrowU</div>";}
	&print_footer();
	&exit();
}

## アドレス帳データを得る
sub get_my_address {
	my ($type,$file) = @_;
	my @tmp;
	
	open(FILE,$file) || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			tr/０-９Ａ-Ｚａ-ｚ　！”“＃＄％＆’（）＊＋，－．／：；＜＝＞？＠［￥］＾＿‘｛｜｝～/0-9A-Za-z \!\"\"#\$\%\&'\(\)\*\+,\-\.\/:;<=>\?\@\[\\\]\^_`{\|}~/;
			s/ +/ /g;
			my $name;
			my ($email,$desc) = split(/\t/,$_);
			if ($email =~ /<.+>/){
				($name,$email) = split(/\s*</,$email);
				$email =~ s/>//;
				$name =~ s/["']//g;
			}
			push(@tmp,"$type\t$email\t$desc\t$name\n");
		}
	close(FILE);
	sort(@tmp);
}
