#!C:/usr/perl/bin/perl.exe

### uK4 - セットアップ済みビッグファイル受領サイトの管理($bigfileroot2内)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
require "./config.cgi";
require "./mailbox_common.cgi";
use utf8;
$cgi = 'mailbox_bigfile2.cgi';
$cgi2 = 'mailbox_bigfile.cgi';
$confirm = "onClick=\"if(!confirm('このアップロードサイトを削除してもよろしいですか？')){return false;}\"";
$index = "$tempdir/$loginid/.my_bigfile2_site.txt";
$fileIcon = "<img src='$idir/file.gif' height=13 width=15 title='ファイル' border=0>";

## 初期表示
if (@ARGV){
	($field,$method,$page,$op1,$op2,$op3) = @ARGV;
	my $msg;
	
	# 登録済みサイトを削除する
	if ($op1 eq 'delete' && length($op2) == 32){
		rmtree(["$bigfileroot2/$op2"],0,0);
		unlink($index);
		$msg = "1個の登録済みサイトを削除しました。";
	}
	# 指定ファイルをダウンロード
	elsif ($op1 eq 'download' && length($op2) == 32 && length($op3) == 32){
		my %p = &getenv("$bigfileroot2/$op2/$op3.txt",'=','',1,$charset);
		$FileName = $p{FileName};
		Encode::_utf8_off($FileName);
		Encode::from_to($FileName,$charset,$charsetS);
		
		print "Content-Type: application/download\n";
		print "Content-Disposition: attachment; filename=\"$FileName\"\n\n";
		if (open(FILE,"<$bigfileroot2/$op2/$op3")){
				binmode FILE;
				binmode STDOUT;
				print while (<FILE>);
			close(FILE);
		}
		exit;
	}
	# 最新情報に更新
	elsif ($op1 eq 'refresh'){
		unlink($index);
		$msg = "最新情報を取得しました。";
	}
	
	&html($msg);
}
exit;

### ---------------------------------------------------------------
sub html {
	&expire() if $Expired;
	my ($error) = @_;
	$error = "$alert $fs5R$error$fe" if $error;
	my $arg = join('+',$field,$method,$page);
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	$K4 = <<"EOF";
<html><head>
$charcss
<title>ビッグファイルの管理</title>
</head>
<body $bodyp class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><img src='$idir/letter.gif' width=34 height=24 title='ビッグファイルを管理します'></td>
<td nowrap>&nbsp;$fs7G<b>ビッグファイルの管理</b>$fe$fs5G - ビッグファイル受領&nbsp;$fe</td><td width='100%'>$error</td>
<td nowrap><a href='$cgi2?0+0+0'>送付サイトの管理へ$arrowR</a>&nbsp;</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=4 height=1>$null</td></tr>
<tr><td height=4></td></tr>
<tr><td colspan=4 height=28 valign='top'>ビッグファイル受領機能を利用して準備したウェブサイトを管理します。
不要サイトは削除してください。 <a href='$cgi?$arg+refresh'>最新情報に更新$arrowR</a></td></tr>
</table>
EOF
	&print_utf($K4);
	
	# サイトの一覧を得る
	my ($count,@sites) = &get_bigfile2("$user1\@$domain1");
	
	# ソート(デフォルトは作成日)
	@sites = &sorting(1,0,0,@sites);
	
	# ページ分割
	###
	
	# 一覧を表示
	my ($count,$data,$fs3,$fs4,$fe4) = (0,'',"<font color='#800000'>","<font color='#006000'>","</font>");
	foreach my $site (@sites){
		chomp($site);
		$site =~ s/</&lt;/g;
		$site =~ s/>/&gt;/g;
		$site =~ s/"/&quot;/g;
		$site =~ s/\|+/<br>/g;
		## 0サイトID 1作成日 2XMailアカウント 3開始日 4終了日 5サイト名 6ファイル個数
		## 7認証フラグ 8有効秒数 9パスフレーズ 10大文字小文字 11サイズ制限 12認証リトライ回数
		## 13あて先名 14運営者名 15メッセージ 16送付先メールアドレス
		my @s = split(/\t/,$site);
		my ($end,$start);
		my ($auth,$bgc,$created,$end,$files,$from,$period,$start,$to);
		($start,$end) = @s[3,4];
		$start =~ s/(\d{4})(\d{2})(\d{2})/$1\/$2\/$3/;
		$end =~ s/(\d{4})(\d{2})(\d{2})/$1\/$2\/$3/;
		$period = "$start ～ $end" if ($start || $end);
		$auth = $s[7];
		if ($auth){
			$auth = "認証必要、パスフレーズ:$s[9]";
			$auth .= "(大小文字区別)" if $s[10];
			$auth .= "、認証リトライ$s[12]回" if $s[12];
			$auth .= "、$s[8]秒有効" if $s[8];
		} else {
			$auth = '認証不要';
		}
		($to,$from) = @s[13,14];
		if ($to){$to .= "&lt;$s[16]&gt;";} else {$to = $s[16];}
		if ($from){$from .= "&lt;$user1\@$domain1&gt;";} else {$from = "$user1\@$domain1";}
		$created = $s[1];
		$created =~ s/\s+/<br>/;
		$bgc = "bgcolor='white'";
		$bgc = $bgcolor3 if $count%2 == 1;
		
		# 受領ファイルがあれば得る
		my $root = "$bigfileroot2/$s[0]";
		foreach (glob("$root/????????????????????????????????")){
			if (!-f "$_.txt"){
				unlink($_);
				next;
			}
			my %p = &getenv("$_.txt",'=','',1);
			$files .= "<a href='$cgi?$arg+download+$s[0]+$p{FileID}'>$fileIcon$p{FileName}($p{Created})/$p{FileSize}(KB)</a><br>";
			$files .= "$p{Message}<br>" if $p{Message};
		}
		$files = "(なし)" if !$files;
		
		$data .= "<tr $bgc valign='top'><td>$created</td><td>$fs3$s[5]<br>$period$fe4</td><td>$fs4$auth$fe4</td>";
		$data .= "<td>$fs3$to<br>$from$fe4</td><td>$fs4$files$fe4</td>";
		$data .= "<td align='center' nowrap><a href='$cgi?$arg+delete+$s[0]' $confirm>&laquo;削除&raquo;</a><br>";
		$data .= "<a href='upload_login.cgi?$s[0]' target='_blank'>&laquo;URL&raquo;</a></td></tr>";
		$count++;
	}
	$data = "<tr><td align='center' colspan=7 height=60>受領サイトは未登録です。</td></tr>" if !$data;
	
	$K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=1 class='doc131' width='100%'>
<tr bgcolor='#ffe0e0'><td>作成日</td><td nowrap>サイト名/公開期間</td><td>認証等</td>
<td nowrap>通知先/通知元</td><td nowrap>受領ファイル情報</td>
<td align='center' nowrap></td></tr>
<tr><td height=4></td></tr>
$data
<tr><td bgcolor='#c0c0c0' colspan=7 height=1></td></tr>
</table>
EOF
	&print_utf($K4);
	&print_footer();
	exit;
}
