#!C:/usr/perl/bin/perl.exe

### uK4 - 振り分けの管理
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";
$tab = 'distribute.tab';		## 振り分け定義ファイル
@array = qw(Distribute stat rule header word method folder regexp);
$headers = <<"EOF";
	<option>Authentication-Results</option>
	<option>Cc</option>
	<option>Comments</option>
	<option>Content-Disposition</option>
	<option>Content-Transfer-Encoding</option>
	<option>Content-Type</option>
	<option>Date</option>
	<option>Delivery-Agent</option>
	<option>Disposition-Notification-To</option>
	<option>DomainKey-Signature</option>
	<option>Errors-To</option>
	<option>From</option>
	<option>In-Reply-To</option>
	<option>Keywords</option>
	<option>Lines</option>
	<option>Message-Id</option>
	<option>MIME-Version</option>
	<option>Organization</option>
	<option>Posted</option>
	<option>Precedence</option>
	<option>Received</option>
	<option>Received-SPF</option>
	<option>References</option>
	<option>Reply-To</option>
	<option>Return-Path</option>
	<option>Return-ReCeipt-To</option>
	<option>Sender</option>
	<option>Subject</option>
	<option>To</option>
	<option>User-Agent</option>
	<option>X-Account</option>
	<option>X-Antivirus</option>
	<option>X-Apparently-From</option>
	<option>X-Apparently-To</option>
	<option>X-Attach</option>
	<option>X-Dispatcher</option>
	<option>X-Html</option>
	<option>X-Keywords</option>
	<option>X-Mail-Agent</option>
	<option>X-Mail-Count</option>
	<option>X-Mailer</option>
	<option>X-MailerError</option>
	<option>X-MailerServer</option>
	<option>X-MessageId</option>
	<option>X-MimeOLE</option>
	<option>X-ML-Name</option>
	<option>X-MSMail-Priority</option>
	<option>X-Originating-IP</option>
	<option>X-Priority</option>
	<option>X-S25R-Check</option>
	<option>X-SmtpMessageID</option>
	<option>X-Spam-Checker-Version</option>
	<option>X-Spam-Flag</option>
	<option>X-Spam-Level</option>
	<option>X-Spam-Status</option>
	<option>X-Virus-Scanned</option>
EOF
%method = (
	1,'で始まる',
	2,'を含む',
	3,'である',
	4,'で終る',
	5,'で始まらない',
	6,'を含まない',
	7,'でない',
	8,'で終らない'
);

### 初期表示/ルール管理
if (@ARGV){
	my $msg;
	if ($key4 =~ /^del2|down|up/i && $k4fixed){&html("このアカウントでは実行できません！",1);}
	## 振り分けルールを削除
	elsif ($key4 eq 'del2'){
		my $file = $userdir . "/$xmailcfg/$tab";
		my ($count,$method,$folder) = ($key5,$key6,$key7);
		my ($chk,$count2);
		my @reg;
		if (open(FILE,$file)){
			while (<FILE>){
				$count2++;
				chomp;
				my @tmp = split(/\t/,$_);
				if ($count == $count2 && $method == $tmp[3] && $folder eq $tmp[4]){
					$chk = 1;
					next;
				}
				push(@reg,"$_\n");
			}
			close(FILE);
			
			if ($chk && open(FILE,">$file")){
					flock(FILE,2);
					print FILE @reg;
				close(FILE);
				$msg = "指定ルールを削除しました。";
			}
		}
	}
	
	## 振り分けルールの優先順位を上位/下位に
	elsif ($key4 eq 'down' || $key4 eq 'up'){
		my $file = $userdir . "/$xmailcfg/$tab";
		my ($count,$method,$folder) = ($key5,$key6,$key7);
		my ($chk,$count2);
		my @tmp1;
		my @tmp2;
		if (open(FILE,$file)){
			while (<FILE>){
				$count2++;
				chomp;
				my @tmp = split(/\t/,$_);
				if ($count == $count2 && $method == $tmp[3] && $folder eq $tmp[4]){
					$chk = "$_\n";
					next;
				}
				if (!$chk){push(@tmp1,"$_\n");}
				else {push(@tmp2,"$_\n");}
			}
			close(FILE);
			
			if ($key4 eq 'down'){
				my $line = shift(@tmp2);
				unshift(@tmp2,$chk);
				push(@tmp1,$line);
			} else {
				my $line = pop(@tmp1);
				push(@tmp1,$chk);
				unshift(@tmp2,$line);
			}
			if ($chk && open(FILE,">$file")){
					flock(FILE,2);
					if (@tmp1){print FILE @tmp1;}
					if (@tmp2){print FILE @tmp2;}
				close(FILE);
				$msg = "登録済みルールを移動しました。";
			}
		}
	}
	
	&html($msg);
}

### フォーム入力を処理
&parse_form(@array);
foreach(@array){
	$$_ =~ s/^\s+//;
	$$_ =~ s/\s+$//;
	$$_ =~ s/\s+/ /g;
}
&html("このアカウントでは作成/変更できません！",1) if $k4fixed;

## ステータス変更
if ($stat){
	my $file = "$userdir/$xmailcfg/config.tab";
	my @tmp;
	if (open(FILE,$file)){
			while (<FILE>){
				next if /^Distribute\s*=/;
				push(@tmp,$_);
			}
		close(FILE);
	}
	open(FILE,">$file");
		flock(FILE,2);
		print FILE @tmp;
		print FILE "Distribute = $Distribute\n";
	close(FILE);
	
	my $msg = '振り分けを実行します。';
	$msg = '振り分けを停止します。' if !$Distribute;
	&html($msg);
}

## ルール追加
&html("ルール名を指定してください！") if !$rule;
&html("対象ヘッダを選択してください！") if !$header;
&html("キーワードを指定してください！") if !$word;
&html("正規表現が正しくありません。") if ($regexp && &chk_regexp($word));
&html("評価方法を選択してください！") if !$method;
&html("振り分け先フォルダを選択してください！") if !$folder;
&zenhan('word') if $word =~ /[^$zstr]/;		# 半角変換
my $line = join("\t",$rule,$header,$word,$method,$folder,$regexp);
my ($line2) = &mod_str($line);
$line2 =~ s/\s+$//;

## 比較のために現在の設定を得る
if (open(FILE,"$userdir/$xmailcfg/$tab")){
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			s/^\s+//;
			s/\s+$//;
			s/ +/ /g;
			&html("同じ登録があります！",1) if /^$line2$/i;
		}
	close(FILE);
}

## 追加実行
Encode::_utf8_off($line);
Encode::from_to($line,$charset,$charsetE);
open(FILE,">>$userdir/$xmailcfg/$tab");
	flock(FILE,2);
	print FILE "$line\n";
close(FILE);

## 完了
&html("振り分けルールを追加しました。");

## -------------------------------------------
sub html {
	if ($Expired && !$_[1]){&expire($_[0]);}
	my $na = $nofilter if -f "$tempdir/$nf";
	
	&do_header("振り分け","$_[0]");
	
	my %perm = &getenv("$userdir/$xmailcfg/config.tab",'=');
	my $stat;
	if ($na){$stat = "(メンテナンスのため、振り分けシステムは停止中です)";}
	elsif ($perm{'Distribute'}){
		$stat = "<input type='hidden' name='Distribute' value='0'>";
		$stat .= "<input type='submit' name='stat' value='振り分けを停止する(現在は実行中)' $class>";
	} else {
		$stat = "<input type='hidden' name='Distribute' value='1'>";
		$stat .= "<input type='submit' name='stat' value='振り分けを実行する(現在は停止中)' $class>";
	}
	
	$K4 = <<"EOF";
$table0
<tr><td>受信メッセージの自動振り分けを行います。</td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr>
<form method=post action="$cgidistribute">
	<td $bgcolor3>
	<table cellpadding=10 cellspacing=0 class='doc131' border=0>
	<tr><td>$stat</td></tr>
	</table><td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
</table>
EOF
	
	&print_utf($K4);
	
	$K4 = &get_distribute_form();		## フォーム用データを得る
	$K4 .= &get_distribute_table();		## ルール表示用データを得る
	&print_utf($K4);
	
	## 注意書き
	$K4 = <<"EOF";
<span class='doc13'><ul>
<li>"振り分け" とは、メッセージがメールボックス(受信トレイ)に到着するとき、あらかじめ決めておいた規則(振り分けルール)に従って自動的に受信フォルダなどにそれを移動する機能です。振り分けず、直ちに削除することもできます。</li>
<li>複数の振り分けルールがある場合、上位に表示されているルールから順に評価が行われ、最初に一致したもので振り分けが実行されます。
どのルールにも一致しないメッセージはそのまま受信トレイに入ります。</li>
<li>キーワードは大文字と小文字が同一視されます。正規表現が [オフ] の場合、キーワードにはワイルドカード(*,?)が使用できます。
ワイルドカード文字自体を検索する場合はバックスラッシュ(&yen;)をその前につけてください。</li>
<li>振り分け先のフォルダは [フォルダ] メニューで作成できます。</li>
$fs2<li>振り分けられたメッセージは、受信トレイに戻さない限りメーラからは受信できません。</li>$fe
</ul></span>
</form>
EOF
	&print_utf($K4);
	&print_footer();
	exit;
}

## フォーム用データ
sub get_distribute_form {
	my $data = <<"EOF";
<table cellpadding=10 cellspacing=0 border=0 width='100%'>
<tr><td>
	<table cellpadding=1 cellspacing=0 class='doc131' border=0>
	<tr><td class='doc15'><img src='$idir/arrow_blue.gif' width=32 height=13 title='$title1'>&nbsp;
	<b>振り分けルールの追加</b></td></tr>
	<tr><td height=6></td></tr>
EOF
	
	my @folders = &get_stats('folder');
	my $select;
	foreach (@folders){
		my ($name,$desc) = split(/\t/,$_);
		if (!$desc){
			my $op = $1 if $name =~ /^i(\d+)/;
			$desc = $1;
		}
		$select .= "<option value='$name'>$desc</option>";
	}
	$select .= "<option value='__trashbox__'>ごみ箱</option>";
	$select .= "<option value='spam'>迷惑メール</option>";
	$select .= "<option value='__deleteall__'>*削除する*</option>";
	
	$headers =~ s/>$header</ selected$&/;
	my $methods;
	while (my($key,$name) = each %method){
		$methods .= "<option value='$key'>$name</option>";
	}
	$methods =~ s/value='$method'>/selected $&/;
	if ($regexp){$r2 = 'selected';} else {$r1 = 'selected';}
	$select =~ s/value='$folder'>/selected $&/;
	
	$data .= <<"EOF";
	<tr><td>ルール名: <input name='rule' value='$rule' size=30 maxlength=128 $nosubmit>
	(日本語で自由に)</td></tr>
	<tr><td>
		<table cellpadding=1 cellspacing=1 class='doc131' border=0>
		<tr><td height=4></td></tr>
		<tr $bgcolor0><td>対象ヘッダ</td><td>キーワード</td><td>正規表現</td>
		<td>評価方法</td><td>振り分け先</td></tr>
		<tr><td><select name='header'>
		<option value=''>▽選択</option>
		$headers
		</select></td>
		<td><input name='word' size=25 maxlength=128 value='$word' $nosubmit></td>
		<td><select name='regexp'>
		<option value='' $r1>オフ</option>
		<option value='1' $r2>オン</option>
		</select></td>
		<td><select name='method'>
		<option value=''>▽選択</option>
		$methods
		</select></td>
		<td><select name='folder'>
		<option value=''>▽選択</option>
		$select
		</select></td></tr>
		</table></td></tr>
	<tr><td><input type='submit' value='ルールを追加する' $class></td></tr>
EOF
	$data .= "</table></td></tr></table>";
	$data;
}

## ルール一覧データ
sub get_distribute_table {
	my @rules = &get_stats('distribute');
	foreach (&get_stats('folder')){
		my ($id,$name) = split(/\t/,$_);
		$folder{$id} = $name;
	}
	
	my $data = <<"EOF";
$table0
<tr><td $bgcolor0 height=1>$null</td></tr>
</table>
<table cellpadding=10 cellspacing=0 border=0 width='100%'>
<tr><td $bgcolor3>
	<table cellpadding=1 cellspacing=1 class='doc131' border=0>
	<tr><td class='doc15' colspan=7><img src='$idir/arrow_blue.gif' width=32 height=13 title='$title1'>
	&nbsp;<b>登録済みルール一覧</b></td></tr>
EOF

	if (@rules){
		$data .= "<tr $bgcolor0><td nowrap>順位&nbsp;</td><td nowrap>ルール名&nbsp;</td>";
		$data .= "<td nowrap>ヘッダ&nbsp;</td><td nowrap>キーワード&nbsp;</td>";
		$data .= "<td nowrap>正規表現&nbsp;</td><td nowrap>評価方法&nbsp;</td>";
		$data .= "<td nowrap>振り分け先&nbsp;</td><td nowrap>削除/移動</td></tr>";
		my $count1 = @folders;
		my $count2;
		my $count3 = @rules;
		foreach (@rules){
			$count2++;
			my ($rule,$header,$word,$method,$folder,$regexp) = split(/\t/,$_);
			$rule =~ s/</&lt;/g;
			$rule =~ s/>/&gt;/g;
			my $arg2 = "$count2+$method+$folder";
			my $down = "<a href='$cgi1?down+$arg2' title='このルールを下へ移動します'>▼</a>&nbsp;" if $count2 != $count1;
			my $up = "<a href='$cgi1?up+$arg2' title='このルールを上へ移動します'>▲</a>&nbsp;" if $count2 != 1;
			if ($count3 == 1){$down = $up = '';}
			if ($count2 == $count3){$down = '　 &nbsp;';}
			if ($folder =~ /^i/i){$folder = $folder{$folder};}
			elsif ($folder =~ /_+trashbox_+/i){$folder = 'ごみ箱';}
			elsif ($folder eq 'spam'){$folder = '迷惑メール';}
			elsif ($folder =~ /_+deleteall_+/i){$folder = '*削除*';}
			if ($regexp){$regexp = "$fs2 オン$fe";} else {$regexp = "オフ";}
			$data .= <<"EOF";
<tr bgcolor='white' valign='top'><td>$count2</td><td>$rule&nbsp;</td>
<td>$header&nbsp;</td><td>$word&nbsp;</td><td>$regexp</td><td>$method{$method}&nbsp;</td>
<td>$folder&nbsp;</td><td><a href='$cgi1?del2+$arg2' $confirm1>削除</a>&nbsp; $down $up</td><tr>
EOF
		}
	} else {
		$data .= "<tr><td height=20>振り分けルールは登録されていません。</td></tr>";
	}
	
	$data .= <<"EOF";
</table></td></tr>
</table>
$table0
<tr><td $bgcolor0 height=1>$null</td></tr>
</table>
EOF
	$data;
}

## 振り分けフォルダ(受信フォルダ)/振り分けルールを得る
sub get_stats {
	my ($option) = @_;
	my @tmp;
	open(MyFILE,"$userdir/$xmailcfg/$option.tab") || return();
		while(<MyFILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			next if (/^\s*$/ || !/\t/);
			next if ($option eq 'folder' && (/^#/ || /^[^i]/i));
			s/</&lt;/g;
			s/>/&gt;/g;
			s/"/&quot;/g;
			push(@tmp,$_);
		}
	close(MyFILE);
	
	if ($option eq 'folder'){@tmp = &sorting(1,0,0,@tmp);}
	@tmp;
}
