#!C:/usr/perl/bin/perl.exe

### uK4 - 署名の管理
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";
$colmax = 76;						# 最大カラム数
if (!$siglimit){$siglimit = 1;}		# 最大署名数
if (!$sigrowmax){$sigrowmax = 5;}	# 最大行数

## 初期表示
if (@ARGV){
	&chk_maildir();
	&html();
}

## フォーム入力を処理
$doc = new CGI_Lite;
$doc->set_platform (Windows);
%form = $doc->parse_form_data;
while (($name, $value) = each %form){
	&redirect if $k4envstr =~ /,$name,/;
	$value = &dec_utf($value,$charset);
	$value =~ s/\r*\n/\n/g;
	$value =~ s/^\n+//;
	$value =~ s/\s+$//;
	$$name = $value;
}
&html("このアカウントでは更新できません！",1) if $k4fixed;

# データを保存
for(1 .. $siglimit){
	my $sig = "sig"."$_";
	my $sig0 = "$sig"."t";
	my $file = "$userdir/$xmailcfg/$sig.tab";
	if ($$sig){
		@tmp = split(/\n/,"$$sig");
		@tmp = splice(@tmp,0,$sigrowmax);				# 行数を切り詰め
		foreach $i (@tmp){
			if (length($i) > $colmax){
				$i = substr("$i",0,$colmax);			# 行長を切り詰め
				$i =~ s/.$// if $i =~ /[^$zstr]/;		# 全角文字対策
			}
			$temp .= "$i\n";
		}
		$$sig = $temp;
	}
	&html("署名 $_ が不完全です。") if (($$sig0 eq '' && $$sig) || ($$sig0 && $$sig eq ''));
	if ($$sig0){
		$$sig0 = "[SignatureTitle] $$sig0\n";
		Encode::_utf8_off($$sig);
		Encode::_utf8_off($$sig0);
		Encode::from_to($$sig,$charset,$charsetM);
		Encode::from_to($$sig0,$charset,$charsetM);
		open(FILE,">$file");
			flock(FILE,2);
			print FILE "$$sig0$$sig";
		close(FILE);
	} else {
		unlink($file);
	}
	$$sig = $$sig0 = $temp = '';
}
&html("署名データを保存しました。");

## --------------------------------------------------
sub html {
	&expire($_[0]) if ($Expired && !$_[1]);
	&do_header("署名","$_[0]");
	
	$K4 = <<"EOF";
$table0
<tr><td>署名(シグネチャ、フッタ)の管理:&nbsp;(名前と本文を入力してください)</td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr><td $bgcolor3>
<form method='post' action='$cgisig'>
<input type='hidden' name='key4' value='$key4'>
<input type='hidden' name='key5' value='$key5'>
<table cellpadding=4 cellspacing=2 class='doc131' border=0>
EOF
	
	&print_utf($K4);
	$K4 = '';
	
	for(1 .. $siglimit){
		$sig = "sig"."$_"; $sig0 = "$sig"."t"; $count = 1; $$sig = '';
		if (open(FILE,"$userdir/$xmailcfg/$sig.tab")){
				while ($line = <FILE>){
					$line = &dec_utf($line,$charsetM);
					chomp($line);
					$line =~ s/\s+$//;
					&htmlconv('line');
					if ($count == 1 && $line =~ /^\[SignatureTitle\] *(.*)/){$$sig0 = $1; $count++; next;}
					$$sig .= "$line\n";
					$count++;
				}
			close(FILE);
			$$sig =~ s/^\n+//;
			$$sig =~ s/[ \n\t]+$/\n/;
		}
		$K4 .= "<tr><td>■ 署名 $_ <br><input name='$sig0' class='doc15' size=50 maxlength=$colmax value='$$sig0' $nosubmit><br>";
		$K4 .= "<textarea name='$sig' class='doc15' cols=$colmax rows=$sigrowmax>$$sig</textarea></td></tr>";
	}
	
	$K4 .= <<"EOF";
<tr><td><input type='submit' $class value='作成/更新する'></td></tr>
</table></td></tr>
<tr><td></from></td></tr>
<tr><td $bgcolor0 height=1>$null</td></tr>
<tr><td height=6></td></tr>
<tr><td class='doc13'>
<ul>
<li>署名の名前は、メッセージの新規作成などで署名の選択リストを表示するときにタイトルとして使われるので、
「会社用」、「個人用」などと署名本文の内容が分かるように工夫してください。</li>
<li>1 行は $colmax バイト以内で改行してください。それを超えるデータは強制的に切り詰められます。</li>
<li>行数は最大 $sigrowmax 行です。それ以上のデータは強制的に切り詰められます。</li>
<li>署名を削除するには入力フィールドを空にして保存してください。</li>
<li>メッセージへの署名の挿入にあたっては、本文と署名との間に空白行が 1行入ります。</li>
<li>半角カタカナは全角文字に変換されます。</li>
</ul></td></tr>
</table>
EOF
	
	$K4 .= "<div align='right'>$arrowU</div>" if $siglimit >= 3;
	
	&print_utf($K4,'',1);
	&print_footer();
	&exit();
}

sub chk_maildir {
	local($mail);
	foreach("$mailroot/domains/$domain1","/$user1","/$outbox"){
		$mail .= $_;
		if (!-e "$mail"){
			mkdir("$mail",0755);
			&error("e506",$ermsg1) if !-e "$mail";
		}
	}
}
