#!C:/usr/perl/bin/perl.exe

### uK4 - お知らせメールの指定
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use utf8;
$maxnotify = 3;		# 通知先アドレス登録最大数
require "./config.cgi";
$cgi = "notify.cgi";
&auth();

## 初期表示
if (@ARGV){
	&getenv("$userdir/$xmailcfg/config.tab",'=','1');
	&set_value();
	&html();
}

## フォーム入力を処理
&parse_form(qw(notifyfrom notifyto NotifyFrom NotifyTo OP op1 op2));
&html("このアカウントでは指定/更新できません！",1) if $k4fixed;
foreach(qw(notifyfrom notifyto)){
	&zenhan("$_") if $$_ =~ /[^$zstr]/;
	$$_ =~ s/^[\s,]+//;
	$$_ =~ s/[\s,]+$//;
	$$_ =~ s/\s//g;
}
if ($notifyfrom){
	@notify = split(/,/,$notifyfrom);
	@notify = splice(@notify,0,$maxnotify);
	foreach (@notify){
		&html("送信元アドレス $_<br>は不正です！",1) if !/^$emreg1$/;
		$tmp2 .= "$_,";
	}
	$tmp2 =~ s/,+$//;
	$notifyfrom = $tmp2;
}
if ($notifyto){
	&html("自分あての通知はできません！",1) if $notifyto =~ /^$user1\@$domain1$/i;
	&html("通知先アドレスが不正です！",1) if $notifyto !~ /^$emreg1$/;
}

&html("更新不要です。",1) if ($notifyfrom eq $NotifyFrom && $notifyto eq $NotifyTo && $OP eq "$op2");

($NotifyFrom,$NotifyTo) = ($notifyfrom,$notifyto);
$NotifyFrom .= ",*" if $op1;
$NotifyFrom .= ",_Header_Only_" if $OP;
&saveenv('k4',$domain1,$user1,'NotifyFrom','NotifyTo');
&set_value();
&html("更新を保存しました。",1);

## -----------------------------
sub html {
	my ($error) = @_;
	if ($error){$error = "$alert $fs5R$error$fe";}
	else {
		if ($notifyfrom || $notifyto){$error = "以下は現在の設定内容です。";}
		else {$error = '送信元と通知先のメールアドレスを指定してください。'}
	}
	if ($Expired && !$_[1]){&expire();}
	my $na = $nofilter if -f "$tempdir/$nf";
	my $opchk = 'checked' if $OP;
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "$cbody$nocache";
	
	my $title = 'お知らせメールの指定';
	my $title1 = '送信者アドレス';
	my $title2 = '通知先アドレス';
	my $K4 = <<"EOF";
<form method='post' action='$cgi' $nosubmit>
<input type='hidden' name='NotifyFrom' value="$NotifyFrom">
<input type='hidden' name='NotifyTo' value="$NotifyTo">
<input type='hidden' name='op1' value="$op1">
<input type='hidden' name='op2' value="$op2">
$table1
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=6 cellspacing=0 class='doc13' border=0 width=130>
		<tr><td $bgcolor1>指定アドレスからのメッセージ到着を他の指定アドレスに通知します。<br>
		<br></td></tr>
		</table>
	</table></td>
<td width=1></td><td>
	<table cellpadding=1 cellspacing=4 class='doc131' border=0>
	<tr valign='top'><td>
	<img src='$idir/notify.gif' width=33 height=36 title='$title' border=0></td>
	<td $bgcolor4 width=12>$null</td>
	<td>$fs7<b>$title</b>$fe$na
	$hr
	$error<br><br>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title1'> $title1:<br>
	<input name='notifyfrom' size=40 maxlength=150 value='$notifyfrom'><br>
	<br>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title2'> $title2:<br>
	<input name='notifyto' size=40 maxlength=50 value='$notifyto'><br>
	<input type='checkbox' name='OP' value='1' $opchk> ヘッダ情報(Subject,From,To,Date)のみ通知する。<br>
	<br>
	<input type='submit' value=' 指定/更新する '>
	$hr
	カンマで区切って $maxnotify 個まで送信者を指定できます。<br>
	双方のアドレスが指定された場合に通知が行われます。</td></tr>
	</table></td></tr>
</table>
</form>
EOF
	
	&print_utf($K4);
	&print_footer();
	&exit();
}

sub set_value {
	$op1 = $op2 = '';
	if ($NotifyFrom =~ s/\*//g){$op1 = 1;}					## * は全送信元オプション
	if ($NotifyFrom =~ s/_Header_Only_//i){$OP = $op2 = 1;}	## _Header_Only_ はヘッダのみ通知オプション
	$NotifyFrom =~ s/^[\s,]+//;
	$NotifyFrom =~ s/[\s,]+$//;
	$NotifyFrom =~ s/\s//;
	($notifyfrom,$notifyto) = ($NotifyFrom,$NotifyTo);
}
