#!c:/usr/perl/bin/perl.exe

### uK4 - 特定日の個人用の予定を入力・更新する
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use Time::Local;
use utf8;
require './config.cgi';
$cgi1 = 'schedule2.cgi';
$cgi2 = 'schedule1.cgi';		# 戻り先
&auth;
$root = "$mailroot/domains/$domain1/$user1/schedules";
@array = qw(cyear cmonth cday mySchedule);
mkdir($root,0755);

### 初期表示
if (@ARGV){
	($cyear,$cmonth,$cday) = @ARGV;
	$cday = sprintf("%02d",$cday);
	$cmonth = sprintf("%02d",$cmonth);
	
	## 現在の予定を得る
	if (open(FILE,"$root/$cyear-$cmonth.tab")){
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				next if !/^$cday\t(.*)/;
				$mySchedule = $1;
			}
		close(FILE);
		$mySchedule =~ s/\|\|/\n/g;
	}
	
	&html();
}

### フォーム処理
&parse_form(@array);
&html("このアカウントでは保存できません！") if $k4fixed;

## 保存・更新処理
my $data = $mySchedule;
$data =~ s/\n/\|\|/g;
$data =~ s/\|+$//;
my $file = "$root/$cyear-$cmonth.tab";
my ($check,@data);
if (open(FILE,$file)){		# 既存である
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp();
			if (/^$cday\t/){
				$_ = "$cday\t$data";
				$check = 1;
			}
			push(@data,"$_\n");
		}
	close(FILE);
} else {					# 新規作成
	for (1 .. 31){
		my $str = sprintf("%02d",$_);
		my $str2;
		$str2 = $data if $str eq "$cday";
		push(@data,"$str\t$str2\n");
		$check = 1;
	}
}

## 保存
open(FILE,">$file");
	flock(FILE,2);
	foreach (@data){
		Encode::_utf8_off($_);
		Encode::from_to($_,$charset,$charsetE);
		print FILE "$_\n";
	}
	if (!$check){
		my ($cday1,$data1) = ($cday,$data);
		Encode::_utf8_off($cday1);
		Encode::_utf8_off($data1);
		Encode::from_to($cday1,$charset,$charsetE);
		Encode::from_to($data1,$charset,$charsetE);
		print FILE "$cday1\t$data1\n";
	}
close(FILE);

## 終了
&html("$cyear/$cmonth/$cday の予定を保存しました。");

### ---------------------------------
sub html {
	my ($msg) = @_;
	$msg = "$alert $fs7R $msg $fe" if $msg;
	&htmlconv(qw(mySchedule));
	$confirm2 = "onClick=\"if(!confirm('$cyear/$cmonth/$cday の予定を保存してもよろしいですか？')){return false;}\"";
	
	print <<"EOF";
Content-Type: text/html; charset=$charset
CacheControl: no-cache
Pragma: no-cache
Expires: -1

<html><head>$charcss</head>
<body $bodyp class='doc131' topmargin=2 leftmargin=4 marginheight=2 marginwidth=4 $cbody0>

<form method='post' action='$cgi1'>
<input type='hidden' name='cyear' value='$cyear'>
<input type='hidden' name='cmonth' value='$cmonth'>
<input type='hidden' name='cday' value='$cday'>
EOF
	
	$K4 = <<"EOF";
<table cellpadding=0 cellspacing=0 border=0 width='100%'>
<tr><td height=8></td></tr>
<tr><td nowrap valign='bottom'><img src='$idir/arrow_blue.gif' width=32 height=13 title='$title0'> 
$fs7G<b>$cyear/$cmonth/$cday の予定を更新</b>&nbsp;$fe</td><td width='100%'>$msg</td></tr>
<tr><td bgcolor='#a0a0a0' colspan=2 height=1></td></tr>
<tr><td height=2></td></tr>
<tr><td></td><td align='right' class='doc131'><a href='$cgi2?$cyear+$cmonth'>予定表へもどる$arrowR</a></td></tr>
<tr><td colspan=2>
<table cellpadding=1 cellspacing=0 border=0 align='center'>
<tr><td align='right'><input type='submit' value=' この予定を保存する ' $confirm2></td></tr>
<tr><td><textarea name='mySchedule' cols=75 rows=15 wrap='soft'>$mySchedule</textarea></td></tr>
</table></td></tr>
</table>
</form>
EOF
	
	&print_utf($K4);
	&print_footer(1);
	exit;
}
