### uK4 - ビッグファイル受領共通 ###
exit if (!$allowmail || !$allowbigfile2);
use utf8;
$bigfilemax2 = 1 if $bigfilemax2 eq '';
$bigfileroot2 =~ s/\\/\//g;
$k4cookiestr2 = 'k4ckeywcmtupldst';		# Cookieキー名
$loginCGI = 'upload_login.cgi';
$tempdir = "../temp";
($authpage,$errorpage,$footerpage,$headerpage) = &x_original();
##
## ==========================================================================
## 認証 
sub auth2 {
	my @cookie = split(/;\s*/,$ENV{'HTTP_COOKIE'});
	@cookie = grep(/^$k4cookiestr2=/,@cookie);
	my $cookie = pop(@cookie);
	my ($cName,$cData) = split(/=/,$cookie);
	$cData =~ tr/gxoAdBjCqDEwFpGeHnIhJuKaLyMiNvOkPcQzRtSmTfUrVlWsXYZ0123456789b/abcdefg0123456789hijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/;
	($Id,$domain,$user,$sId,$etime) = split(/:/,$cData);
	$tempdir .= "/$sId";
	if (-f "$tempdir/.$Id"){
		$Expired = 1 if time() > $etime;	# if expired?
		%Big = &getenv("$bigfileroot2/$Id/profile.txt",'=','',1);
		&print_expired() if $Expired;
	} else {
		&print_blank();
	}
}

### サイト情報確認/リダイレクト
sub check_status {
	my ($Id) = @_;
	
	if (!$Id || length($Id) != 32 || !-d "$bigfileroot2/$Id"){
		&save_history($Id,'ban',1);
		&print_blank();
		exit;
	}
	
	my %b = &getenv("$bigfileroot2/$Id/profile.txt",'=','',1,$charset);
	
	## サイトの有効期間をチェック
	my $today = "$year$month$mday";
	&print_confirm(5) if ($b{Start} && $b{Start} > $today);
	&print_confirm(4) if ($b{End} && $b{End} < $today);
	return(%b) if ($b{BigfileID} && $b{Created} && $b{Owner});
	
	&save_history($id,'ban',1);
	&print_blank();
	exit;
}

### 空白ページを表示
sub print_blank {
	&print_header3('','','','Who is it?');
	&print_footer3();
	exit;
}

### システム標準ボディの左半分を表示
sub print_body_1 {
	my $K4 = <<"EOF";
<table align='center' border=0 cellpadding=10 cellspacing=0 class='doc15'>
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='top'><td><img src='$idir/foot_1.gif' border=0 height=154 width=160 title='Who?'></td>
<td>
EOF
	&print_utf($K4);
}

### システム標準ボディの右半分を表示
sub print_body_2 {
	print "</td></tr></table>";
}

### サイトの確認(不正アクセス等)
sub print_confirm {
	my ($error) = @_;
	my ($str1,$str2);
	
	if ($error >= 4){		# 時間切れ
		$str1 = "サイトは有効ではありません!!";
		$str2 = <<"EOF";
アクセス先のサイトは時間切れになっています。<br>
改めて初期アクセスを行ってください。<br>
EOF
	} elsif ($error == 3){	# 存在しない
		$str1 = "サイトが見つかりません!!";
		$str2 = <<"EOF";
アクセス先のサイトは見つかりません。<br>
入力ミスか、すでに削除された可能性があります。<br>
アクセス先を確認してください。<br>
EOF
	} elsif ($error == 2){	# 一時領域を作成できない
		$str1 = "サイトを準備できません!!";
		$str2 = <<"EOF";
アクセス先のサイトを準備できませんでした。<br>
送信元へ問い合わせてください。<br>
EOF
	} else {				# 不正アクセス
		$str1 = "アクセス先が正しくありません!!";
		$str2 = <<"EOF";
アクセス先のサイトは存在しません。<br>
正しいアドレスでサイトへアクセスしてください。<br>
EOF
	}
	
	&print_header3();
	&print_body_1();
	my $K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='$str1($error)'></td>
<td class='doc17' valign='bottom'>$fs2$str1$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=20></td></tr>
<tr><td colspan=2>$str2</td></tr>
</table>
EOF
	&print_utf($K4);
	&print_body_2();
	&print_footer3();
}

### 時間切れページを表示
sub print_expired {
	my $str1 = "サイトの有効時間が過ぎました。";
	
	&print_header3('','','',$Big{SiteName});
	&print_body_1();
	
	my $K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='$str1'></td>
<td class='doc17' valign='bottom'>$fs2$str1$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=20></td></tr>
<tr><td colspan=2>
サイトの安全を守るため、作業有効時間が設定されています。<br>
恐れ入りますが、一度このブラウザウインドウを閉じ、<br>
改めてサイトにアクセスしてください。<br>
詳細は $Big{Owner} までお問い合わせください。<br>
ご協力まことにありがとうございます。<br>
</td></tr>
</table>
EOF
	&print_utf($K4);
	&print_body_2();
	&print_footer3();
	exit;
}

### フッタを表示
sub print_footer3 {
	if ($footerpage){
		Encode::_utf8_off($footerpage);
		print $footerpage;
	} else {
		print "</body></html>";
	}
	exit;
}

### ヘッダを表示
sub print_header3 {
	my ($refresh,$url,$focus,$sitename) = @_;
	$focus = "onload=\"document.myform.$focus.focus()\"" if $focus;
	$sitename = "- $sitename" if $sitename;
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	
	if ($headerpage){
		Encode::_utf8_off($headerpage);
		print $headerpage;
		return();
	}
	
	## 標準ヘッダを表示
	$refresh = "<meta http-equiv='Refresh' content='$refresh;url=$url'>" if $refresh;
	my $K4 = <<"EOF";
<html><head>
$refresh
$charcss
<title>ファイルのアップロード $sitename</title>
</head>
<body $bodyp class='doc15' topmargin=20 leftmargin=20 marginheight=20 marginwidth=20 $focus>
EOF
	&print_utf($K4);
}

### ロギング
sub save_history {
	my ($site,$type,$stat,$file) = @_;
	# 0サイトID 1日時 2auth/ban/upload/login 3ステータス(成功0/失敗1) 4ファイル情報 5IP 6Referer
	open(FILE,">>$bigfileroot2/$site/history.txt") || return();
		flock(FILE,2);
		print FILE "$site\t$year/$month/$mday $hour:$min:$sec\t$type\t$stat\t$file\t";
		print FILE "$ENV{'REMOTE_ADDR'}\t$ENV{'HTTP_USER_AGENT'}\t\n";
	close(FILE);
}

### オリジナルHTMLがあれば得る
sub x_original {
	my ($auth,$count,$error,$footer,$header) = ('',0);
	
	## 認証用HTMLファイルが存在する場合(100バイト以上で有効)
	if (open(FILE,"$bigfileroot2/$bigfileauth")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$auth .= $_;
			}
		close(FILE);
		$auth = '' if (length($auth) < 100 || $auth !~ /=['"]pathphrase[ '"]/ || $auth !~ /<form /i);
	}
	## エラー用HTMLファイルがある場合(100バイト以上で有効)
	if (open(FILE,"$bigfileroot2/$bigfileerror")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$error .= $_;
			}
		close(FILE);
		$error = '' if length($error) < 100;
	}
	## フッタ用HTMLファイルが存在する場合(10バイト以上で有効)
	if (open(FILE,"$bigfileroot2/$bigfilefooter")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$footer .= $_;
			}
		close(FILE);
		$footer = '' if length($footer) < 10;
	}
	## ヘッダ用HTMLファイルが存在する場合(100バイト以上で有効)
	if (open(FILE,"$bigfileroot2/$bigfileheader")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$count++ if /<html /i;
				$count++ if /=['"]*euc[-_]*jp/i;
				$count++ if /<body /i;
				$header .= $_;
			}
		close(FILE);
		$header = '' if ($count < 3 && length($header) < 100);
	}
	
	($auth,$error,$footer,$header);
}

1;
