#!C:/usr/perl/bin/perl.exe

### uK4 - ビッグファイル受領 - ログイン
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use CGI_Lite;
use Digest::MD5 'md5_hex';
use utf8;
require './config.cgi';
require './upload_common.cgi';
$cgi1 = $loginCGI;
$cgi2 = 'upload.cgi';

### 初期アクセス -----------------------------
if (@ARGV){
	($Id) = $ARGV[0];
	%b = &check_status($Id);	# 有効チェック
	if ($b{Auth}){
		&html();				# 認証ページオープン
	} else {
		&loginOK('guest');		# ゲストでログイン
	}
}

### フォーム処理(認証) -------------------------
my $fm = new CGI_Lite;
my %f = $fm->parse_form_data();
while (($key,$val) = each %f){
	&redirect if $k4envstr =~ /,$key,/;
	$val = &dec_utf($val);
	$val =~ s/^\s+//;
	$val =~ s/\s+$//;
	$val =~ s/(　)+/ /g;
	$val =~ s/\s+/ /g;
	$$key = $val;
}

%b = &check_status($Id);

if ($myphrase eq ''){
	&save_history($Id,'auth',1);
	&html("パスフレーズを入力してください.");
}
my $phrase = $b{PassPhrase};
$phrase =~ s/(　)+/ /g;
$phrase =~ s/\s+/ /g;
my $phrase2 = $myphrase;

## パスフレーズ比較
if ($b{Sensitive}){
	($phrase2) = &mod_str($phrase2);
	if ($phrase !~ /^$phrase2$/){
		&save_history($Id,'auth',1);
		&html("パスフレーズを確認してください.") ;
	}
} else {
	my ($p1,$p2) = (uc($phrase),uc($phrase2));
	if ($p1 ne $p2){
		&save_history($Id,'auth',1);
		&html("パスフレーズを確認してください.");
	}
}

## ログインOK
&loginOK($Id);

### 認証ページを表示 -------------------------------------------------
sub html {
	my ($error) = @_;
	$error = 'このサイトのご利用は認証が必要です...' if $error eq '';
	$ct++;
	
	&print_header3('','','myphrase',$b{SiteName});
	
	## リトライチェック
	if ($b2{Retry} && $ct > $b2{Retry}){
		$error = '再アクセスしてください...';
		&print_body_1();
		my $K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='$error'></td>
<td class='doc17' valign='bottom'>$fs2$error$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=10></td></tr>
<tr><td colspan=2><p>パスフレーズの入力には回数制限があります。<br>
失敗回数が制限を超えてしまいました。<br>
ログインのためにはサイトに改めてアクセスする必要があります。</p>
</td></tr>
</talble>
EOF
		&print_utf($K4);
		
		# ロギング
		&save_history($Id,'auth',1);
		
		&print_body_2();
		&print_footer3();
	}
	## リトライOKの場合
	if ($authpage){print $authpage;}
	else {
		&htmlconv('myphrase');
		my $str = "<br>(パスフレーズは大文字と小文字とが区別されます)" if $b{Sensitive};
		&print_body_1();
		my $K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='URLを確認してください($error)'></td>
<td class='doc17' valign='bottom'>$fs2$error$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=10></td></tr>
<tr><td colspan=2><p>このサイトへのアクセスはパスフレーズの入力が必要です。<br>
パスフレーズを入力してサイトにログインしてください。
$str</p>
<form action='$cgi1' name='myform' method='post'>
<input type='hidden' name='ct' value='$ct'>
<input type='hidden' name='Id' value='$Id'>
<p><input name='myphrase' size=40 maxlength=128 value="$myphrase">
<input type='submit' name='auth' value='ログイン'></p>
</form></td></tr>
</table>
EOF
		&print_utf($K4);
		&print_body_2();
	}
	
	&print_footer3;
}

## ログイン
sub loginOK {
	my ($owner) = @_;
	my ($user,$domain) = split(/\@/,$owner);
	$domain = '-' if !$domain;
	
	my $str = $Id . time() .$ENV{'REMOTE_ADDR'}.$ENV{'HTTP_REFERER'};
	my $sId = md5_hex $str;
	mkdir("$tempdir/$sId",0755);
	&print_confirm(2) if !-d "$tempdir/$sId";
	open(FILE,">$tempdir/$sId/.$Id") && close(FILE);
	foreach my $file ('index.htm','index.html','default.htm'){
		open(FILE,">$tempdir/$sId/$file") && close(FILE);
	}
	
	## ログイン有効時間
	my $ttl = $b{ExpireTime};
	$ttl = 86400 if !$ttl;
	my $expire = time() + $ttl;
	
	## ログイン履歴
	&save_history($Id,'login',0);
	
	## COOKIEデータ作成
	my $cookie = "$Id:$domain:$user:$sId:$expire:x:y";
	$cookie =~ tr/abcdefg0123456789hijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/gxoAdBjCqDEwFpGeHnIhJuKaLyMiNvOkPcQzRtSmTfUrVlWsXYZ0123456789b/;
	
	## アップロードページをオープン
	print <<"EOF";
Content-type: text/html; charset=$charset
Set-Cookie: $k4cookiestr2=$cookie
CacheControl: no-cache
Pragma: no-cache
Expires: -1

<html>
<head>
<meta http-equiv="Refresh" content="0;url=upload.cgi?top">
</head>
</html>
EOF
	exit;
}
